SystemOrganization addCategory: #'Seaside-Core'!
SystemOrganization addCategory: #'Seaside-Core-Configuration'!
SystemOrganization addCategory: #'Seaside-Core-Contexts'!
SystemOrganization addCategory: #'Seaside-Core-Document'!
SystemOrganization addCategory: #'Seaside-Core-Document-Elements'!
SystemOrganization addCategory: #'Seaside-Core-HTTP'!
SystemOrganization addCategory: #'Seaside-Core-Libraries'!
SystemOrganization addCategory: #'Seaside-Core-Callbacks'!
SystemOrganization addCategory: #'Seaside-Core-RequestHandler'!
SystemOrganization addCategory: #'Seaside-Core-Cache'!
SystemOrganization addCategory: #'Seaside-Core-Filter'!
SystemOrganization addCategory: #'Seaside-Core-Exceptions'!
SystemOrganization addCategory: #'Seaside-Core-Utilities'!

!MessageSend methodsFor: '*Seaside-Core' stamp: 'pmm 4/23/2007 20:02'!
fixCallbackTemps
	"for polymorphism with BlockContext >> #fixCallbackTemps"! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
valueWithPossibleArgument: anArg

     "Evaluate the block represented by the receiver.
     If the block requires one argument, use anArg, if it requires more than one,
     fill up the rest with nils."

	self numArgs = 0
		ifTrue: [^self value].
	self numArgs = 1
		ifTrue: [^self value: anArg].
	self numArgs  > 1 ifTrue: [
		^self valueWithArguments: (Array with: anArg), (Array new: self numArgs  - 1)]! !

Notification subclass: #WADeprecatedApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WADeprecatedApi commentStamp: 'pmm 4/17/2007 00:16' prior: 0!
WADeprecatedApi is a notification that gets signaled if someone used a deprecated Seaside method.

see #deprecatedApi!

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WADynamicVariable commentStamp: 'pmm 4/17/2007 00:14' prior: 0!
A WADynamicVariable is a variable that is visible only in the stackframes outgoing from this one.

Example:

WADynamicVariable
	use: 'Seaside'
	during: [ self compilcatedCalculation ]
	
Whenever
WADynamicVariable value
gets evaluated somewhere inside [ self compilcatedCalculation ] or a method invoked directly or indirectly by it, its value will be 'Seaside'. If no #use:during: handler is around the current stack frame, then the value will be the return value of #defaultValue.

Do not use WADynamicVariable directly, instead create a subclass for each variable you want to use.!

!WADynamicVariable class methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'lr 4/18/2007 00:25'!
use: anObject during: aBlock
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'avi 4/27/2004 14:25'!
value
	^ self raiseSignal! !

!WADynamicVariable methodsFor: 'defaults' stamp: 'lr 3/29/2008 19:01'!
defaultAction
	^ self class defaultValue! !

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

Notification subclass: #WAReturnResponse
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAReturnResponse methodsFor: 'accessing' stamp: 'lr 2/27/2008 15:23'!
response
	^ response! !

!WAReturnResponse methodsFor: 'accessing' stamp: 'lr 2/27/2008 15:23'!
response: anObject
	response := anObject! !

WAObject subclass: #WAAttributeContext
	instanceVariableNames: 'key target attribute cachedValues ancestorsWithAttribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeContext class methodsFor: 'instance creation' stamp: 'jf 8/4/2008 14:33'!
key: keySymbol target: targetConfiguration
	^ self basicNew initializeWithKey: keySymbol target: targetConfiguration! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 14:49'!
at: aConfiguration ifPresent: aBlock
	^ self cache at: aConfiguration ifPresent: aBlock! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 14:49'!
at: aConfiguration put: cachedObject
	^ self cache at: aConfiguration put: cachedObject! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 14:38'!
attribute
	^ attribute! !

!WAAttributeContext methodsFor: 'private' stamp: 'jf 8/4/2008 14:49'!
cache
	^ cachedValues! !

!WAAttributeContext methodsFor: 'as yet unclassified' stamp: 'jf 8/4/2008 18:11'!
filterAncestors
	| stack |
	stack := OrderedCollection with: self target.! !

!WAAttributeContext methodsFor: 'private' stamp: 'jf 8/4/2008 18:37'!
findAttributeAndSelectAncestorsOf: aConfiguration
	| found |
	(ancestorsWithAttribute includes: aConfiguration) ifTrue: [ ^ true ].
			
	aConfiguration canDefineAttributes ifTrue: [
		aConfiguration localAttributeAt: self key ifPresent:
			[ :attr |
			attribute := attr.
			ancestorsWithAttribute add: aConfiguration.
			^ true ] ].
		
	found := false.
	aConfiguration parents do: [ :each | found := found | (self findAttributeAndSelectAncestorsOf: each) ].
	
	found ifTrue: [ ancestorsWithAttribute add: aConfiguration ].
	
	^ found! !

!WAAttributeContext methodsFor: 'initialization' stamp: 'jf 8/4/2008 18:39'!
initializeWithKey: keySymbol target: targetConfiguration
	key := keySymbol.
	target := targetConfiguration.
	ancestorsWithAttribute := IdentitySet new.
	cachedValues := IdentityDictionary new.
	
	self findAttributeAndSelectAncestorsOf: target.
	! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 15:25'!
isAttributeInheritedBy: aConfiguration
	^ ancestorsWithAttribute includes: aConfiguration! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 18:29'!
key
	^ key! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 18:12'!
target
	^ target! !

WAObject subclass: #WACache
	instanceVariableNames: 'keysByObject objectsByKey mutex expiryPolicy reapingStrategy missStrategy reapAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACache commentStamp: 'jf 9/22/2008 17:41' prior: 0!
A WACache represents a collection of arbitrary objects referenced by a key (an instance of WAExternalID).

Methods are provided to add and retrieve and remove objects from the cache. The behaviour of the cache is configurable through four different plugins:

+ expiry policy: determines when objects are considered expired
+ cache miss strategy: determines what do to if a requested object is not found in the cache
+ cache reap action: determines what to do when an expired object is eventually reaped from the cache
+ cache reaping strategy: determines when expired objects should be reaped from the cache

Access to the two dictionaries which store the objects and keys is protected by a mutex. Calls to the plugins are currently not protected by the mutex, but possibly should be to simplify implementation of the plugins.!

!WACache methodsFor: 'public' stamp: 'jf 9/18/2008 22:10'!
at: aStringOrExternalID
	^ self retrieve: aStringOrExternalID! !

!WACache methodsFor: 'public' stamp: 'jf 9/18/2008 22:18'!
at: aStringOrExternalID ifAbsent: aBlock
	| object |
	object := self at: aStringOrExternalID.
	
	^ object ifNil: aBlock! !

!WACache methodsFor: 'public' stamp: 'jf 9/22/2008 17:31'!
clear
	| objects |
	self mutex critical: [
		objects := objectsByKey.
		objectsByKey := SeasidePlatformSupport reducedConflictDictionary new.
		keysByObject := SeasidePlatformSupport reducedConflictDictionary new ].
	
	objects isNil ifFalse: [
		[ objects keysAndValuesDo: [ :key :object | self reap: object key: key ] ] fork ]! !

!WACache methodsFor: 'initialization' stamp: 'jf 9/22/2008 17:01'!
initialize
	super initialize.
	expiryPolicy := WALastAccessExpiryPolicy cache: self.
	reapingStrategy := WARetrievalIntervalReapingStrategy cache: self.
	missStrategy := WACacheMissStrategy cache: self.
	reapAction := WANotifyReapAction cache: self.
	self clear! !

!WACache methodsFor: 'public' stamp: 'jf 9/18/2008 20:37'!
keyFor: anObject
	| key |
	self mutex critical: [
		key := keysByObject at: anObject ifAbsent: [ nil ] ].

	^ key! !

!WACache methodsFor: 'configuration' stamp: 'jf 9/18/2008 15:34'!
keySize
	^ 16! !

!WACache methodsFor: 'private' stamp: 'jf 9/18/2008 15:29'!
mutex
	^ mutex ifNil: [ mutex := SeasidePlatformSupport semaphoreClass forMutualExclusion ]! !

!WACache methodsFor: 'private' stamp: 'jf 9/18/2008 21:58'!
newKey
	| key |
	[ objectsByKey includesKey: (key := WAExternalID new: self keySize) ] whileTrue.
	^ key! !

!WACache methodsFor: 'private' stamp: 'jf 9/22/2008 17:02'!
notifyReaped: anObject key: anExternalID
	self pluginsDo: [ :each | each reaped: anObject key: anExternalID ]! !

!WACache methodsFor: 'private' stamp: 'jf 9/22/2008 16:29'!
notifyRetrieving: anObject key: anExternalID
	self pluginsDo: [ :each | each retrieving: anObject key: anExternalID ]! !

!WACache methodsFor: 'private' stamp: 'jf 9/22/2008 16:29'!
notifyStoring: anObject key: anExternalID
	self pluginsDo: [ :each | each storing: anObject key: anExternalID ]! !

!WACache methodsFor: 'private' stamp: 'jf 9/22/2008 17:00'!
pluginsDo: aBlock
	aBlock value: expiryPolicy.
	aBlock value: reapingStrategy.
	aBlock value: missStrategy.
	aBlock value: reapAction.! !

!WACache methodsFor: 'public' stamp: 'jf 9/23/2008 17:00'!
reap
	| expired newObjectsByKey newKeysByObject |
	expired := OrderedCollection new.
	newObjectsByKey := SeasidePlatformSupport reducedConflictDictionary new.
	newKeysByObject := SeasidePlatformSupport reducedConflictDictionary new.
	self mutex critical: [
		objectsByKey keysAndValuesDo: [ :key :object |
			(expiryPolicy isExpired: object key: key)
				ifTrue: [ expired add: (key -> object) ]
				ifFalse: [
					newObjectsByKey at: key put: object.
					newKeysByObject at: object put: key ] ].
		objectsByKey := newObjectsByKey.
		keysByObject := newKeysByObject ].
	
	[ expired do: [ :each | self reap: each value key: each key ] ] fork! !

!WACache methodsFor: 'private' stamp: 'jf 9/22/2008 17:12'!
reap: anObject key: anExternalID
	reapAction reap: anObject key: anExternalID.
	self notifyReaped: anObject key: anExternalID! !

!WACache methodsFor: 'public' stamp: 'jf 9/22/2008 17:11'!
removeKey: aStringOrExternalID
	| key object |
	key := aStringOrExternalID seasideExternalID.
	self mutex critical: [
		object := objectsByKey removeKey: key ifAbsent: [ nil ].
		keysByObject removeKey: object ifAbsent: [ nil ] ].
	
	object isNil ifFalse: [ self reap: object key: key ].
	
	^ object! !

!WACache methodsFor: 'public' stamp: 'jf 9/22/2008 17:35'!
retrieve: aStringOrExternalID
	| key object |
	key := aStringOrExternalID seasideExternalID.
	self mutex critical: [
		object := objectsByKey at: key ifAbsent: [ missStrategy missed: key ] ].
	
	object isNil ifFalse: [
		(expiryPolicy isExpired: object key: key) ifTrue: [ ^ nil ].
		self notifyRetrieving: object key: key ].
	
	^ object! !

!WACache methodsFor: 'initialization' stamp: 'jf 9/18/2008 22:19'!
setExpiryPolicy: anExpiryPolicyClass
	expiryPolicy := anExpiryPolicyClass cache: self! !

!WACache methodsFor: 'public' stamp: 'jf 9/22/2008 17:32'!
store: anObject
	| key |
	key := self newKey.
	self mutex critical: [
		objectsByKey at: key put: anObject.
		keysByObject at: anObject put: key ].
	
	self notifyStoring: anObject key: key.
	
	^ key! !

WAObject subclass: #WACachePlugin
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

WACachePlugin subclass: #WACacheExpiryPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheExpiryPolicy commentStamp: 'jf 9/22/2008 17:36' prior: 0!
A cache expiry policy determines when an item in the cache is considered expired. Expired items are periodically reaped an a schedule determined by the reaping strategy in place.

Subclasses should implement any of the notification methods that are interesting to them and should implement #isExpired:key: and return true or false as appropriate for any given object.!

!WACacheExpiryPolicy methodsFor: 'protocol' stamp: 'jf 9/22/2008 17:18'!
isExpired: anObject key: anExternalID
	^ false! !

WACacheExpiryPolicy subclass: #WALastAccessExpiryPolicy
	instanceVariableNames: 'lastAccessTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WALastAccessExpiryPolicy methodsFor: 'initialization' stamp: 'jf 9/18/2008 21:37'!
initializeWithCache: aCache
	super initializeWithCache: aCache.
	lastAccessTable := SeasidePlatformSupport reducedConflictDictionary new! !

!WALastAccessExpiryPolicy methodsFor: 'protocol' stamp: 'jf 9/22/2008 17:18'!
isExpired: anObject key: anExternalID
	| lastAccess |
	lastAccess := lastAccessTable at: anExternalID ifAbsent: [ Time totalSeconds ].
	^ (Time totalSeconds - lastAccess) > self timeout! !

!WALastAccessExpiryPolicy methodsFor: 'notifications' stamp: 'jf 9/22/2008 17:05'!
reaped: anObject key: anExternalID
	lastAccessTable removeKey: anExternalID ifAbsent: []! !

!WALastAccessExpiryPolicy methodsFor: 'notifications' stamp: 'jf 9/22/2008 16:32'!
retrieving: anObject key: anExternalID
	lastAccessTable at: anExternalID put: Time totalSeconds! !

!WALastAccessExpiryPolicy methodsFor: 'notifications' stamp: 'jf 9/22/2008 16:32'!
storing: anObject key: anExternalID
	lastAccessTable at: anExternalID put: Time totalSeconds! !

!WALastAccessExpiryPolicy methodsFor: 'configuration' stamp: 'jf 9/18/2008 15:54'!
timeout
	^ 600! !

WACacheExpiryPolicy subclass: #WALeastRecentlyUsedExpiryPolicy
	instanceVariableNames: 'ageTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'initialization' stamp: 'jf 9/18/2008 22:04'!
initializeWithCache: aCache
	super initializeWithCache: aCache.
	ageTable := SeasidePlatformSupport reducedConflictDictionary new! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'protocol' stamp: 'jf 9/22/2008 17:18'!
isExpired: anObject key: anExternalID
	^ (ageTable at: anExternalID) > self maximumAge! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'configuration' stamp: 'jf 9/18/2008 22:14'!
maximumAge
	^ 20! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'notifications' stamp: 'jf 9/22/2008 17:05'!
reaped: anObject key: anExternalID
	ageTable removeKey: anExternalID ifAbsent: []! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'notifications' stamp: 'jf 9/22/2008 16:32'!
retrieving: anObject key: anExternalID
	ageTable at: anExternalID put: 0! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'notifications' stamp: 'jf 9/22/2008 16:32'!
storing: anObject key: anExternalID
	ageTable associationsDo: [ :assoc | assoc value: assoc value + 1 ].
	ageTable at: anExternalID put: 0.! !

WACachePlugin subclass: #WACacheMissStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheMissStrategy commentStamp: 'jf 9/22/2008 16:45' prior: 0!
A cache miss strategy determines what should be done when an attempt is made to retrieve an object with a key that is not found in the cache.

Subclasses should implement #missed: and should either return nil or if the object can be found outside the cache somewhere, the object.!

!WACacheMissStrategy methodsFor: 'protocol' stamp: 'jf 9/18/2008 21:22'!
missed: anExternalID
	^ nil! !

!WACachePlugin class methodsFor: 'as yet unclassified' stamp: 'jf 9/18/2008 21:25'!
cache: aCache
	^ self basicNew initializeWithCache: aCache; yourself! !

!WACachePlugin methodsFor: 'initialization' stamp: 'jf 9/18/2008 21:25'!
initializeWithCache: aCache
	cache := aCache! !

!WACachePlugin methodsFor: 'notifications' stamp: 'jf 9/22/2008 17:05'!
reaped: anObject key: anExternalID
! !

!WACachePlugin methodsFor: 'notifications' stamp: 'jf 9/22/2008 16:29'!
retrieving: anObject key: anExternalID! !

!WACachePlugin methodsFor: 'notifications' stamp: 'jf 9/22/2008 16:29'!
storing: anObject key: anExternalID
! !

WACachePlugin subclass: #WACacheReapAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheReapAction commentStamp: 'jf 9/22/2008 17:15' prior: 0!
A cache reap action determines what, if anything, should happen when an object is reaped from the cache.

Subclasses should implement #reap:key:. When this method is called, the object will already have been removed from the cache itself but the subclass should perform any any additional actions that need to be taken.!

!WACacheReapAction methodsFor: 'protocol' stamp: 'jf 9/22/2008 17:06'!
reap: anObject key: anExternalID! !

WACacheReapAction subclass: #WANotifyReapAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WANotifyReapAction methodsFor: 'protocol' stamp: 'jf 9/22/2008 17:05'!
reap: anObject key: anExternalID
	(anObject respondsTo: #unregistered) ifTrue: [ anObject unregistered ]
	! !

WACachePlugin subclass: #WACacheReapingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheReapingStrategy commentStamp: 'jf 9/22/2008 16:43' prior: 0!
A cache reaping strategy determines when expired items should be removed from a cache.

Subclasses should implement any of the event notification methods they require and should call "self reap" whenever they determine that expired items should be removed from the cache.!

!WACacheReapingStrategy methodsFor: 'private' stamp: 'jf 9/18/2008 21:17'!
reap
	cache reap! !

WACacheReapingStrategy subclass: #WARetrievalIntervalReapingStrategy
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WARetrievalIntervalReapingStrategy methodsFor: 'initialization' stamp: 'jf 9/18/2008 19:18'!
initializeWithCache: aCache
	super initializeWithCache: aCache.
	count := 0! !

!WARetrievalIntervalReapingStrategy methodsFor: 'configuration' stamp: 'jf 9/18/2008 16:08'!
interval
	^ 10! !

!WARetrievalIntervalReapingStrategy methodsFor: 'private' stamp: 'jf 9/18/2008 21:17'!
reap
	count := 0.
	super reap! !

!WARetrievalIntervalReapingStrategy methodsFor: 'notifications' stamp: 'jf 9/22/2008 16:32'!
retrieving: anObject key: anExternalId
	count := count + 1.
	(count >= self interval) ifTrue: [ self reap ]! !

WAObject subclass: #WACallback
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAActionCallback methodsFor: 'accessing' stamp: 'jf 7/14/2008 02:11'!
block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock fixCallbackTemps! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'jf 7/14/2008 02:22'!
evaluateWithArgument: anObject
	block valueWithPossibleArgument: anObject.
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'testing' stamp: 'lr 4/9/2008 10:45'!
isEnabled
	^ self requestContext request isXmlHttpRequest not! !

!WAActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 8! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'lr 10/28/2007 14:42'!
signalRenderNotification
	WARenderNotification raiseSignal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACancelActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 3! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADefaultActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 10! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAImageCallback methodsFor: 'converting' stamp: 'lr 9/14/2008 10:06'!
convertKey: aString
	^ aString , '.x'! !

!WACallback methodsFor: 'comparing' stamp: 'lr 9/14/2008 10:07'!
<= other
	^ self priority < other priority or: [ self priority = other priority and: [ self key asNumber <= other key asNumber ] ]! !

!WACallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString! !

!WACallback methodsFor: 'evaluation' stamp: 'avi 6/7/2004 21:49'!
evaluateWithArgument: anObject
	self subclassResponsibility! !

!WACallback methodsFor: 'evaluation' stamp: 'lr 8/8/2007 17:55'!
evaluateWithField: anObject
	self isEnabled ifFalse: [ ^ self ].
	self evaluateWithArgument: (self valueForField: anObject)! !

!WACallback methodsFor: 'testing' stamp: 'lr 8/8/2007 17:56'!
isEnabled
	^ true! !

!WACallback methodsFor: 'accessing' stamp: 'lr 9/14/2008 10:06'!
key
	"Answer the callback key."

	^ self convertKey: key! !

!WACallback methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
priority
	self subclassResponsibility! !

!WACallback methodsFor: 'initialization' stamp: 'lr 9/14/2008 10:37'!
setContext: aRenderingContext key: aString 
	key := aString! !

!WACallback methodsFor: 'converting' stamp: 'lr 9/14/2008 10:10'!
valueForField: anObject
	^ anObject isNil
		ifTrue: [ String new ]
		ifFalse: [
			anObject isString
				ifTrue: [ anObject ]
				ifFalse: [
					anObject isEmpty
						ifTrue: [ String new ]
						ifFalse: [ anObject first ] ] ]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: 'renderContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADispatchCallback methodsFor: 'evaluation' stamp: 'lr 3/29/2008 22:47'!
evaluateWithArgument: anObject 
	| callback |
	callback := renderContext callbackAt: anObject.
	callback isNil ifFalse: [ callback evaluateWithArgument: nil ]! !

!WADispatchCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:42'!
priority
	^ 5! !

!WADispatchCallback methodsFor: 'initialization' stamp: 'lr 9/14/2008 10:38'!
setContext: aRenderingContext key: aString
	super setContext: aRenderingContext key: aString.
	renderContext := aRenderingContext! !

WADispatchCallback subclass: #WAMultiDispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAMultiDispatchCallback methodsFor: 'evaluation' stamp: 'lr 10/28/2007 14:42'!
evaluateWithField: anObject
	(anObject isCollection and: [ anObject isString not ])
		ifFalse: [ ^ super evaluateWithField: anObject ].
	anObject do: [ :each |
		self evaluateWithArgument: (self valueForField: each) ]! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:29'!
block: aOneArgBlock
	block := aOneArgBlock fixCallbackTemps! !

!WAValueCallback methodsFor: 'evaluation' stamp: 'pmm 2/27/2007 06:30'!
evaluateWithArgument: anObject
	block valueWithPossibleArgument: anObject! !

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:41'!
priority
	^ 5! !

WAObject subclass: #WACallbackRegistry
	instanceVariableNames: 'context owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACallbackRegistry class methodsFor: 'instance-creation' stamp: 'lr 1/11/2008 19:06'!
context: aContext
	^ self context: aContext owner: nil! !

!WACallbackRegistry class methodsFor: 'instance-creation' stamp: 'avi 6/7/2004 22:04'!
context: aContext owner: anObject
	^ self basicNew initializeWithContext: aContext owner: anObject! !

!WACallbackRegistry methodsFor: 'initialization' stamp: 'avi 6/7/2004 22:04'!
initializeWithContext: aContext owner: anObject
	context := aContext.
	owner := anObject! !

!WACallbackRegistry methodsFor: 'accessing' stamp: 'lr 5/1/2007 08:20'!
owner
	^ owner! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerCancelActionCallback: aBlock
	^ self storeCallback: (WACancelActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerDefaultActionCallback: aBlock
	^ self storeCallback: (WADefaultActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 9/2/2004 14:42'!
registerImageCallback: aBlock
	^ self storeCallback: (WAImageCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'lr 10/10/2005 20:00'!
registerMultiDispatchCallback
	^ self storeCallback: WAMultiDispatchCallback new! !

!WACallbackRegistry methodsFor: 'callbacks' stamp: 'lr 9/14/2008 10:05'!
storeCallback: aCallback
	| key |
	key := context storeCallback: aCallback.
	aCallback setContext: context key: key.
	^ key! !

WAObject subclass: #WAClosingConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Closes a WAConditionalComment.!

!WAClosingConditionalComment methodsFor: 'printing' stamp: 'lr 3/27/2007 11:37'!
encodeOn: aDocument
	aDocument nextPutAll: '<!![endif]-->'! !

WAObject subclass: #WAClosingRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingRevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Closes a WARevealedConditionalComment.!

!WAClosingRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:55'!
encodeOn: aDocument
	aDocument nextPutAll: '<!!--<!![endif]-->'! !

WAObject subclass: #WAConditionalComment
	instanceVariableNames: 'condition root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAConditionalComment commentStamp: 'pmm 1/28/2008 07:06' prior: 0!
A WAConditionalComment is an implementation of Downlevel-hidden Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
These are only visible for the IE family of browsers.

See also WAOpeningConditionalComment and WAClosingConditionalComment.!

!WAConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:37'!
root: anHtmlRoot
	^self new initializeWithRoot: anHtmlRoot! !

!WAConditionalComment methodsFor: 'private' stamp: 'lr 3/27/2007 11:36'!
addToCondition: aString
	condition := condition , aString! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
closingConditionClass
	^WAClosingConditionalComment! !

!WAConditionalComment methodsFor: 'public' stamp: 'pmm 11/25/2007 21:51'!
do: aBlock
	root add: (self openingConditionClass condition: condition).
	aBlock value.
	root add: (self closingConditionClass new)! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:19'!
equal
	"implicit of nothing else"! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:14'!
greaterThan
	self addToCondition: ' gt'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie
	self addToCondition: ' IE'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie5
	self addToCondition: ' IE 5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie50
	self addToCondition: ' IE 5.0'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie55
	self addToCondition: ' IE 5.5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie6
	self addToCondition: ' IE 6'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie7
	self addToCondition: ' IE 7'! !

!WAConditionalComment methodsFor: 'initialization' stamp: 'pmm 10/11/2006 17:36'!
initializeWithRoot: anHtmlRoot
	root := anHtmlRoot.
	condition := 'if'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:15'!
lessThan
	self addToCondition: ' lt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'tbn 11/21/2007 12:41'!
not
	self addToCondition: ' !!'! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
openingConditionClass
	^WAOpeningConditionalComment! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/19/2006 20:19'!
orEqual
	self addToCondition: 'e'! !

WAConditionalComment subclass: #WARevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WARevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
A WAConditionalComment is an implementation of Downlevel-revealed Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
Non-IE family browsers see them always.

See also WAOpeningRevealedConditionalComment and WARevealedConditionalComment.!

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
closingConditionClass
	^WAClosingRevealedConditionalComment! !

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
openingConditionClass
	^WAOpeningRevealedConditionalComment! !

WAObject subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfiguration commentStamp: 'jf 7/24/2008 19:44' prior: 0!
A configuration for a Seaside application contains attributes which can be used by Seaside and the application. WAConfiguration hierarchy uses the composite pattern.

Subclasses of WASystemConfiguration define and configure related groups of attributes. See WASystemConfiguration class comment for information on defining your own attributes.

WAUserConfiguration is a composite of configurations. The set of configurations contained in WAUserConfiguration is called the ancestors. Attribute values in a configuration override the attribute values in the ancestors. WAUserConfiguration also holds the non-default values of attributes.

Seaside applications start with a WAUserConfiguration (see WAApplication>>configuration) a single parent: WARenderLoopConfiguration. The full ancestry also includes WASessionConfiguration WAGlobalConfiguration. Other configurations can be added to an application on the Seaside configuration page for the application or in your application. Values for the attributes can be given in either location. 

See Seaside documentation (http://www.seaside.st/documentation) on configuration and preferences (http://www.seaside.st/documentation/Configuration%20and%20Preferences) for more information.

Example of setting attributes and adding configurations in code
ASubclassOfWAComponent class>>initialize
	"self initialize"
	| application |
	application := self registerAsApplication: 'GlorpExample'.
	"set a standard attribute"
	application preferenceAt: #sessionClass put: Glorp.WAGlorpSession. 

	"add a configuration"
	application configuration addParent: GlorpConfiguration new.
	application preferenceAt: #databaseLogin put: 'foo'. "set attribute defined in GlorpConfiguration"

Subclasses must implement the following messages:
	name
		return the name of the configuration

	localValueAt:ifAbsent:
		return the value of the attribute given as first argument!

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:39'!
allAttributes
	| attributes |
	attributes := IdentityDictionary new.
	
	self ancestorsDo: 
		[ :each |
		each canDefineAttributes ifTrue: [ attributes addAll: each attributes ] ].
	
	^ attributes! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:22'!
ancestors
	"As it happens, the 'seen' set gives us the result we need"
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo: 
			[ :each | 
			"nothing"
			 ]
		seen: set.
	^ set! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:22'!
ancestorsDo: aBlock 
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo: aBlock
		seen: set.
	^ set! !

!WAConfiguration methodsFor: 'ancestry-private' stamp: 'jf 7/24/2008 19:22'!
ancestorsDo: aBlock seen: seenSet 
	self parents do: 
		[ :each | 
		(seenSet includes: each) ifFalse: 
			[ aBlock value: each.
			seenSet add: each.
			each 
				ancestorsDo: aBlock
				seen: seenSet ] ]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/19/2008 14:47'!
attributeAt: aSymbol
	^ self attributeAt: aSymbol ifAbsent: [ self error: 'No attribute named ', aSymbol printString ]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:40'!
attributeAt: aSymbol ifAbsent: aBlock
	^ self allAttributes at: aSymbol ifAbsent: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/19/2008 15:26'!
canDefineAttributes
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:07'!
expressionAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:09'!
expressionAt: aSymbol ifPresent: aBlock
	| expression |
	expression := self expressionAt: aSymbol ifAbsent: [ ^ nil ].
	^ aBlock value: expression! !

!WAConfiguration methodsFor: 'values-private' stamp: 'jf 8/4/2008 15:26'!
inheritedValueAt: aSymbol context: aContext
	| value |
	(self parents select: [ :each | aContext isAttributeInheritedBy: each ]) reverseDo:
		[ :each |
		value := each valueAt: aSymbol context: aContext.
		value notNil ifTrue: [ ^ value ] ].
	
	^ nil! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:16'!
inheritsFrom: aConfiguration 
	^ self ancestors includes: aConfiguration! !

!WAConfiguration methodsFor: 'accessing' stamp: 'dkh 2/29/2008 10:48'!
name

	^self class name! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:10'!
parents
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/26/2008 14:57'!
valueAt: aSymbol 
	| value context |
	context := WAAttributeContext key: aSymbol target: self.

	context attribute isNil ifTrue: [ ^ WAAttributeNotFound new key: aSymbol; signal ].

	value := self valueAt: aSymbol context: context.
	
	^ value isNil
		ifTrue: [ context attribute default ]
		ifFalse: [ value ]! !

!WAConfiguration methodsFor: 'values-private' stamp: 'jf 8/4/2008 16:10'!
valueAt: aSymbol context: aContext
	aContext at: self ifPresent: [ :v | ^ v ].
	
	(aContext attribute configuration == self) ifTrue: [ ^ aContext at: self put: nil ].
	
	self expressionAt: aContext key ifPresent:
		[ :expression |
		^ aContext
			at: self
			put: (expression determineValueWithContext: aContext) ].
		
	^ aContext at: self put: (self inheritedValueAt: aSymbol context: aContext)! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

!WASystemConfiguration commentStamp: 'jf 7/24/2008 19:44' prior: 0!
You should subclass WASystemConfiguration to define new attributes. The method #addAttributes is passed an instance of WAAttributes which can be used to create new attributes. The attributes can be configured to specify their default value, label, and so on. See the methods on WAConfigurationAttribute and its subclasses to see what options are available.

If a configuration needs to override the value of another WASystemConfiguration or depends on its attributes, implement the method "parents", returning a collection of configuration objects.

WASystemConfiguration subclasses are "read-only" in that their attributes, parents, and default values are all specified in code. Users and applications that want to configure values for attributes should create a WAUserConfiguration and specify the WASystemConfiguration in its ancestry.

WASystemConfiguration classes are singleton. You should use #instance on the class side to get the current instance. You cannot call #copy on a WASystemConfiguration.

Subclasses should implement the following messages:
	addAttributes:
		
They may also want to implement:
	addOverrides:
	parents!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAAuthConfiguration commentStamp: 'jf 7/22/2008 12:39' prior: 0!
WAAuthConfiguration defines attributes to store a username and password for an application. It is used by WAApplication to provide a basic single-account authentication mechanism for applications like the Seaside Configuration application. It changes to mainClass for the session to WAAuthMain, which adds a Decoration to check for authentication before displaying the root component.

You can implement your own authentication mechanism without using this configuration by subclassing WAApplication and implementing #verifyPassword:forUser: to lookup account details from a database or similar. You can then manually set WAAuthMain as your main class.
!

!WAAuthConfiguration methodsFor: 'description' stamp: 'lr 9/12/2008 19:46'!
describeOn: config
	(config string: #login)
		group: #authentication;
		comment: 'The username for this application.'.
	(config password: #passwordHash)
		group: #authentication;
		comment: 'The password for this application.';
		label: 'Password'.! !

WASystemConfiguration subclass: #WARequestHandlingConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARequestHandlingConfiguration commentStamp: 'jf 7/24/2008 22:37' prior: 0!
This configuration class holds attributes needed by classes in the Request Handling layer.!

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'jf 9/13/2008 14:05'!
describeOn: config
	(config list: #documentClass)
		options: [self documentClasses];
		default: WAHtmlStreamDocument.
	(config list: #responseFactory)
		options: [self responseFactories];
		default: WAResponseFactory.
	(config list: #serverProtocol)
		group: #server;
		comment: 'The protocol in URLs generated by Seaside.';
		options: [#(http https)].
	(config string: #serverHostname)
		group: #server;
		comment: 'The hostname in URLs generated by Seaside.'.
	(config number: #serverPort)
		group: #server;
		comment: 'The port in URLs generated by Seaside.'.
	(config string: #serverPath)
		group: #server;
		comment: 'The path in URLs generated by Seaside.'.! !

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'jf 8/5/2008 10:33'!
documentClasses
	^ WAHtmlStreamDocument withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'jf 9/13/2008 14:42'!
responseFactories
	^ WAResponseFactory withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ] ! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'MAD 9/13/2008 12:26'!
clearAllDescriptions
	self allSubclasses do: [ :each | each instance clearDescription ]! !

!WASystemConfiguration class methodsFor: 'accessing' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance := self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'instance creation' stamp: 'jf 7/18/2008 17:10'!
new
	^ self error: 'SystemConfigurations are singletons. Use #instance.'! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:36'!
attributes
	^ self description attributes! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 18:57'!
buildDescription
	| d |
	d := WAConfigurationDescription new.
	d configuration: self.
	self describeOn: d.
	^ description := d! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 7/19/2008 15:26'!
canDefineAttributes
	^ true! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 18:56'!
clearDescription
	description := nil! !

!WASystemConfiguration methodsFor: 'copying' stamp: 'jf 7/18/2008 17:10'!
copy
	^ self error: 'SystemConfigurations are singletons and should not be copied.'! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 17:55'!
describeOn: conf
	"Should be implemented by subclasses to add attributes and value overrides to the configuration"! !

!WASystemConfiguration methodsFor: 'accessing' stamp: 'jf 7/29/2008 18:56'!
description
	^ description isNil 
		ifFalse: [ description ]
		ifTrue: [ self buildDescription ]! !

!WASystemConfiguration methodsFor: 'values' stamp: 'jf 9/11/2008 11:27'!
expressionAt: aSymbol ifAbsent: absentBlock
	^ self description expressions at: aSymbol ifAbsent: absentBlock.! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:37'!
localAttributeAt: aSymbol ifPresent: absentBlock
	^ self attributes at: aSymbol ifPresent: absentBlock! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'expressions parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAUserConfiguration commentStamp: 'jf 7/24/2008 19:45' prior: 0!
WAUserConfiguration is a composite of configurations.  This composite of configurations is stored in the field "parents". WAUserConfiguration provides methods to dynamically provide non-default values for attributes. WAUserConfiguration inherits attributes and values defined in its ancestors. If WAUserConfiguration does not have a value for an attribute it will search its ancestors for a value, stopping when it finds a value.

An instance of WAUserConfiguration is the first configuration added to a Seaside application (WAApplication). All other configurations added to the application are added as ancestors of this instance. When a value for an attribute is set either by the standard Seaside component configuration page or in code the value is added to the "values" dictionary in WAUserConfiguration.

Instance Variables:
	parents	<Collection of: WAConfiguration>	 hierarchy of configurations defining all attributes for this instance of WAUserConfiguration
	values	<Dictionary>	the dictionary key is an attribute key, dictionary value is value of that attribute 
!

WAUserConfiguration subclass: #WASharedConfiguration
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WASharedConfiguration class
	instanceVariableNames: 'instances'!

WASharedConfiguration class
	instanceVariableNames: 'instances'!

!WASharedConfiguration class methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:37'!
add: aSharedConfiguration
	^ instances add: aSharedConfiguration! !

!WASharedConfiguration class methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:38'!
configurations
	^ instances copy! !

!WASharedConfiguration class methodsFor: 'class initialization' stamp: 'jf 7/31/2008 14:37'!
initialize
	instances := IdentitySet new.! !

!WASharedConfiguration class methodsFor: 'instance creation' stamp: 'jf 7/31/2008 14:39'!
named: aString
	^ self add: (self new name: aString; yourself)! !

!WASharedConfiguration class methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:37'!
remove: aSharedConfiguration
	^ instances remove: aSharedConfiguration! !

!WASharedConfiguration methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:15'!
name
	^ name! !

!WASharedConfiguration methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:15'!
name: anObject
	name := anObject! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:47'!
addParent: aConfiguration 
	(self canAddParent: aConfiguration) 
		ifTrue: [ parents add: aConfiguration ]
		ifFalse: 
			[ self error: 'Cannot add this configuration as a parent. Would this cause a circular ancestry graph?' ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:42'!
canAddParent: aConfiguration 
	^ (aConfiguration = self or: [ aConfiguration inheritsFrom: self ]) not! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:17'!
expressionAt: aSymbol ifAbsent: errorBlock
	^ expressions at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'initialization' stamp: 'jf 8/4/2008 16:17'!
initialize
	super initialize.
	expressions := Dictionary new.
	parents := OrderedCollection new! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:36'!
moveParentDown: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index < parents size ifTrue: [ parents swap: index with: index + 1 ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:36'!
moveParentUp: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index > 1 ifTrue: [ parents swap: index with: index - 1 ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:47'!
parents
	^ parents! !

!WAUserConfiguration methodsFor: 'copying' stamp: 'jf 8/4/2008 16:18'!
postCopy
	super postCopy.
	expressions := expressions copy.
	parents := parents copy.! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:34'!
removeParent: aConfiguration 
	parents 
		remove: aConfiguration
		ifAbsent: [ ]! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:17'!
storeExpression: anAttributeExpression forAttribute: anAttribute
	^ expressions at: anAttribute key put: (anAttributeExpression configuration: self; yourself)! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:02'!
takeValue: anObject forAttribute: anAttribute
	^ anObject isNil ifFalse: [
		self
			storeExpression:
				((WAValueExpression key: anAttribute key)
					configuration: self;
					value: anObject;
					yourself)
			forAttribute: anAttribute ]! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 7/19/2008 20:40'!
takeValueFromString: aString forAttribute: anAttribute
	^ self takeValue: (anAttribute valueFromString: aString) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 7/31/2008 13:10'!
valueAt: aSymbol addAll: aCollection
	^ self valueAt: aSymbol addAll: aCollection removeAll: #()! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:00'!
valueAt: aSymbol addAll: additions removeAll: removals
	^ self
		storeExpression:
			((WAAddRemoveExpression key: aSymbol)
				additions: additions;
				removals: removals;
				yourself)
		forAttribute: (self attributeAt: aSymbol)! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 7/21/2008 09:27'!
valueAt: aSymbol put: anObject
	"It would be faster to simply add the value to the dictionary and
	implement #takeValue:forAttribute: in terms of this method, but
	config options are set only rarely and this ensures you are setting
	a value for an attribute that actually exists."

	^ self takeValue: anObject forAttribute: (self attributeAt: aSymbol)! !

WAObject subclass: #WAConfigurationDescription
	instanceVariableNames: 'configuration attributes expressions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfigurationDescription commentStamp: 'jf 7/19/2008 13:33' prior: 0!
I hold a collection of attributes and present methods to construct new methods, providing an interface a bit like WACanvs and #renderContentOn: to WASystemConfiguration>>addAttributes:.

I can use any kind of collection class and handle setting the #configuration: parameter of the attribute appropriately on addition. If my collection is a Dictionary, I will store the attributes by their keys.
!

!WAConfigurationDescription methodsFor: 'private' stamp: 'jf 7/29/2008 16:57'!
add: aDescriptor to: aDictionary
	configuration isNil ifFalse: [ aDescriptor configuration: configuration ].
	^ aDictionary at: aDescriptor key put: aDescriptor! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 16:57'!
addAttribute: anAttribute
	^ self add: anAttribute to: attributes! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 9/11/2008 11:24'!
addExpression: anExpression
	^ self add: anExpression to: expressions! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 7/31/2008 13:11'!
at: aSymbol addAll: aCollection
	self at: aSymbol addAll: aCollection removeAll: #()! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 9/11/2008 11:24'!
at: aSymbol addAll: additions removeAll: removals
	self addExpression: ((WAAddRemoveExpression key: aSymbol)
			additions: additions;
			removals: removals;
			yourself)! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 9/11/2008 11:24'!
at: aSymbol put: anObject 
	self addExpression: ((WAValueExpression key: aSymbol)
			value: anObject;
			yourself)! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 7/29/2008 17:02'!
attributes
	^ attributes! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 16:59'!
boolean: aSymbol
	^ self addAttribute: (WABooleanAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
collection: aSymbol
	^ self addAttribute: (WACollectionAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 7/19/2008 15:40'!
configuration: aConfiguration
	configuration := aConfiguration! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 9/11/2008 11:27'!
expressions
	^ expressions! !

!WAConfigurationDescription methodsFor: 'initialization' stamp: 'jf 9/11/2008 11:27'!
initialize
	super initialize.
	attributes := IdentityDictionary new.
	expressions := IdentityDictionary new.! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
list: aSymbol
	^ self addAttribute: (WAListAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
number: aSymbol
	^ self addAttribute: (WANumberAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
password: aSymbol
	^ self addAttribute: (WAPasswordAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
string: aSymbol
	^ self addAttribute: (WAStringAttribute key: aSymbol)! !

WAObject subclass: #WAConfigurationElement
	instanceVariableNames: 'configuration key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WAConfigurationElement subclass: #WAAttributeDescription
	instanceVariableNames: 'group comment label default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeDescription commentStamp: 'jf 7/19/2008 13:54' prior: 0!
WAConfigurationAttribute represents a value of a specified type in a Seaside configuration. Some attributes are needed by Seaside for application parameters like deployment Mode and session timeout. Optional attributes like a database login may be used internally by the application.

Each subclass of WAConfigurationAttribute handles one type (Number, Boolean, etc) of attribute. The "group" of the attribute is used to place all attributes in the same group together on the Seaside configuration page. The "key" of the attribute identifies the attribute. Attribute keys must be globally unique so use namespacing where required to ensure uniqueness. See WAConfiguration for example of accessing a configuration attribute. 

Subclasses may implement their own configuration options depending on their needs.

Subclasses must implement the following messages:
	valueFromString: aString
		convert "aString" into type represented by the class, return result of the conversion
	
	accept: aVisitor with: anObject
		Typical implementation is:
			aVisitor visitXXXAttribute: self with: anObject

		where XXX is the type of this attribute. The method visitXXXAttribute:with: must be implemented in all visitors, in particular WAConfigurationEditor which creates the configuration page for Seaside applications.

Instance Variables:
	configuration	<WAConfiguration>	The configuration object that defined the attribute
	group	<Symbol>	name of the group the attribute belongs to
	key	<Symbol>	key or name of the attribute, used to look up the attribute
	comment	<String> a full length description of the attribute for displaying in the configuration interface
	label	<String>	a short field label used in the user interface. If not specified, a label is constructed from the key.
	default	<Object>	The default value for the attribute.!

!WAAttributeDescription methodsFor: 'visiting' stamp: 'lr 10/28/2007 14:42'!
accept: aVisitor with: anObject
	self subclassResponsibility! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'pmm 12/9/2007 12:10'!
comment
	^ comment! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/16/2008 16:46'!
comment: aString
	comment := aString! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 15:33'!
default
	^ default! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 15:32'!
default: anObject
	default := anObject! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/16/2008 16:46'!
group: aSymbol
	group := aSymbol! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 18:11'!
label
	^ label ifNil: [self labelForSelector: self key] ! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 18:10'!
label: aString
	label := aString! !

!WAAttributeDescription methodsFor: 'converting' stamp: 'lr 8/30/2008 16:22'!
stringForValue: anObject 
	^ anObject seasideString! !

!WAAttributeDescription methodsFor: 'converting' stamp: 'lr 10/28/2007 14:42'!
valueFromString: aString
	self subclassResponsibility! !

WAAttributeDescription subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WABooleanAttribute commentStamp: 'rew 10/7/2007 12:49' prior: 0!
WABooleanAttribute  represents a boolean attribute. It converts between text entered on the configuration page and boolean values.!

!WABooleanAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'converting' stamp: 'lr 10/28/2007 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]! !

WAAttributeDescription subclass: #WAListAttribute
	instanceVariableNames: 'optionsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAListAttribute commentStamp: 'jf 7/19/2008 13:55' prior: 0!
WAListAttribute is an attribute that is restricted to a list of values. 

Instance Variables:
	options	<Block>	A block returning a list of possible values for the attribute!

WAListAttribute subclass: #WACollectionAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WACollectionAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitCollectionAttribute: self with: anObject! !

!WACollectionAttribute methodsFor: 'accessing' stamp: 'jf 9/11/2008 11:11'!
default
	"We don't want users modifying our internal collection"
	^ default copy! !

!WACollectionAttribute methodsFor: 'accessing' stamp: 'jf 9/11/2008 11:11'!
default: aCollection
	default := Set new.
	default addAll: aCollection.! !

!WACollectionAttribute methodsFor: 'initialization' stamp: 'jf 7/31/2008 11:40'!
initializeWithKey: aSymbol
	super initializeWithKey: aSymbol.
	default := Set new.! !

!WAListAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'accessing' stamp: 'jf 7/18/2008 20:16'!
options
	^ optionsBlock isNil
		ifTrue: [#()]
		ifFalse: optionsBlock! !

!WAListAttribute methodsFor: 'accessing' stamp: 'jf 7/18/2008 20:19'!
options: aBlock
	optionsBlock := aBlock! !

!WAListAttribute methodsFor: 'converting' stamp: 'jf 9/11/2008 11:09'!
valueFromString: aString 
	self error: 'List attributes cannot be converted from Strings'! !

WAAttributeDescription subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WANumberAttribute commentStamp: 'rew 10/7/2007 12:51' prior: 0!
WANumberAttribute represents a number attribute. It converts between text entered on the configuration page and numbers.
!

!WANumberAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'converting' stamp: 'jf 7/31/2008 16:43'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ Number readFrom: aString ]! !

WAAttributeDescription subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAPasswordAttribute commentStamp: 'jf 7/10/2008 14:06' prior: 0!
WAPasswordAttribute represents a password attribute. When set from a string, it records a hashed value. On the Seaside configuration page it does not display its current value.
!

!WAPasswordAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitPasswordAttribute: self with: anObject! !

!WAPasswordAttribute methodsFor: 'converting' stamp: 'pmm 7/14/2008 20:32'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [
		SeasidePlatformSupport secureHashFor: aString ]! !

WAAttributeDescription subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAStringAttribute commentStamp: 'rew 10/7/2007 12:52' prior: 0!
WAStringAttribute represents a string attribute. It does the trivial conversion between text entered on the Seaside configuration page and a string.!

!WAStringAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'converting' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

WAConfigurationElement subclass: #WAAttributeExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WAAttributeExpression subclass: #WAAddRemoveExpression
	instanceVariableNames: 'additions removals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 11:42'!
additions
	^ additions! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 11:43'!
additions: aCollection
	additions := aCollection! !

!WAAddRemoveExpression methodsFor: 'values' stamp: 'jf 9/11/2008 11:39'!
determineValueWithContext: aContext
	| collection set |
	collection := self configuration inheritedValueAt: self key context: aContext.
	
	collection isNil ifTrue: [ collection := aContext attribute default ].
	collection isNil ifTrue: [ collection := Array new ].
	
	set := Set withAll: collection. 
	self removals do: [ :each | set remove: each ifAbsent: [] ].
	set addAll: self additions.
	
	^ set! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 13:09'!
removals
	^ removals! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 13:09'!
removals: anObject
	removals := anObject! !

!WAAttributeExpression methodsFor: 'values' stamp: 'jf 8/4/2008 15:28'!
determineValueWithContext: aContext
	self subclassResponsibility! !

WAAttributeExpression subclass: #WAValueExpression
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAValueExpression methodsFor: 'values' stamp: 'jf 8/4/2008 15:28'!
determineValueWithContext: aContext
	^ self value! !

!WAValueExpression methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:31'!
value
	^ value! !

!WAValueExpression methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:31'!
value: anObject
	value := anObject! !

!WAConfigurationElement class methodsFor: 'instance-creation' stamp: 'jf 7/29/2008 19:02'!
key: aSymbol
	^ self basicNew initializeWithKey: aSymbol! !

!WAConfigurationElement methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:53'!
configuration
	^ configuration! !

!WAConfigurationElement methodsFor: 'accessing' stamp: 'jf 7/29/2008 19:02'!
configuration: aConfiguration
	configuration := aConfiguration! !

!WAConfigurationElement methodsFor: 'initialization' stamp: 'jf 7/29/2008 19:02'!
initializeWithKey: aSymbol
	key := aSymbol! !

!WAConfigurationElement methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:54'!
key
	^ key! !

WAObject subclass: #WADictionaryMerger
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WADictionaryMerger commentStamp: 'pmm 9/4/2008 14:07' prior: 0!
This is a utility class that merges multiple dictionaries. It also promotes values to collections if there a multiple mappings for the same key. This class can be used by server adapter to deal with http parameters.!

!WADictionaryMerger methodsFor: 'accessing' stamp: 'pmm 9/4/2008 14:13'!
at: aKey put: aValue
	^(aValue isKindOf: self collectionClass)
		ifTrue: [ 
			aValue size = 1
				ifTrue: [ self at: aKey putScalar: aValue first ]
				ifFalse: [ self at: aKey putCollection: aValue ] ]
		ifFalse: [ self at: aKey putScalar: aValue ]! !

!WADictionaryMerger methodsFor: 'private' stamp: 'pmm 9/4/2008 14:28'!
at: aKey putCollection: aCollection
	(dictionary includesKey: aKey)
		ifTrue: [
			| value |
			value := dictionary at: aKey.
			(value isKindOf: self collectionClass)
				ifTrue: [ value addAll: aCollection ]
				ifFalse: [
					dictionary
						at: aKey
						put: ((self collectionClass with: value), aCollection) ] ]
		ifFalse: [ dictionary at: aKey put: aCollection ]! !

!WADictionaryMerger methodsFor: 'private' stamp: 'pmm 9/4/2008 14:26'!
at: aKey putScalar: anObject
	^(dictionary includesKey: aKey)
		ifTrue: [
			| value |
			value := dictionary at: aKey.
			(value isKindOf: self collectionClass)
				ifTrue: [ value add: anObject ]
				ifFalse: [
					dictionary
						at: aKey
						put: (self collectionClass with: value with: anObject) ] ]
		ifFalse: [ dictionary at: aKey put: anObject ]! !

!WADictionaryMerger methodsFor: 'private' stamp: 'pmm 9/4/2008 14:09'!
collectionClass
	^OrderedCollection! !

!WADictionaryMerger methodsFor: 'accessing' stamp: 'pmm 9/4/2008 14:15'!
dictionary
	^dictionary! !

!WADictionaryMerger methodsFor: 'initialize-release' stamp: 'pmm 9/4/2008 14:08'!
initialize
	super initialize.
	dictionary := Dictionary new! !

WAObject subclass: #WAEncoder
	instanceVariableNames: 'stream table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder commentStamp: 'lr 4/8/2007 15:49' prior: 0!
I encode everything that is written to myself using #nextPut: and #nextPutAll: onto the wrapped stream. To be efficient I use an encoding table to be able to transform the most used characters from the UTF Basic Multilingual Plane as efficiently as possible. The convertion of a single character is defined in #encode:on: on the class-side of my subclasses.!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 13:42'!
encode: aCharacter on: aStream
	self subclassResponsibility! !

!WAEncoder class methodsFor: 'initialization' stamp: 'pmm 2/13/2008 21:17'!
initializeBMP
	"Initializes the BMP, the Basic Multilingual Plane of UTF characters, using the encoding strategy of the receiver. This chaching strategy ensures that most commonly used characters can be encoded as efficient as possible."

	| stream characterLimit |
	characterLimit := self maximumCharacterValue.
	table := Array new: characterLimit.
	stream := WriteStream on: (String new: 6).
	1 to: characterLimit do: [ :index |
		self encode: (Character value: index - 1) on: stream reset.
		table at: index put: (stream position = 1
			ifTrue: [ stream contents first ]
			ifFalse: [ stream contents ]) ]! !

!WAEncoder class methodsFor: 'private' stamp: 'pmm 2/13/2008 21:17'!
maximumCharacterValue
	"find the maximum value of a character that we can instantiate, for Squeak 3.7 this is 255"
	^[ Character value: 16rFFFF.
		16rFFFF ]
			on: Error
			do: [ :error  | 16rFF ]! !

!WAEncoder class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 20:51'!
on: aStream
	^ self on: aStream table: table! !

!WAEncoder class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 20:29'!
on: aStream table: anArray
	^ self basicNew initializeOn: aStream table: anArray! !

!WAEncoder methodsFor: 'initialization' stamp: 'lr 3/26/2007 20:30'!
initializeOn: aStream table: anArray
	stream := aStream.
	table := anArray! !

!WAEncoder methodsFor: 'accessing' stamp: 'lr 4/8/2007 13:57'!
nextPut: aCharacter
	| value encoded |
	value := aCharacter asInteger.
	value < table size
		ifFalse: [ self class encode: aCharacter on: stream ]
		ifTrue: [
			encoded := table at: value + 1.
			encoded isString
				ifTrue: [ stream nextPutAll: encoded ]
				ifFalse: [ stream nextPut: encoded ] ]! !

!WAEncoder methodsFor: 'accessing' stamp: 'lr 4/8/2007 13:57'!
nextPutAll: aString
	| character value encoded |
	"uses #to:do: for speed reasons (on Squeak)
	this is not premature optimization, this is a hotspot method method
	and #to:do: shows measurable speed improvements for rendering seaside pages"
	1 to: aString size do: [ :index |
		character := aString at: index.
		value := character asInteger.
		value < table size
			ifFalse: [ self class encode: character on: stream ]
			ifTrue: [
				encoded := table at: value + 1.
				encoded isString
					ifTrue: [ stream nextPutAll: encoded ]
					ifFalse: [ stream nextPut: encoded ] ] ]! !

WAEncoder subclass: #WAHtmlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlEncoder commentStamp: 'lr 4/6/2007 19:45' prior: 0!
I encode XHTML text.!

!WAHtmlEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 14:05'!
encode: aCharacter on: aStream
	aCharacter = $" ifTrue: [ ^ aStream nextPutAll: '&quot;' ].
	aCharacter = $< ifTrue: [ ^ aStream nextPutAll: '&lt;' ].
	aCharacter = $& ifTrue: [ ^ aStream nextPutAll: '&amp;'].
	aCharacter = $> ifTrue: [ ^ aStream nextPutAll: '&gt;' ].
	aStream nextPut: aCharacter! !

!WAHtmlEncoder class methodsFor: 'initialization' stamp: 'lr 4/8/2007 14:01'!
initialize
	self initializeBMP! !

WAEncoder subclass: #WAUrlEncoder
	instanceVariableNames: 'codec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAUrlEncoder commentStamp: 'pmm 5/10/2008 22:03' prior: 0!
I encode path segments and arguments of an URL.

I only do "precend encoding", I delegate the encoding from characters to bytes to a codec (provided by the server).!

!WAUrlEncoder class methodsFor: 'private' stamp: 'pmm 5/11/2008 08:58'!
encode: aCharacter on: aStream
	| value |
	('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: aCharacter)
		ifTrue: [ ^ aStream nextPut: aCharacter ].
	aCharacter = Character space
		ifTrue: [ ^ aStream nextPut: $+ ].
	value := aCharacter asInteger.
	aStream nextPut: $%.
	aStream nextPutAll: ((value printStringBase: 16) padded: #left to: 2 with: $0)! !

!WAUrlEncoder class methodsFor: 'initialization' stamp: 'lr 4/8/2007 15:43'!
initialize
	self initializeBMP! !

!WAUrlEncoder class methodsFor: 'private' stamp: 'pmm 5/10/2008 21:57'!
maximumCharacterValue
	"String to bye encoding has aleady happened in the server"
	^16rFF! !

!WAUrlEncoder methodsFor: 'initialization' stamp: 'jf 7/29/2008 12:25'!
initializeOn: aStream table: anArray
	super initializeOn: aStream table: anArray.
	
	codec := WACurrentRequestContext value isNil
		ifFalse: [ WACurrentRequestContext value codec ].
	codec isNil ifTrue: [ codec := WANullCodec new ].! !

!WAUrlEncoder methodsFor: 'accessing' stamp: 'pmm 5/10/2008 22:05'!
nextPut: aCharacter
	self nextPutAll: (String with: aCharacter)! !

!WAUrlEncoder methodsFor: 'accessing' stamp: 'pmm 5/11/2008 08:48'!
nextPutAll: aString
	super nextPutAll: (codec encodeUrl: aString)! !

WAObject subclass: #WAEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

WAEvent subclass: #WAResponseEvent
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

!WAResponseEvent class methodsFor: 'instance-creation' stamp: 'lr 3/29/2008 22:35'!
on: aResponse
	^ self basicNew initializeOn: aResponse! !

!WAResponseEvent methodsFor: 'initialization' stamp: 'lr 3/29/2008 22:34'!
initializeOn: aResponse
	response := aResponse! !

!WAResponseEvent methodsFor: 'accessing' stamp: 'lr 3/29/2008 22:34'!
response
	^ response! !

WAObject subclass: #WAExceptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAExceptionHandler commentStamp: 'jf 9/17/2008 20:49' prior: 0!
Exception handlers are invoked when an error in a Seaside application occurs. Request handlers can use the class-side method #handleExceptionsDuring: to set up exception handlers around a block of code.

== Catching ==

Exception handlers can configure which exceptions they want to catch by overriding the class-side method #exceptionsToCatch. They may also choose to override #handleExceptionsDuring: on the class-side directly, if they need more complex behaviour.

== Handling ==

Handling behaviour is implemented on the instance side by implementing #handleException:. This method should return a suitable seaside response (usually an instance of WAResponse) if it returns.

== Internal Errors ==

Internal errors are typically errors that occur while trying to execute one of the other error handlers and should be as basic as possible to ensure they don't have any trouble executing. Request handlers can ask for an internal error response by calling #internalError: on the class-side of an exception handler.

== HTML Responses ==

See WAWalkbackErrorHandler in the development packages for examples of how to do rendering with the canvas API.
!

WAExceptionHandler subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAErrorHandler commentStamp: 'jf 9/17/2008 20:50' prior: 0!
WAErrorHandler catches Errors and Warnings and provides two methods for handling each type of exception:

handleError:
handleWarning:

If either method is not implemented, the default implementation will call #handleDefault:, which can be used to provide common behaviour for both exception types.!

!WAErrorHandler class methodsFor: 'exception handling' stamp: 'jf 9/19/2008 20:05'!
exceptionsToCatch
	^ super exceptionsToCatch, Error, Warning, SeasidePlatformSupport haltExceptionClass! !

!WAErrorHandler class methodsFor: 'deprecated' stamp: 'jf 9/17/2008 19:59'!
handleError: anError
	self deprecatedApi: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:'.
	^ self new handleError: anError! !

!WAErrorHandler class methodsFor: 'deprecated' stamp: 'jf 9/17/2008 19:59'!
handleWarning: aWarning
	self deprecatedApi: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:'.
	^ self new handleWarning: aWarning! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/17/2008 20:03'!
handleDefault: anException
	"This method provides the default behaviour if subclasses do
	not implement one of the specific handler methods."
	^ self internalError: anException! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/14/2008 13:03'!
handleError: anError
	^ self handleDefault: anError! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/19/2008 20:05'!
handleException: anException
	(anException isKindOf: Error)
		ifTrue: [ ^ self handleError: anException ].
	(anException isKindOf: Warning)
		ifTrue: [ ^ self handleWarning: anException ].
	(anException isKindOf: SeasidePlatformSupport haltExceptionClass)
		ifTrue: [ ^ self handleHalt: anException ].
	
	^ self handleDefault: anException! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/19/2008 20:00'!
handleHalt: anException
	"Note that different platforms may use different classes of exceptions to
	represent a halt."
	^ self handleDefault: anException! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/14/2008 13:03'!
handleWarning: aWarning
	^ self handleDefault: aWarning! !

!WAExceptionHandler class methodsFor: 'exception handling' stamp: 'jf 9/17/2008 19:55'!
exceptionsToCatch
	^ ExceptionSet new! !

!WAExceptionHandler class methodsFor: 'exception handling' stamp: 'jf 9/23/2008 17:34'!
handleExceptionsDuring: aBlock
	| handler |
	handler := nil.
		
	^ aBlock
		on: self exceptionsToCatch
		do: [ :e | (handler ifNil: [ handler := self new ]) handleException: e ]! !

!WAExceptionHandler class methodsFor: 'responding' stamp: 'jf 9/17/2008 19:51'!
internalError: anError
	^ self new internalError: anError! !

!WAExceptionHandler methodsFor: 'actions' stamp: 'jf 9/17/2008 20:00'!
handleException: anException! !

!WAExceptionHandler methodsFor: 'actions' stamp: 'jf 9/23/2008 14:21'!
internalError: anError
	"This method should not call #handleException: because subclasses
	want to modify the behaviour for for other exceptions without
	changing the simple fallback internal error behaviour."
	^ WAResponse internalError: anError! !

WAObject subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAFile commentStamp: 'pmm 5/31/2008 23:54' prior: 0!
I represent a file that was uploaded by the user via #fileInput.

Instance Variables
	contents:		<ByteArray>
	contentType:	<WAMimeType>
	fileName:		<String>

contents
	- the contents of the file, binary

contentType
	- the content type of the file
	
fileName
	- The name of the file the user agent uploaded. This is locale name on the machine of the client. The instance variable might include the full path on the file system, the accessor will never return the path.!

!WAFile methodsFor: 'accessing' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'accessing' stamp: 'jf 9/22/2008 12:23'!
contentType: aMimeTypeOrString
	contentType := aMimeTypeOrString seasideMimeType! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:39'!
contents
	"Answer a ByteArray"
	^ contents! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:37'!
contents: aByteArray
	contents := aByteArray! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 7/24/2007 22:03'!
fileName
	"compensate for windows explorer behavior"
	^ self isWindowsPath
		ifTrue: [ fileName copyAfterLast: $\ ]
		ifFalse: [ fileName ]! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
fileName: aString
	fileName := aString! !

!WAFile methodsFor: 'private' stamp: 'pmm 7/24/2007 22:02'!
isWindowsPath
	"'#:\*' match: fileName is broken on Squeak for WideString arguments"
	^fileName notEmpty
		and: [ fileName first isLetter
		and: [ fileName size >= 3
		and: [ (fileName copyFrom: 2 to: 3) = ':\' ] ] ]! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 4/18/2008 22:45'!
size
	"the file size in bytes"
	^self contents size! !

WAObject subclass: #WAHtmlDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlDocument commentStamp: 'pmm 6/1/2008 00:19' prior: 0!
A WAHtmlDocument controls how a string is created from a series of brushes.!

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 22:23'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
nextPut: aCharacter
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
nextPutAll: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 21:38'!
openTag: aString
	self openTag: aString attributes: nil closed: false! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 21:38'!
openTag: aString attributes: anAttributes
	self openTag: aString attributes: anAttributes closed: false! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 22:23'!
openTag: aString attributes: anAttributes closed: aBoolean
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
print: anObject
	self subclassResponsibility! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'stream htmlEncoder urlEncoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlStreamDocument commentStamp: 'pmm 6/1/2008 00:23' prior: 0!
A WAHtmlStreamDocument is a concrete WAHtmlDocument that writes tags into a stream.

Instance Variables
	htmlEncoder:	<WAHtmlEncoder>
	stream:			<WriteStream>
	urlEncoder:		<WAUrlEncoder>

htmlEncoder
	- the encoder used to escape reserved HTML characters

stream
	- the stream on which the brushes are written

urlEncoder
	- the encoder used to escape reserved URL characters
!

!WAHtmlStreamDocument methodsFor: 'actions' stamp: 'lr 3/27/2007 11:47'!
close: aHtmlRoot
	aHtmlRoot close: self! !

!WAHtmlStreamDocument methodsFor: 'writing-xhtml' stamp: 'lr 4/9/2007 10:28'!
closeTag: aString
	stream nextPutAll: '</'.
	stream nextPutAll: aString.
	stream nextPut: $>! !

!WAHtmlStreamDocument methodsFor: 'accessing-encoders' stamp: 'lr 3/26/2007 20:22'!
htmlEncoder
	^ htmlEncoder! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:06'!
nextPut: aCharacter
	stream nextPut: aCharacter! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:07'!
nextPutAll: aString
	stream nextPutAll: aString! !

!WAHtmlStreamDocument methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
open: aHtmlRoot
	aHtmlRoot open: self! !

!WAHtmlStreamDocument methodsFor: 'writing-xhtml' stamp: 'lr 5/23/2007 10:49'!
openTag: aString attributes: anAttributes closed: aBoolean
	stream nextPut: $<.
	stream nextPutAll: aString.
	anAttributes encodeOn: self.
	aBoolean ifTrue: [ stream nextPut: $/ ].
	stream nextPut: $>! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:16'!
print: anObject
	anObject encodeOn: self! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:39'!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'lr 3/26/2007 20:42'!
stream: aStream
	stream := aStream.
	htmlEncoder := WAHtmlEncoder on: stream.
	urlEncoder := WAUrlEncoder on: stream! !

!WAHtmlStreamDocument methodsFor: 'accessing-encoders' stamp: 'lr 3/26/2007 20:22'!
urlEncoder
	^ urlEncoder! !

WAObject subclass: #WAHtmlElement
	instanceVariableNames: 'root attributes children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAHtmlElement commentStamp: 'pmm 1/28/2008 07:08' prior: 0!
Root class of all elements inside a <head> section.!

WAHtmlElement subclass: #WABaseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WABaseElement commentStamp: 'pmm 1/28/2008 07:05' prior: 0!
In HTML, links and references to external images, applets, form-processing programs, style sheets, etc. are always specified by a URI. Relative URIs are resolved according to a base URI, which may come from a variety of sources. The BASE element allows authors to specify a document's base URI explicitly.

When present, the BASE element must appear in the HEAD section of an HTML document, before any element that refers to an external source. The path information specified by the BASE element only affects URIs in the document where the element appears.

For example, given the following BASE declaration and A declaration:
updateRoot: html
	super updateRoot: html.
	html base url: 'http://www.aviary.com/products/intro.html'

renderContentOn: html
	html anchor
		url: '../cages/birds.gif';
		with: 'Bird Cages'

the relative URI "../cages/birds.gif" would resolve to:
http://www.aviary.com/cages/birds.gif!

!WABaseElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'base'! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
target: aString
	self attributeAt: 'target' put: aString! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
url: aString
	self attributeAt: 'href' put: aString! !

WAHtmlElement subclass: #WAContentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAContentElement commentStamp: 'pmm 1/28/2008 07:01' prior: 0!
Common superclass of all elements inside a <head> that can have content. Either between the start and end tag or a (mime) document pointed to by an URL.!

!WAContentElement methodsFor: 'attributes' stamp: 'lr 3/27/2007 13:33'!
contents: aString
	self document: aString! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString
	self document: aString mimeType: self typeOrNil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString fileName: fileName
	self document: aString mimeType: self typeOrNil fileName: fileName! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString mimeType: mimeType
	self document: aString mimeType: mimeType fileName: nil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:33'!
document: aString mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aString mimeType: mimeType fileName: fileName)! !

!WAContentElement methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
encodeChildrenOn: aDocument 
	children isEmptyOrNil ifTrue: [ ^ self ].
	aDocument nextPutAll: '/*<!![CDATA[*/'.
	children do: [ :each | aDocument nextPutAll: each seasideString ].
	aDocument nextPutAll: '/*]]>*/'! !

!WAContentElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ false! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 4/10/2007 09:55'!
resourceUrl: aString
	self url: (root context absoluteUrlForResource: aString)! !

!WAContentElement methodsFor: 'attributes' stamp: 'pmm 11/21/2007 20:48'!
type: aMimeTypeOrString
	self attributeAt: 'type' put: aMimeTypeOrString! !

!WAContentElement methodsFor: 'private' stamp: 'lr 3/27/2007 10:51'!
typeOrNil
	^ self attributeAt: 'type' ifAbsent:  [ nil ]! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
url: aString
	self subclassResponsibility! !

WAContentElement subclass: #WALinkElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WALinkElement commentStamp: 'pmm 1/29/2008 22:04' prior: 0!
Defines either a link or style sheet rules. If it has children then it defines style sheet rules, else it defines a link.

= if link =
This element defines a link. Unlike A, it may only appear in the HEAD section of a document, although it may appear any number of times. Although LINK has no content, it conveys relationship information that may be rendered by user agents in a variety of ways (e.g., a tool-bar with a drop-down menu of links).

= style sheet rules =
The STYLE element allows authors to put style sheet rules in the head of the document. HTML permits any number of STYLE elements in the HEAD section of a document.

User agents that don't support style sheets, or don't support the specific style sheet language used by a STYLE element, must hide the contents of the STYLE element. It is an error to render the content as part of the document's text. Some style sheet languages support syntax for hiding the content from non-conforming user agents.!

!WALinkElement methodsFor: 'accessing-children' stamp: 'pmm 1/29/2008 22:00'!
add: anElement
	super add: anElement.
	attributes isNil ifFalse: [
		attributes removeKey: 'rel' ifAbsent: [ "ignore" ] ]! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAll
	self addMedia: 'all'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAural
	self addMedia: 'aural'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addBraille
	self addMedia: 'braille'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addHandheld
	self addMedia: 'handheld'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 3/9/2008 11:19'!
addMedia: aString
	self attributes addMedia: aString! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addPrint
	self addMedia: 'print'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addProjection
	self addMedia: 'projection'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addScreen
	self addMedia: 'screen'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTeletype
	self addMedia: 'tty'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTelevision
	self addMedia: 'tv'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:54'!
beAlternate
	"Gives alternate representations of the current document."
	self relationship: 'alternate'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:14'!
beAlternateStylesheet
	self relationship: 'alternate stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beAppendix
	self relationship: 'appendix'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:56'!
beArchives
	"Provides a link to a collection of records, documents, or other materials of historical interest."
	self relationship: 'archives'! !

!WALinkElement methodsFor: 'type' stamp: 'jf 9/22/2008 12:21'!
beAtom
	self type: 'application/atom+xml' seasideMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beBookmark
	self relationship: 'bookmark'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beChapter
	self relationship: 'chapter'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beClossary
	self relationship: 'lossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beCopyright
	self relationship: 'copyright'! !

!WALinkElement methodsFor: 'type' stamp: 'jf 9/22/2008 13:14'!
beCss
	self type: WAMimeType textCss! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:05'!
beFirst
	"Indicates that the current document is a part of a series, and that the first document in the series is the referenced document."
	self relationship: 'first'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:17'!
beFontDefinition
	self relationship: 'fontdef'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:57'!
beGlossary
	self relationship: 'glossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beHelp
	self relationship: 'help'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beIndex
	self relationship: 'index'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beLast
	self relationship: 'last'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:58'!
beMicrosummary
	"http://wiki.mozilla.org/Microsummaries"
	self relationship: 'microsummary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beNext
	"Indicates that the current document is a part of a series, and that the next document in the series is the referenced document."
	self relationship: 'next'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
bePrevious
	"Indicates that the current document is a part of a series, and that the previous document in the series is the referenced document."
	self relationship: 'previous'! !

!WALinkElement methodsFor: 'type' stamp: 'jf 9/22/2008 12:21'!
beRss
	self type: 'application/rss+xml' seasideMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beSearch
	"Gives a link to a resource that can be used to search through the current document and its related pages. "
	self relationship: 'search'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beSection
	self relationship: 'section'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:16'!
beShortcutIcon
	self relationship: 'shortcut icon'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:03'!
beStart
	"Refers to the first document in a collection of documents. This link type tells search engines which document is considered by the author to be the starting point of the collection."
	self relationship: 'start'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beStylesheet
	"Imports a stylesheet."
	self relationship: 'stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beSubsection
	self relationship: 'subsection'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beTableOfContents
	self relationship: 'contents'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beTop
	self relationship: 'top'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beUp
	"Provides a link to a document giving the context for the current document."
	self relationship: 'up'! !

!WALinkElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ children isEmptyOrNil! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:02'!
media: aString
	"This attribute specifies the intended destination medium for style information. It may be a single media descriptor or a comma-separated list. The default value for this attribute is 'screen'."
	self attributeAt: 'media' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:01'!
relationship: aString
	"This attribute describes the relationship from the current document to the anchor specified by the href(url) attribute. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rel' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:00'!
reverse: aString
	"This attribute is used to describe a reverse link from the anchor specified by the href attribute to the current document. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rev' put: aString! !

!WALinkElement methodsFor: 'accessing' stamp: 'pmm 1/29/2008 21:57'!
tag
	^ children isEmptyOrNil
		ifTrue: [ 'link' ]
		ifFalse: [ 'style' ]! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:09'!
title: aString
	self attributeAt: 'title' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'href' put: aString! !

WAContentElement subclass: #WAScriptElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAScriptElement commentStamp: 'pmm 1/28/2008 06:46' prior: 0!
The SCRIPT element places a script within a document. This element may appear any number of times in the HEAD of an HTML document.

The script may be defined within the contents of the SCRIPT element or in an external file. If the src attribute is not set, user agents must interpret the contents of the element as the script. If the src has a URI value, user agents must ignore the element's contents and retrieve the script via the URI. Note that the charset attribute refers to the character encoding of the script designated by the src attribute; it does not concern the content of the SCRIPT element.!

!WAScriptElement methodsFor: 'types' stamp: 'jf 9/22/2008 13:02'!
beJavascript
	self type: WAMimeType textJavascript! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 9/22/2007 07:36'!
defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
		self attributeAt: 'defer' put: true! !

!WAScriptElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:27'!
tag
	^ 'script'! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAHtmlElement class methodsFor: 'instance-creation' stamp: 'lr 3/27/2007 13:26'!
root: aRoot
	^ self basicNew initializeWithRoot: aRoot! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 3/27/2007 10:47'!
add: anElement
	children ifNil: [ children := OrderedCollection new ].
	children add: anElement! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString
	^ self attributes at: aString! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString ifAbsent: aBlock
	^ self attributes at: aString ifAbsent: aBlock! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString put: anObject
	^ self attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/21/2007 15:58'!
attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 3/27/2007 10:47'!
childrenDo: aBlock
	children ifNotNil: [ children do: aBlock ]! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeAfterOn: aDocument
	aDocument closeTag: self tag! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeBeforeOn: aDocument
	aDocument openTag: self tag attributes: attributes closed: self isClosed! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeChildrenOn: aDocument
	self childrenDo: [ :each | each encodeOn: aDocument ]! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeOn: aDocument
	self encodeBeforeOn: aDocument.
	self isClosed ifTrue: [ ^ self ].
	self encodeChildrenOn: aDocument.
	self encodeAfterOn: aDocument! !

!WAHtmlElement methodsFor: 'initialization' stamp: 'lr 3/27/2007 13:26'!
initializeWithRoot: aRoot
	root := aRoot! !

!WAHtmlElement methodsFor: 'testing' stamp: 'lr 3/27/2007 11:24'!
isClosed
	^ true! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:24'!
tag
	self subclassResponsibility! !

!WAHtmlElement methodsFor: 'public' stamp: 'lr 11/5/2007 17:22'!
with: anObject
	self add: anObject! !

WAHtmlElement subclass: #WAMetaElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAMetaElement commentStamp: 'pmm 1/28/2008 06:58' prior: 0!
The META element can be used to identify properties of a document (e.g., author, expiration date, a list of key words, etc.) and assign values to those properties. This specification does not define a normative set of properties.

Each META element specifies a property/value pair. The name attribute identifies the property and the content attribute specifies the property's value.

For example, the following declaration sets a value for the Author property:
<META name="Author" content="Dave Raggett">

The lang attribute can be used with META to specify the language for the value of the content attribute. This enables speech synthesizers to apply language dependent pronunciation rules.

In this example, the author's name is declared to be French:

htm meta
	name: 'Author'; language: 'fr'; content: 'Arnaud Le Hors'
	
Note. The META element is a generic mechanism for specifying meta data. However, some HTML elements and attributes already handle certain pieces of meta data and may be used by authors instead of META to specify those pieces: the TITLE element, the ADDRESS element, the INS and DEL elements, the title attribute, and the cite attribute.

Note. When a property specified by a META element takes a value that is a URI, some authors prefer to specify the meta data via the LINK element. Thus, the following meta data declaration:
html meta
      name: 'DC.identifier';
      content: 'http://www.ietf.org/rfc/rfc1866.txt'

might also be written:
html link
         relationship: 'DC.identifier';
         type: 'text/plain';
         url: 'http://www.ietf.org/rfc/rfc1866.txt'

The http-equiv attribute can be used in place of the name attribute and has a special significance when documents are retrieved via the Hypertext Transfer Protocol (HTTP). HTTP servers may use the property name specified by the http-equiv attribute to create an [RFC822]-style header in the HTTP response. Please see the HTTP specification ([RFC2616]) for details on valid HTTP headers.

The following sample META declaration:
htttp meta
         responseHeaderName: 'Expires';
         content: 'Tue, 20 Aug 1996 14:25:27 GMT'

will result in the HTTP header:
Expires: Tue, 20 Aug 1996 14:25:27 GMT

This can be used by caches to determine when to fetch a fresh copy of the associated document.

Note. Some user agents support the use of META to refresh the current page after a specified number of seconds, with the option of replacing it by a different URI. Authors should not use this technique to forward users to different pages, as this makes the page inaccessible to some users. Instead, automatic page forwarding should be done using server-side redirects.

html meta
         redirectAfter: 5 to: 'http://www.google.com/'!

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 10/7/2006 18:20'!
beLeftToRight
	self textDirection: 'LTR'! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 10/7/2006 18:20'!
beRightToLeft
	self textDirection: 'RTL'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
content: aString
	self attributeAt: 'content' put: aString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 11/21/2007 21:17'!
contentScriptType: aMimeTypeOrString
	self responseHeaderName: 'Content-Script-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 11/21/2007 21:17'!
contentType: aMimeTypeOrString
	self responseHeaderName: 'Content-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'initialization' stamp: 'lr 2/16/2008 18:47'!
initialize
	super initialize.
	self content: ''! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:18'!
language: aString
	self attributeAt: 'lang' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'lr 8/30/2008 16:22'!
redirectAfter: seconds to: aString 
	self responseHeaderName: 'refresh'.
	self content: seconds seasideString , ';URL=' , aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:25'!
responseHeaderName: aString
	self attributeAt: 'http-equiv' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
scheme: aString
	self attributeAt: 'scheme' put: aString! !

!WAMetaElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'meta'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:19'!
textDirection: aString
	self attributeAt: 'dir' put: aString! !

WAObject subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WALRUCache commentStamp: 'pmm 10/20/2007 23:23' prior: 0!
WALRUCache implements at Least Recently Used cache. Items are removed from the cache when they reach "max" age. The age of an item is the number of additions to the cache done since the item itself was added. WALRUCache does not worry about the size of the cache. The "capacity:" method is misleading, it sets how long items will remain in the cache.

Instance Variables:
	ageTable	<Dictionary>	The age each time in the cache
	max	<SmallInteger>	The age at which items are removed from the cache
	table	<Dictionary>	Items in the cache, each item has key
			
WALRUCache is used to store the last n continutations of a session.

!

!WALRUCache class methodsFor: 'instance creation' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 3/19/2007 20:18'!
at: aKey
	^ self at: aKey ifAbsent: [ self error: 'No entry for ' , aKey ]! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 3/19/2007 20:37'!
at: aKey ifAbsent: anErrorBlock
	| result |
	result := table at: aKey ifAbsent: [ ^ anErrorBlock value ].
	ageTable at: result put: 0.
	^ result! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey put: aValue
	| removals |
	table at: aKey put: aValue.
	ageTable at: aValue put: 0.
	removals := OrderedCollection new.
	ageTable associationsDo: [ :assoc |
		assoc value > max
			ifTrue: [ removals add: assoc key ]
			ifFalse: [ assoc value: assoc value + 1 ] ].
	removals do: [ :each | self remove: each ]! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max := aNumber! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'jf 8/30/2008 16:31'!
initialize
	super initialize.
	max := 20.
	table := Dictionary new.
	ageTable := Dictionary new! !

!WALRUCache methodsFor: 'testing' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'callbacks' stamp: 'lr 8/30/2008 16:22'!
nextKey
	| key |
	[ table includesKey: (key := WAExternalID new seasideString) ] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'removing' stamp: 'lr 10/28/2007 14:42'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'callbacks' stamp: 'lr 3/19/2007 20:43'!
store: anObject
	| key |
	key := self nextKey.
	self at: key put: anObject.
	^ key! !

WAObject subclass: #WALibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

WALibrary class
	instanceVariableNames: 'default'!

!WALibrary commentStamp: 'pmm 4/22/2007 12:56' prior: 0!
I'm the common superclass of file and string libraries.!

WALibrary class
	instanceVariableNames: 'default'!

WALibrary subclass: #WAFileLibrary
	instanceVariableNames: ''
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAFileLibrary commentStamp: 'pmm 8/17/2007 06:58' prior: 0!
What does FileLibrary do
=============================
It allows to serve static files directly from seaside without the need for a standalone server like Apache or to configure Kom. These files can reference each other (say a CSS references an image) and can be distrubuted the same way as normal Smalltalk code (Monticello, SqueakMap, ...).

Each file in a file library is represented by a method. The method name is created from the file name, the dot is removed and the first letter of the suffix in capitalized. This puts certain limitations to the allowed filenames. Eg. 'main.css' becomes #mainCss.

Like Script- and StyleLibraries FileLibraries can be added to an application so that they automatically include themselves in the document root. Implement #selectorsToInclude and return the selectors you whish to be added to the document root.

How to create a FileLibrary
================================
- First create the static files and put them in some directory. From there they can reference the other files in the same directory normally with their filenames.
- Make sure you have a "Files" entry that serves your files. This is a normal entry point type that you can find in your /seaside/config application. If you don't already have one, you can create it if you select "Files" in the type field of the "add entry point" dialog. For the rest of this text we assume you chose "files" as the path.
- Create a subclass of WAFileLibrary, for the rest of this text I assume its name is MyFileLibrary.
- To add the files to your file library there are two ways.
1. Programmatically with MyFileLibrary class >> #addAllFilesIn: / #addFileNamed:. For example MyFileLibrary addAllFilesIn: '/path/to/directory/with/files' or MyFileLibrary addFileNamed: '/path/to/background.png'.
2. Via the web interface. Go to your /seaside/config application and there click configure for your "Files". Click "configure" behind MyFileLibrary. There you can add a file by uploading it (select the file, then click "Add")

Note that a "Files" can consist of several file libraries and can even have tradional script or style libraries.

How to integrate a FileLibrary into your application
=============================================================
Files from a FileLibrary are ingetrated the same way other static files are integrated. They have a constant path that is '/seaside/<Static File Library>/<FileLibrary class name>/<filename>' so for example '/seaside/files/MyFileLibrary/background.png'. These can be conveniently generated by 'MyFileLibrary / #aSelector' where #aSelector is the name of the method representing that file. For example 'MyFileLibrary / #backgroundPng'.

How to get back the files in a FileLibrary
=================================================
The contents of a file library can be written out to disk. Writing out a file library first makes a folder with the name of the file library in the folder of your Smallatlk image. Then a file for each file in the file library is created in this folder. Writing out to disk can happen in three ways
1. MyFileLibrary default deployFiles
2. Via the configuration interface of the file library. On the same page where you can add files to your file library there is also a button 'write to disk' which will write out all the files in this library.
3. Via the configuration interface of your application. In the section where you can add libraries to your application there is a a button 'write to disk' which will write out all the libraries of this application.

Examples:
==========

The following code uses WAFileLibrary to add a CSS file to a page.

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: WAFileLibraryDemo / #mainCss
		
The folllowing code uses WAFileLibrary to display an image.

renderContentOn: html
	html image
		url: WAFileLibraryDemo / #mainJpg!

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/27/2007 20:35'!
/ aSymbol
	^self urlOf: aSymbol! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/4/2006 20:31'!
addAllFilesIn: aPathString
	"adds all files in the directory specified by aPathString to the current file library"
	(SeasidePlatformSupport filesIn: aPathString)
		do: [ :each | self addFileAt: each ]! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/5/2006 18:29'!
addFileAt: aPath
	"adds the file specified by aFilename to the current file library"
	self
		addFileAt: aPath
		contents: (SeasidePlatformSupport
			contentsOfFile: aPath
			binary: (self isBinaryAt: aPath))! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/4/2006 20:29'!
addFileAt: aPath contents: aByteArrayOrString
	self
		addFileNamed: (SeasidePlatformSupport localNameOf: aPath)
		contents: aByteArrayOrString! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
addFileNamed: aFilename contents: aByteArrayOrString
	| selector |
	selector := self asSelector: aFilename.
	(self isBinary: aFilename)
		ifTrue: [ self compileBinary: aByteArrayOrString selector: selector ]
		ifFalse: [ self compileText: aByteArrayOrString selector: selector ]! !

!WAFileLibrary class methodsFor: 'vw port-squeak' stamp: 'lr 10/28/2007 14:42'!
adjustForVisualWorks
	| newSource oldSource badCode goodCode |
	badCode := 'xxxCache := #(nil).'.
	goodCode := 'xxxCache := #(nil) beMutable.'.
	self selectors do: [:selector |
		oldSource := self sourceCodeAt: selector.
		(oldSource indexOfSubCollection: badCode startingAt: 1) > 0 ifTrue:
			[newSource := oldSource copyReplaceAll: badCode with: goodCode.
			self compile: newSource classified: self methodCategory]]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 2/23/2008 18:25'!
asSelector: aFilename
	| mainPart extension |
	mainPart := (aFilename copyUpToLast: $.)
		select: [ :each | each isAlphaNumeric ].
	[ mainPart first isDigit ]
		whileTrue: [ mainPart := mainPart allButFirst ].
	extension := (aFilename copyAfterLast: $.) asLowercase capitalized.
	^ (mainPart , extension) asSymbol! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 5/22/2007 22:08'!
compileBinary: aByteArrayOrString selector: aSymbol
	"compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a byte array"
	| code |
	code := SeasidePlatformSupport asMethodReturningByteArray: aByteArrayOrString named: aSymbol.
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 8/31/2008 14:31'!
compileText: aByteArrayOrString selector: aSymbol 
	"Compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a string literal.
	aSymbol
		^ aByteArrayOrString"
	| code |
	code := String streamContents: [ :stream | 
		stream
			nextPutAll: aSymbol;
			cr.
		stream
			tab;
			nextPutAll: '^ '''.
		aByteArrayOrString seasideString do: [ :each | 
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	SeasidePlatformSupport 
		compile: code
		into: self
		classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 4/20/2006 20:52'!
defaultMimeType
	^ 'application/octet-stream'! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 9/6/2007 22:27'!
defaultMimeTypes
	^ #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash'

	)! !

!WAFileLibrary class methodsFor: 'class initialization' stamp: 'pmm 9/6/2007 22:28'!
initialize
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 1/4/2008 15:04'!
isBinary: aFilename
	^(self mimetypeFor: (aFilename copyAfterLast: $.)) isBinary! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
isBinaryAt: aPath
	^self isBinary: (SeasidePlatformSupport localNameOf: aPath)! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 4/7/2007 00:58'!
methodCategory
	"the method category for uploaded files"
	^#uploaded! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'jf 9/22/2008 12:23'!
mimetypeFor: aString
	^ (self mimetypes at: aString ifAbsent: [ self defaultMimeType ]) seasideMimeType! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:51'!
mimetypes
	^ MimeTypes! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/13/2007 18:03'!
register
	"no longer needed left in so that code can still be loaded since it is sent in class side initialize methods"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:01'!
unregister
	"no longer used"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'jf 8/30/2008 19:33'!
urlOf: aSymbol
	^self default urlOf: aSymbol! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
addFile: aFile
	"adds a file to the receiver

	aFile an instance of of WAFile"
	| contents |
	aFile isNil ifTrue: [ ^self "in case no file was selected for uploading" ].

	contents := (self class isBinary: aFile fileName)
		ifTrue: [ aFile contents ]
		ifFalse: [ SeasidePlatformSupport convertToSmalltalkNewlines: aFile contents ].
	self class addFileNamed: aFile fileName contents: contents! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 8/31/2008 14:31'!
asFilename: aSelector 
	| dotIndex extension |
	dotIndex := self lastUpperCaseIndexIn: aSelector.
	dotIndex = 0 ifTrue: [
		"convert Symbol to String"
		^ aSelector seasideString ].
	extension := (aSelector last: aSelector size - dotIndex + 1) asLowercase.
	^ (aSelector first: dotIndex - 1), '.', extension! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
asSelector: aFilename
	^ self class asSelector: aFilename! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileBinary: aString selector: aSymbol
	^self class compileBinary: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileText: aString selector: aSymbol
	self class compileText: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:21'!
fileSelectors
	^ (self class selectors
		select: [ :each | self isFileSelector: each ])
		removeAllFoundIn: self nonFileSelectors;
		yourself! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
isFileSelector: aSymbol
	^ aSymbol isUnary and: [ (self lastUpperCaseIndexIn: aSymbol) > 1 ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:28'!
lastUpperCaseIndexIn: aString
	^ aString findLast: [ :each | each isUppercase ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:18'!
mimetypeForFile: aFilename
	^self class mimetypeFor: (aFilename copyAfterLast: $.)! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:17'!
nonFileSelectors
	^#(
		nonFileSelectors
		selectorsToInclude
	)! !

!WAFileLibrary methodsFor: 'actions' stamp: 'pmm 4/21/2006 23:57'!
removeFile: aFilename
	SeasidePlatformSupport
		removeSelector: (self asSelector: aFilename)
		from: self class! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
renameFile: oldName to: newName
	| contents file |
	(self asSelector: oldName) = (self asSelector: newName)
		ifTrue: [ ^ nil ].
	contents := self perform: (self asSelector: oldName).
	file := WAFile new contents: contents.
	file fileName: newName.
	self addFile: file.
	self removeFile: oldName! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selectorsToInclude
	"The files represented by the selectors this method returns will be automatically added to the html <head> if the receiver is added to the respective Seaside application.

	This makes only sense for CSS and JS files"
	^ #()! !

!WAFileLibrary methodsFor: 'processing' stamp: 'lr 4/9/2007 11:06'!
updateRoot: aHtmlRoot
	"Only override if you want to automatically include new types of resources. The default implementation knows how to reference CSS, JS and FavIcons into aHtmlRoot."

	self selectorsToInclude do: [ :each |
		(each endsWith: #Js)
			ifTrue: [ aHtmlRoot javascript url: (self urlOf: each) ].
		(each endsWith: #Ico)
			ifTrue: [ aHtmlRoot link beShortcutIcon; url: (self urlOf: each) ].
		(each endsWith: #Css)
			ifTrue: [ aHtmlRoot stylesheet url: (self urlOf: each) ] ]! !

WAFileLibrary subclass: #WAStandardFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAStandardFiles commentStamp: 'lr 6/5/2007 19:29' prior: 0!
A collection of standard scripts, styles, and images. They are needed for the configuration application and some basic look-and-feel in Seaside. The icons are from the Tango Desktop Project (tango.freedesktop.org), they are licensed under the Creative Commons Attribution Share-Alike license.!

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'pmm 2/13/2007 19:16'!
externalAnchorsJs
	^ '// See http://www.sitepoint.com/article/standards-compliant-world
function externalLinks() {
	if (!!document.getElementsByTagName) return;
	var anchors = document.getElementsByTagName("a");
	for (var i=0; i<anchors.length; i++) {
	var anchor = anchors[i];
	if (anchor.getAttribute("href") && anchor.getAttribute("rel") == "external")
		anchor.target = "_blank";
	}
}'! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'lr 10/28/2007 14:42'!
kalseyTabsCss
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}


.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'lr 10/28/2007 14:42'!
miscJs
	^ '
	function swapDisplay(a, b) {
		var tmp = document.getElementById(a).style.display;
		document.getElementById(a).style.display = document.getElementById(b).style.display;
		document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey, value) {
		if (value)
			{
				var ele = document.createElement("input");
				ele.type = "hidden";
				ele.name = callbackKey;
				ele.value = value;
				document.forms[formName].appendChild(ele)
			}
		submitForm(formName)
	}

	function submitForm(formName) {
		document.forms[formName].submit();
	}

	function chooseOther(select, hiddenId, p) {
		value = prompt(p);
		document.getElementById(hiddenId).value = value;
		select.options[select.options.length-1].text = value;
	}

	function enableChoice(enableID, disableID) {
		document.getElementById(enableID).disabled = false;
		document.getElementById(disableID).disabled = true;
	}

	function setFocus(elementId) {
		document.getElementById(elementId).focus();
	}

	function setSelection(elementId, start, stop) {
		var input = document.getElementById(elementId);
		input.focus();
		/* When stop parameter not supplied, all field is selected */
		if (!!start) start = 1;
		if (!!stop) stop = input.value.length + 1;
		if (typeof document.selection !!= "undefined") {
	    		/* Place selection in MS-IE */
	    		var range = document.selection.createRange();
	     	range.moveStart("character", start - 1);
	     	range.moveEnd("character", stop - start);
	 		range.select();
	  	} else if (typeof input.selectionStart !!= "undefined") {
		  	/* Place selection in Gecko browsers */
	    		input.selectionStart = start - 1;
	    		input.selectionEnd = stop - 1;
	  	} else {
	  		/* Other browsers, please feel free to implement */
			alert("unknown browser");
		}
	}

'! !

!WAStandardFiles methodsFor: 'accessing' stamp: 'MAD 8/29/2008 16:43'!
selectorsToInclude
	^#(
		windowCss

		kalseyTabsCss
		externalAnchorsJs
		miscJs
		shortcutsJs
	)! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'lr 10/28/2007 14:42'!
shortcutsJs
	^ '

	var shortcutKeys = [];
	var shortcutElements = [];

	function resetShortcuts() {
		shortcutKeys = [];
		shortcutElements = [];
	}

	function addShortcut(shortcut, elementID) {
		var elem = document.getElementById(elementID);
		if ((elem.tagName == "INPUT" & (elem.type == "submit" || elem.type == "checkbox" || elem.type == "radio")) || elem.tagName == "A")
			{
			shortcutKeys[shortcutKeys.length] = shortcut;
			shortcutElements[shortcutElements.length] = elem;
			}
		else alert("Attempt to assign a shortcut (" + shortcut + ") to something that is not clickable");
	}

	function onKeyDown(event) {
		var keyname = "";
		var element;
		var nav;
		if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
		else if (navigator.product == "Gecko")
			nav = "Gecko";
		else
			nav = "IE";
		// cope with MS-IE
		if (event == null) event = window.event;
		if (event) {
			if (event.ctrlKey) keyname = keyname + "Ctrl-";
			if (event.altKey) keyname = keyname + "Alt-";
			if (event.metaKey) keyname = keyname + "Meta-";
			// cope with Netscape
			var keyCode = event.which;
			if (keyCode == null) keyCode = event.keyCode;
			if (keyCode == null) keyCode = event.charCode;
			if (keyCode !!= 0) {
				var character = String.fromCharCode(keyCode);
				character = character.toLowerCase();
				if (event.shiftKey) character = character.toUpperCase();
				// cope with special keys, designated with some logical names
				if (keyCode == 27) character = "Esc";
				if (keyCode == 8) character = "Backspace";
				if (keyCode == 9) character = "Tab";
				if (keyCode == 13) character = "Return";
				if (keyCode == 37) character = "Left";
				if (keyCode == 38) character = "Up";
				if (keyCode == 39) character = "Right";
				if (keyCode == 40) character = "Down";
				// cope with func-keys (some keys not intercepted for MS-IE)
				if ((keyCode >= 112) & (keyCode <= 123)) character = "F" + (keyCode - 112 + 1);
				for ( var x = 1 ; x <= shortcutKeys.length ; x++ ) {
					if (shortcutKeys[x-1] == keyname+character) {
						// alert("key=" + keyCode + " " + keyname + character);
						element = shortcutElements[x-1];
						if (element.tagName == "A" & nav !!= "IE") {
							if (element.onclick)
								element.onclick.call();
							else
								/* This does not work for anchor in IE */
								location.href = element.href;
						} else  {
							element.click();
						}
					}
				}
				return false;
			}
		}
	}

'! !

!WAStandardFiles methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot bodyAttributes
		at: 'onkeydown'
		put: 'onKeyDown(event)'! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'MAD 8/29/2008 19:38'!
windowCss
	^ '.window {
	border: 1px solid #aaa;
}
.window .window-titlebar {
	color: #444;
	padding: 5px;
	overflow: hidden;
	background-color: #eee;
	border-bottom: 1px solid #aaa;
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
}
.window .window-titlebar .window-title {
	float: left;
	font-weight: bold;
	padding-left: 20px;
}
.window .window-titlebar .window-close {
	float: right;
}
.window .window-titlebar .window-close a {
	color: #444;
	text-decoration: none;
}
.window .window-titlebar .window-close a:hover {
	color: #111;
}
.window .window-content {
	clear: both;
	padding: 2px;
}'! !

!WALibrary class methodsFor: 'instance-creation' stamp: 'pmm 4/6/2007 13:27'!
default
	^ default ifNil: [ default := self new ]! !

!WALibrary class methodsFor: 'actions' stamp: 'pmm 8/14/2007 07:21'!
deployFiles
	^self default deployFiles! !

!WALibrary class methodsFor: 'accessing' stamp: 'pmm 7/21/2007 23:19'!
documentAt: aFilename ifAbsent: aBlock
	^self default
		documentAt: aFilename
		ifAbsent: aBlock! !

!WALibrary class methodsFor: 'testing' stamp: 'pmm 7/20/2007 06:56'!
handlesFolder: aSymbol
	^self name = aSymbol! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asFilename: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asSelector: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'pmm 9/11/2008 07:33'!
cacheDuration
	"ansers the duration the response should be cached by the user agent"
	^Duration days: 0 hours: 0 minutes: 30 seconds: 0! !

!WALibrary methodsFor: 'actions' stamp: 'pmm 8/14/2007 19:34'!
deployFiles
	"Write to disk the files that the receiver use to serve as methods.
	The files are stored in a subfolder named like the classname of the receiver in a subfolder of Smalltalk image folder."
	SeasidePlatformSupport ensureExistenceOfFolder: self name.
	self fileSelectors do: [ :each |
		SeasidePlatformSupport
			write: (self perform: each)
			toFile: (self asFilename: each)
			inFolder: self name ]! !

!WALibrary methodsFor: 'accessing' stamp: 'pmm 9/11/2008 07:34'!
documentAt: aFilename ifAbsent: aBlock
	| selector |
	selector := self asSelector: aFilename.
	^(self fileSelectors includes: selector)
		ifTrue: [ (WAResponse
			document: (self documentForFile: aFilename)
			mimeType: (self mimetypeForFile: aFilename))
			cacheFor: self cacheDuration;
			yourself ]
		ifFalse: [ aBlock value ]! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:17'!
documentForFile: aFilename
	^self perform: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
fileSelectors
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:20'!
filenames
	^ self fileSelectors collect: [ :each | self asFilename: each ]! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:24'!
mimetypeForFile: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:21'!
name
	^ self class name! !

!WALibrary methodsFor: 'processing' stamp: 'mb 2/23/2007 10:29'!
updateRoot: anHtmlRoot! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlForFile: aFilename
	^ self urlOf: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol
	^ self urlOf: aSymbol using: WAFileHandler default! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol using: aHandler
	^ aHandler baseUrl
		addToPath: self className;
		addToPath: (self asFilename: aSymbol);
		yourself! !

WAObject subclass: #WALocale
	instanceVariableNames: 'language country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

WALocale class
	instanceVariableNames: 'iso2Languages iso3Languages iso2Countries iso3Countries'!

!WALocale commentStamp: 'pmm 6/1/2008 11:58' prior: 0!
A WALocale definces a users langauge and country.

Instance Variables
	country:		<String>
	language:		<String>

country
	- either an ISO 2 or ISO 3 country code

language
	- either an ISO 2 or ISO 3 language code
!

WALocale class
	instanceVariableNames: 'iso2Languages iso3Languages iso2Countries iso3Countries'!

!WALocale class methodsFor: 'accessing' stamp: ''!
countryList
	^#(('AF' 'AFG' 'AFGHANISTAN') ('AL' 'ALB' 'ALBANIA') ('DZ' 'DZA' 'ALGERIA') ('AS' 'ASM' 'AMERICAN SAMOA') ('AD' 'AND' 'ANDORRA') ('AO' 'AGO' 'ANGOLA') ('AI' 'AIA' 'ANGUILLA') ('AQ' 'ATA' 'ANTARCTICA') ('AG' 'ATG' 'ANTIGUA AND BARBUDA') ('AR' 'ARG' 'ARGENTINA') ('AM' 'ARM' 'ARMENIA') ('AW' 'ABW' 'ARUBA') ('AU' 'AUS' 'AUSTRALIA') ('AT' 'AUT' 'AUSTRIA') ('AZ' 'AZE' 'AZERBAIJAN') ('BS' 'BHS' 'BAHAMAS') ('BH' 'BHR' 'BAHRAIN') ('BD' 'BGD' 'BANGLADESH') ('BB' 'BRB' 'BARBADOS') ('BY' 'BLR' 'BELARUS') ('BE' 'BEL' 'BELGIUM') ('BZ' 'BLZ' 'BELIZE') ('BJ' 'BEN' 'BENIN') ('BM' 'BMU' 'BERMUDA') ('BT' 'BTN' 'BHUTAN') ('BO' 'BOL' 'BOLIVIA') ('BA' 'BIH' 'BOSNIA AND HERZEGOWINA') ('BW' 'BWA' 'BOTSWANA') ('BV' 'BVT' 'BOUVET ISLAND') ('BR' 'BRA' 'BRAZIL') ('IO' 'IOT' 'BRITISH INDIAN OCEAN TERRITORY') ('BN' 'BRN' 'BRUNEI DARUSSALAM') ('BG' 'BGR' 'BULGARIA') ('BF' 'BFA' 'BURKINA FASO') ('BI' 'BDI' 'BURUNDI') ('KH' 'KHM' 'CAMBODIA') ('CM' 'CMR' 'CAMEROON') ('CA' 'CAN' 'CANADA') ('CV' 'CPV' 'CAPE VERDE') ('KY' 'CYM' 'CAYMAN ISLANDS') ('CF' 'CAF' 'CENTRAL AFRICAN REPUBLIC') ('TD' 'TCD' 'CHAD') ('CL' 'CHL' 'CHILE') ('CN' 'CHN' 'CHINA') ('CX' 'CXR' 'CHRISTMAS ISLAND') ('CC' 'CCK' 'COCOS (KEELING) ISLANDS') ('CO' 'COL' 'COLOMBIA') ('KM' 'COM' 'COMOROS') ('CG' 'COG' 'CONGO') ('CK' 'COK' 'COOK ISLANDS') ('CR' 'CRI' 'COSTA RICA') ('CI' 'CIV' 'COTE D''IVOIRE') ('HR' 'HRV' 'CROATIA (local name: Hrvatska)') ('CU' 'CUB' 'CUBA') ('CY' 'CYP' 'CYPRUS') ('CZ' 'CZE' 'CZECH REPUBLIC') ('DK' 'DNK' 'DENMARK') ('DJ' 'DJI' 'DJIBOUTI') ('DM' 'DMA' 'DOMINICA') ('DO' 'DOM' 'DOMINICAN REPUBLIC') ('TP' 'TMP' 'EAST TIMOR') ('EC' 'ECU' 'ECUADOR') ('EG' 'EGY' 'EGYPT') ('SV' 'SLV' 'EL SALVADOR') ('GQ' 'GNQ' 'EQUATORIAL GUINEA') ('ER' '   ' 'ERITREA') ('EE' 'EST' 'ESTONIA') ('ET' 'ETH' 'ETHIOPIA') ('FK' 'FLK' 'FALKLAND ISLANDS (MALVINAS)') ('FO' 'FRO' 'FAROE ISLANDS') ('FJ' 'FJI' 'FIJI') ('FI' 'FIN' 'FINLAND') ('FR' 'FRA' 'FRANCE') ('FX' 'FXX' 'FRANCE, METROPOLITAN') ('GF' 'GUF' 'FRENCH GUIANA') ('PF' 'PYF' 'FRENCH POLYNESIA') ('TF' 'ATF' 'FRENCH SOUTHERN TERRITORIES') ('GA' 'GAB' 'GABON') ('GM' 'GMB' 'GAMBIA') ('GE' 'GEO' 'GEORGIA') ('DE' 'DEU' 'GERMANY') ('GH' 'GHA' 'GHANA') ('GI' 'GIB' 'GIBRALTAR') ('GR' 'GRC' 'GREECE') ('GL' 'GRL' 'GREENLAND') ('GD' 'GRD' 'GRENADA') ('GP' 'GLP' 'GUADELOUPE') ('GU' 'GUM' 'GUAM') ('GT' 'GTM' 'GUATEMALA') ('GN' 'GIN' 'GUINEA') ('GW' 'GNB' 'GUINEA-BISSAU') ('GY' 'GUY' 'GUYANA') ('HT' 'HTI' 'HAITI') ('HM' 'HMD' 'HEARD AND MC DONALD ISLANDS') ('VA' 'VAT' 'HOLY SEE (VATICAN CITY STATE)') ('HN' 'HND' 'HONDURAS') ('HK' 'HKG' 'HONG KONG') ('HU' 'HUN' 'HUNGARY') ('IS' 'ISL' 'ICELAND') ('IN' 'IND' 'INDIA') ('ID' 'IDN' 'INDONESIA') ('IR' 'IRN' 'IRAN (ISLAMIC REPUBLIC OF)') ('IQ' 'IRQ' 'IRAQ') ('IE' 'IRL' 'IRELAND') ('IL' 'ISR' 'ISRAEL') ('IT' 'ITA' 'ITALY') ('JM' 'JAM' 'JAMAICA') ('JP' 'JPN' 'JAPAN') ('JO' 'JOR' 'JORDAN') ('KZ' 'KAZ' 'KAZAKHSTAN') ('KE' 'KEN' 'KENYA') ('KI' 'KIR' 'KIRIBATI') ('KP' 'PRK' 'KOREA, DEMOCRATIC PEOPLE''S REPUBLIC OF') ('KR' 'KOR' 'KOREA, REPUBLIC OF') ('KW' 'KWT' 'KUWAIT') ('KG' 'KGZ' 'KYRGYZSTAN') ('LA' 'LAO' 'LAO PEOPLE''S DEMOCRATIC REPUBLIC') ('LV' 'LVA' 'LATVIA') ('LB' 'LBN' 'LEBANON') ('LS' 'LSO' 'LESOTHO') ('LR' 'LBR' 'LIBERIA') ('LY' 'LBY' 'LIBYAN ARAB JAMAHIRIYA') ('LI' 'LIE' 'LIECHTENSTEIN') ('LT' 'LTU' 'LITHUANIA') ('LU' 'LUX' 'LUXEMBOURG') ('MO' 'MAC' 'MACAU') ('MK' 'MKD' 'MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF') ('MG' 'MDG' 'MADAGASCAR') ('MW' 'MWI' 'MALAWI') ('MY' 'MYS' 'MALAYSIA') ('MV' 'MDV' 'MALDIVES') ('ML' 'MLI' 'MALI') ('MT' 'MLT' 'MALTA') ('MH' 'MHL' 'MARSHALL ISLANDS') ('MQ' 'MTQ' 'MARTINIQUE') ('MR' 'MRT' 'MAURITANIA') ('MU' 'MUS' 'MAURITIUS') ('YT' 'MYT' 'MAYOTTE') ('MX' 'MEX' 'MEXICO') ('FM' 'FSM' 'MICRONESIA, FEDERATED STATES OF') ('MD' 'MDA' 'MOLDOVA, REPUBLIC OF') ('MC' 'MCO' 'MONACO') ('MN' 'MNG' 'MONGOLIA') ('MS' 'MSR' 'MONTSERRAT') ('MA' 'MAR' 'MOROCCO') ('MZ' 'MOZ' 'MOZAMBIQUE') ('MM' 'MMR' 'MYANMAR') ('NA' 'NAM' 'NAMIBIA') ('NR' 'NRU' 'NAURU') ('NP' 'NPL' 'NEPAL') ('NL' 'NLD' 'NETHERLANDS') ('AN' 'ANT' 'NETHERLANDS ANTILLES') ('NC' 'NCL' 'NEW CALEDONIA') ('NZ' 'NZL' 'NEW ZEALAND') ('NI' 'NIC' 'NICARAGUA') ('NE' 'NER' 'NIGER') ('NG' 'NGA' 'NIGERIA') ('NU' 'NIU' 'NIUE') ('NF' 'NFK' 'NORFOLK ISLAND') ('MP' 'MNP' 'NORTHERN MARIANA ISLANDS') ('NO' 'NOR' 'NORWAY') ('OM' 'OMN' 'OMAN') ('PK' 'PAK' 'PAKISTAN') ('PW' 'PLW' 'PALAU') ('PA' 'PAN' 'PANAMA') ('PG' 'PNG' 'PAPUA NEW GUINEA') ('PY' 'PRY' 'PARAGUAY') ('PE' 'PER' 'PERU') ('PH' 'PHL' 'PHILIPPINES') ('PN' 'PCN' 'PITCAIRN') ('PL' 'POL' 'POLAND') ('PT' 'PRT' 'PORTUGAL') ('PR' 'PRI' 'PUERTO RICO') ('QA' 'QAT' 'QATAR') ('RE' 'REU' 'REUNION') ('RO' 'ROM' 'ROMANIA') ('RU' 'RUS' 'RUSSIAN FEDERATION') ('RW' 'RWA' 'RWANDA') ('KN' 'KNA' 'SAINT KITTS AND NEVIS') ('LC' 'LCA' 'SAINT LUCIA') ('VC' 'VCT' 'SAINT VINCENT AND THE GRENADINES') ('WS' 'WSM' 'SAMOA') ('SM' 'SMR' 'SAN MARINO') ('ST' 'STP' 'SAO TOME AND PRINCIPE') ('SA' 'SAU' 'SAUDI ARABIA') ('SN' 'SEN' 'SENEGAL') ('SC' 'SYC' 'SEYCHELLES') ('SL' 'SLE' 'SIERRA LEONE') ('SG' 'SGP' 'SINGAPORE') ('SK' 'SVK' 'SLOVAKIA (Slovak Republic)') ('SI' 'SVN' 'SLOVENIA') ('SB' 'SLB' 'SOLOMON ISLANDS') ('SO' 'SOM' 'SOMALIA') ('ZA' 'ZAF' 'SOUTH AFRICA') ('GS' 'SGS' 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS') ('ES' 'ESP' 'SPAIN') ('LK' 'LKA' 'SRI LANKA') ('SH' 'SHN' 'ST. HELENA') ('PM' 'SPM' 'ST. PIERRE AND MIQUELON') ('SD' 'SDN' 'SUDAN') ('SR' 'SUR' 'SURINAME') ('SJ' 'SJM' 'SVALBARD AND JAN MAYEN ISLANDS') ('SZ' 'SWZ' 'SWAZILAND') ('SE' 'SWE' 'SWEDEN') ('CH' 'CHE' 'SWITZERLAND') ('SY' 'SYR' 'SYRIAN ARAB REPUBLIC') ('TW' 'TWN' 'TAIWAN, PROVINCE OF CHINA') ('TJ' 'TJK' 'TAJIKISTAN') ('TZ' 'TZA' 'TANZANIA, UNITED REPUBLIC OF') ('TH' 'THA' 'THAILAND') ('TG' 'TGO' 'TOGO') ('TK' 'TKL' 'TOKELAU') ('TO' 'TON' 'TONGA') ('TT' 'TTO' 'TRINIDAD AND TOBAGO') ('TN' 'TUN' 'TUNISIA') ('TR' 'TUR' 'TURKEY') ('TM' 'TKM' 'TURKMENISTAN') ('TC' 'TCA' 'TURKS AND CAICOS ISLANDS') ('TV' 'TUV' 'TUVALU') ('UG' 'UGA' 'UGANDA') ('UA' 'UKR' 'UKRAINE') ('AE' 'ARE' 'UNITED ARAB EMIRATES') ('GB' 'GBR' 'UNITED KINGDOM') ('US' 'USA' 'UNITED STATES') ('UM' 'UMI' 'UNITED STATES MINOR OUTLYING ISLANDS') ('UY' 'URY' 'URUGUAY') ('UZ' 'UZB' 'UZBEKISTAN') ('VU' 'VUT' 'VANUATU') ('VE' 'VEN' 'VENEZUELA') ('VN' 'VNM' 'VIET NAM') ('VG' 'VGB' 'VIRGIN ISLANDS (BRITISH)') ('VI' 'VIR' 'VIRGIN ISLANDS (U.S.)') ('WF' 'WLF' 'WALLIS AND FUTUNA ISLANDS') ('EH' 'ESH' 'WESTERN SAHARA') ('YE' 'YEM' 'YEMEN') ('YU' 'YUG' 'YUGOSLAVIA') ('ZR' 'ZAR' 'ZAIRE') ('ZM' 'ZMB' 'ZAMBIA') ('ZW' 'ZWE' 'ZIMBABWE'))! !

!WALocale class methodsFor: 'instance creation' stamp: 'pmm 1/4/2008 14:47'!
fromString: aString
	| language country delimeter |
	delimeter := (aString includes: $_)
		ifTrue: [ $_ ]
		ifFalse: [ $- ].
	language := aString copyUpTo: delimeter.
	country := aString copyAfter: delimeter.
	country isEmpty ifTrue: [ country := nil ].
	^self
		language: language
		country: country! !

!WALocale class methodsFor: 'class initialization' stamp: 'pmm 3/16/2008 12:50'!
initialize
	self initializeLangaugeList.
	self initializeCountryList! !

!WALocale class methodsFor: 'class initialization' stamp: 'lr 3/29/2008 14:47'!
initializeCountryList
	iso2Countries := Dictionary new.
	iso3Countries := Dictionary new.
	self countryList do: [ :each |
		iso2Countries
			at: each first
			put: each third.
		iso3Countries
			at: each second
			put: each third ]! !

!WALocale class methodsFor: 'class initialization' stamp: 'pmm 3/16/2008 12:50'!
initializeLangaugeList
	iso2Languages := Dictionary new.
	iso3Languages := Dictionary new.
	
	self languageList do: [ :each |
		each size > 2
			ifTrue: [
				iso2Languages at: each first put: each third.
				iso3Languages at: each second put: each third ]
			ifFalse: [
				iso3Languages at: each first put: each second ] ]! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:36'!
iso2Countries
	^iso2Countries! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:04'!
iso2Languages
	^iso2Languages! !

!WALocale class methodsFor: 'accessing' stamp: 'lr 3/29/2008 14:50'!
iso3Countries
	^iso3Countries! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:04'!
iso3Languages
	^iso3Languages! !

!WALocale class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 13:16'!
language: aLanguageString country: aCounryString
	^self new
		language: aLanguageString;
		country: aCounryString;
		yourself! !

!WALocale class methodsFor: 'accessing' stamp: ''!
languageList
	^#(('aa' 'aar' 'Afar') ('ab' 'abk' 'Abkhazian') ('ace' 'Achinese') ('ach' 'Acoli') ('ada' 'Adangme') ('ady' 'Adyghe; Adygei') ('afa' 'Afro-Asiatic (Other)') ('afh' 'Afrihili') ('af' 'afr' 'Afrikaans') ('ain' 'Ainu') ('ak' 'aka' 'Akan') ('akk' 'Akkadian') ('sq' 'alb' 'Albanian') ('ale' 'Aleut') ('alg' 'Algonquian languages') ('alt' 'Southern Altai') ('am' 'amh' 'Amharic') ('ang' 'English, Old (ca.450-1100)') ('anp' 'Angika') ('apa' 'Apache languages') ('ar' 'ara' 'Arabic') ('arc' 'Official Aramaic (700-300 BCE); Imperial Aramaic (700-300 BCE)') ('an' 'arg' 'Aragonese') ('hy' 'arm' 'Armenian') ('arn' 'Mapudungun; Mapuche') ('arp' 'Arapaho') ('art' 'Artificial (Other)') ('arw' 'Arawak') ('as' 'asm' 'Assamese') ('ast' 'Asturian; Bable; Leonese; Asturleonese') ('ath' 'Athapascan languages') ('aus' 'Australian languages') ('av' 'ava' 'Avaric') ('ae' 'ave' 'Avestan') ('awa' 'Awadhi') ('ay' 'aym' 'Aymara') ('az' 'aze' 'Azerbaijani') ('bad' 'Banda languages') ('bai' 'Bamileke languages') ('ba' 'bak' 'Bashkir') ('bal' 'Baluchi') ('bm' 'bam' 'Bambara') ('ban' 'Balinese') ('eu' 'baq' 'Basque') ('bas' 'Basa') ('bat' 'Baltic (Other)') ('bej' 'Beja; Bedawiyet') ('be' 'bel' 'Belarusian') ('bem' 'Bemba') ('bn' 'ben' 'Bengali') ('ber' 'Berber (Other)') ('bho' 'Bhojpuri') ('bh' 'bih' 'Bihari') ('bik' 'Bikol') ('bin' 'Bini; Edo') ('bi' 'bis' 'Bislama') ('bla' 'Siksika') ('bnt' 'Bantu (Other)') ('bs' 'bos' 'Bosnian') ('bra' 'Braj') ('br' 'bre' 'Breton') ('btk' 'Batak languages') ('bua' 'Buriat') ('bug' 'Buginese') ('bg' 'bul' 'Bulgarian') ('my' 'bur' 'Burmese') ('byn' 'Blin; Bilin') ('cad' 'Caddo') ('cai' 'Central American Indian (Other)') ('car' 'Galibi Carib') ('ca' 'cat' 'Catalan; Valencian') ('cau' 'Caucasian (Other)') ('ceb' 'Cebuano') ('cel' 'Celtic (Other)') ('ch' 'cha' 'Chamorro') ('chb' 'Chibcha') ('ce' 'che' 'Chechen') ('chg' 'Chagatai') ('zh' 'chi' 'Chinese') ('chk' 'Chuukese') ('chm' 'Mari') ('chn' 'Chinook jargon') ('cho' 'Choctaw') ('chp' 'Chipewyan; Dene Suline') ('chr' 'Cherokee') ('cu' 'chu' 'Church Slavic; Old Slavonic; Church Slavonic; Old Bulgarian; Old Church Slavonic') ('cv' 'chv' 'Chuvash') ('chy' 'Cheyenne') ('cmc' 'Chamic languages') ('cop' 'Coptic') ('kw' 'cor' 'Cornish') ('co' 'cos' 'Corsican') ('cpe' 'Creoles and pidgins, English based (Other)') ('cpf' 'Creoles and pidgins, French-based (Other)') ('cpp' 'Creoles and pidgins, Portuguese-based (Other)') ('cr' 'cre' 'Cree') ('crh' 'Crimean Tatar; Crimean Turkish') ('crp' 'Creoles and pidgins (Other)') ('csb' 'Kashubian') ('cus' 'Cushitic (Other)') ('cs' 'cze' 'Czech') ('dak' 'Dakota') ('da' 'dan' 'Danish') ('dar' 'Dargwa') ('day' 'Land Dayak languages') ('del' 'Delaware') ('den' 'Slave (Athapascan)') ('dgr' 'Dogrib') ('din' 'Dinka') ('dv' 'div' 'Divehi; Dhivehi; Maldivian') ('doi' 'Dogri') ('dra' 'Dravidian (Other)') ('dsb' 'Lower Sorbian') ('dua' 'Duala') ('dum' 'Dutch, Middle (ca.1050-1350)') ('nl' 'dut' 'Dutch; Flemish') ('dyu' 'Dyula') ('dz' 'dzo' 'Dzongkha') ('efi' 'Efik') ('egy' 'Egyptian (Ancient)') ('eka' 'Ekajuk') ('elx' 'Elamite') ('en' 'eng' 'English') ('enm' 'English, Middle (1100-1500)') ('eo' 'epo' 'Esperanto') ('et' 'est' 'Estonian') ('ee' 'ewe' 'Ewe') ('ewo' 'Ewondo') ('fan' 'Fang') ('fo' 'fao' 'Faroese') ('fat' 'Fanti') ('fj' 'fij' 'Fijian') ('fil' 'Filipino; Pilipino') ('fi' 'fin' 'Finnish') ('fiu' 'Finno-Ugrian (Other)') ('fon' 'Fon') ('fr' 'fre' 'French') ('frm' 'French, Middle (ca.1400-1600)') ('fro' 'French, Old (842-ca.1400)') ('frr' 'Northern Frisian') ('frs' 'Eastern Frisian') ('fy' 'fry' 'Western Frisian') ('ff' 'ful' 'Fulah') ('fur' 'Friulian') ('gaa' 'Ga') ('gay' 'Gayo') ('gba' 'Gbaya') ('gem' 'Germanic (Other)') ('ka' 'geo' 'Georgian') ('de' 'ger' 'German') ('gez' 'Geez') ('gil' 'Gilbertese') ('gd' 'gla' 'Gaelic; Scottish Gaelic') ('ga' 'gle' 'Irish') ('gl' 'glg' 'Galician') ('gv' 'glv' 'Manx') ('gmh' 'German, Middle High (ca.1050-1500)') ('goh' 'German, Old High (ca.750-1050)') ('gon' 'Gondi') ('gor' 'Gorontalo') ('got' 'Gothic') ('grb' 'Grebo') ('grc' 'Greek, Ancient (to 1453)') ('el' 'gre' 'Greek, Modern (1453-)') ('gn' 'grn' 'Guarani') ('gsw' 'Swiss German; Alemannic; Alsatian') ('gu' 'guj' 'Gujarati') ('gwi' 'Gwich''in') ('hai' 'Haida') ('ht' 'hat' 'Haitian; Haitian Creole') ('ha' 'hau' 'Hausa') ('haw' 'Hawaiian') ('he' 'heb' 'Hebrew') ('hz' 'her' 'Herero') ('hil' 'Hiligaynon') ('him' 'Himachali') ('hi' 'hin' 'Hindi') ('hit' 'Hittite') ('hmn' 'Hmong') ('ho' 'hmo' 'Hiri Motu') ('hsb' 'Upper Sorbian') ('hu' 'hun' 'Hungarian') ('hup' 'Hupa') ('iba' 'Iban') ('ig' 'ibo' 'Igbo') ('is' 'ice' 'Icelandic') ('io' 'ido' 'Ido') ('ii' 'iii' 'Sichuan Yi; Nuosu') ('ijo' 'Ijo languages') ('iu' 'iku' 'Inuktitut') ('ie' 'ile' 'Interlingue; Occidental') ('ilo' 'Iloko') ('ia' 'ina' 'Interlingua (International Auxiliary Language Association)') ('inc' 'Indic (Other)') ('id' 'ind' 'Indonesian') ('ine' 'Indo-European (Other)') ('inh' 'Ingush') ('ik' 'ipk' 'Inupiaq') ('ira' 'Iranian (Other)') ('iro' 'Iroquoian languages') ('it' 'ita' 'Italian') ('jv' 'jav' 'Javanese') ('jbo' 'Lojban') ('ja' 'jpn' 'Japanese') ('jpr' 'Judeo-Persian') ('jrb' 'Judeo-Arabic') ('kaa' 'Kara-Kalpak') ('kab' 'Kabyle') ('kac' 'Kachin; Jingpho') ('kl' 'kal' 'Kalaallisut; Greenlandic') ('kam' 'Kamba') ('kn' 'kan' 'Kannada') ('kar' 'Karen languages') ('ks' 'kas' 'Kashmiri') ('kr' 'kau' 'Kanuri') ('kaw' 'Kawi') ('kk' 'kaz' 'Kazakh') ('kbd' 'Kabardian') ('kha' 'Khasi') ('khi' 'Khoisan (Other)') ('km' 'khm' 'Central Khmer') ('kho' 'Khotanese') ('ki' 'kik' 'Kikuyu; Gikuyu') ('rw' 'kin' 'Kinyarwanda') ('ky' 'kir' 'Kirghiz; Kyrgyz') ('kmb' 'Kimbundu') ('kok' 'Konkani') ('kv' 'kom' 'Komi') ('kg' 'kon' 'Kongo') ('ko' 'kor' 'Korean') ('kos' 'Kosraean') ('kpe' 'Kpelle') ('krc' 'Karachay-Balkar') ('krl' 'Karelian') ('kro' 'Kru languages') ('kru' 'Kurukh') ('kj' 'kua' 'Kuanyama; Kwanyama') ('kum' 'Kumyk') ('ku' 'kur' 'Kurdish') ('kut' 'Kutenai') ('lad' 'Ladino') ('lah' 'Lahnda') ('lam' 'Lamba') ('lo' 'lao' 'Lao') ('la' 'lat' 'Latin') ('lv' 'lav' 'Latvian') ('lez' 'Lezghian') ('li' 'lim' 'Limburgan; Limburger; Limburgish') ('ln' 'lin' 'Lingala') ('lt' 'lit' 'Lithuanian') ('lol' 'Mongo') ('loz' 'Lozi') ('lb' 'ltz' 'Luxembourgish; Letzeburgesch') ('lua' 'Luba-Lulua') ('lu' 'lub' 'Luba-Katanga') ('lg' 'lug' 'Ganda') ('lui' 'Luiseno') ('lun' 'Lunda') ('luo' 'Luo (Kenya and Tanzania)') ('lus' 'Lushai') ('mk' 'mac' 'Macedonian') ('mad' 'Madurese') ('mag' 'Magahi') ('mh' 'mah' 'Marshallese') ('mai' 'Maithili') ('mak' 'Makasar') ('ml' 'mal' 'Malayalam') ('man' 'Mandingo') ('mi' 'mao' 'Maori') ('map' 'Austronesian (Other)') ('mr' 'mar' 'Marathi') ('mas' 'Masai') ('ms' 'may' 'Malay') ('mdf' 'Moksha') ('mdr' 'Mandar') ('men' 'Mende') ('mga' 'Irish, Middle (900-1200)') ('mic' 'Mi''kmaq; Micmac') ('min' 'Minangkabau') ('mis' 'Uncoded languages') ('mkh' 'Mon-Khmer (Other)') ('mg' 'mlg' 'Malagasy') ('mt' 'mlt' 'Maltese') ('mnc' 'Manchu') ('mni' 'Manipuri') ('mno' 'Manobo languages') ('moh' 'Mohawk') ('mo' 'mol' 'Moldavian') ('mn' 'mon' 'Mongolian') ('mos' 'Mossi') ('mul' 'Multiple languages') ('mun' 'Munda languages') ('mus' 'Creek') ('mwl' 'Mirandese') ('mwr' 'Marwari') ('myn' 'Mayan languages') ('myv' 'Erzya') ('nah' 'Nahuatl languages') ('nai' 'North American Indian') ('nap' 'Neapolitan') ('na' 'nau' 'Nauru') ('nv' 'nav' 'Navajo; Navaho') ('nr' 'nbl' 'Ndebele, South; South Ndebele') ('nd' 'nde' 'Ndebele, North; North Ndebele') ('ng' 'ndo' 'Ndonga') ('nds' 'Low German; Low Saxon; German, Low; Saxon, Low') ('ne' 'nep' 'Nepali') ('new' 'Nepal Bhasa; Newari') ('nia' 'Nias') ('nic' 'Niger-Kordofanian (Other)') ('niu' 'Niuean') ('nn' 'nno' 'Norwegian Nynorsk; Nynorsk, Norwegian') ('nb' 'nob' 'Bokml, Norwegian; Norwegian Bokml') ('nog' 'Nogai') ('non' 'Norse, Old') ('no' 'nor' 'Norwegian') ('nqo' 'N''Ko') ('nso' 'Pedi; Sepedi; Northern Sotho') ('nub' 'Nubian languages') ('nwc' 'Classical Newari; Old Newari; Classical Nepal Bhasa') ('ny' 'nya' 'Chichewa; Chewa; Nyanja') ('nym' 'Nyamwezi') ('nyn' 'Nyankole') ('nyo' 'Nyoro') ('nzi' 'Nzima') ('oc' 'oci' 'Occitan (post 1500); Provenal') ('oj' 'oji' 'Ojibwa') ('or' 'ori' 'Oriya') ('om' 'orm' 'Oromo') ('osa' 'Osage') ('os' 'oss' 'Ossetian; Ossetic') ('ota' 'Turkish, Ottoman (1500-1928)') ('oto' 'Otomian languages') ('paa' 'Papuan (Other)') ('pag' 'Pangasinan') ('pal' 'Pahlavi') ('pam' 'Pampanga; Kapampangan') ('pa' 'pan' 'Panjabi; Punjabi') ('pap' 'Papiamento') ('pau' 'Palauan') ('peo' 'Persian, Old (ca.600-400 B.C.)') ('fa' 'per' 'Persian') ('phi' 'Philippine (Other)') ('phn' 'Phoenician') ('pi' 'pli' 'Pali') ('pl' 'pol' 'Polish') ('pon' 'Pohnpeian') ('pt' 'por' 'Portuguese') ('pra' 'Prakrit languages') ('pro' 'Provenal, Old (to 1500)') ('ps' 'pus' 'Pushto; Pashto') ('qaa-qtz' 'Reserved for local use') ('qu' 'que' 'Quechua') ('raj' 'Rajasthani') ('rap' 'Rapanui') ('rar' 'Rarotongan; Cook Islands Maori') ('roa' 'Romance (Other)') ('rm' 'roh' 'Romansh') ('rom' 'Romany') ('ro' 'rum' 'Romanian') ('rn' 'run' 'Rundi') ('rup' 'Aromanian; Arumanian; Macedo-Romanian') ('ru' 'rus' 'Russian') ('sad' 'Sandawe') ('sg' 'sag' 'Sango') ('sah' 'Yakut') ('sai' 'South American Indian (Other)') ('sal' 'Salishan languages') ('sam' 'Samaritan Aramaic') ('sa' 'san' 'Sanskrit') ('sas' 'Sasak') ('sat' 'Santali') ('sr' 'scc' 'Serbian') ('scn' 'Sicilian') ('sco' 'Scots') ('hr' 'scr' 'Croatian') ('sel' 'Selkup') ('sem' 'Semitic (Other)') ('sga' 'Irish, Old (to 900)') ('sgn' 'Sign Languages') ('shn' 'Shan') ('sid' 'Sidamo') ('si' 'sin' 'Sinhala; Sinhalese') ('sio' 'Siouan languages') ('sit' 'Sino-Tibetan (Other)') ('sla' 'Slavic (Other)') ('sk' 'slo' 'Slovak') ('sl' 'slv' 'Slovenian') ('sma' 'Southern Sami') ('se' 'sme' 'Northern Sami') ('smi' 'Sami languages (Other)') ('smj' 'Lule Sami') ('smn' 'Inari Sami') ('sm' 'smo' 'Samoan') ('sms' 'Skolt Sami') ('sn' 'sna' 'Shona') ('sd' 'snd' 'Sindhi') ('snk' 'Soninke') ('sog' 'Sogdian') ('so' 'som' 'Somali') ('son' 'Songhai languages') ('st' 'sot' 'Sotho, Southern') ('es' 'spa' 'Spanish; Castilian') ('sc' 'srd' 'Sardinian') ('srn' 'Sranan Tongo') ('srr' 'Serer') ('ssa' 'Nilo-Saharan (Other)') ('ss' 'ssw' 'Swati') ('suk' 'Sukuma') ('su' 'sun' 'Sundanese') ('sus' 'Susu') ('sux' 'Sumerian') ('sw' 'swa' 'Swahili') ('sv' 'swe' 'Swedish') ('syc' 'Classical Syriac') ('syr' 'Syriac') ('ty' 'tah' 'Tahitian') ('tai' 'Tai (Other)') ('ta' 'tam' 'Tamil') ('tt' 'tat' 'Tatar') ('te' 'tel' 'Telugu') ('tem' 'Timne') ('ter' 'Tereno') ('tet' 'Tetum') ('tg' 'tgk' 'Tajik') ('tl' 'tgl' 'Tagalog') ('th' 'tha' 'Thai') ('bo' 'tib' 'Tibetan') ('tig' 'Tigre') ('ti' 'tir' 'Tigrinya') ('tiv' 'Tiv') ('tkl' 'Tokelau') ('tlh' 'Klingon; tlhIngan-Hol') ('tli' 'Tlingit') ('tmh' 'Tamashek') ('tog' 'Tonga (Nyasa)') ('to' 'ton' 'Tonga (Tonga Islands)') ('tpi' 'Tok Pisin') ('tsi' 'Tsimshian') ('tn' 'tsn' 'Tswana') ('ts' 'tso' 'Tsonga') ('tk' 'tuk' 'Turkmen') ('tum' 'Tumbuka') ('tup' 'Tupi languages') ('tr' 'tur' 'Turkish') ('tut' 'Altaic (Other)') ('tvl' 'Tuvalu') ('tw' 'twi' 'Twi') ('tyv' 'Tuvinian') ('udm' 'Udmurt') ('uga' 'Ugaritic') ('ug' 'uig' 'Uighur; Uyghur') ('uk' 'ukr' 'Ukrainian') ('umb' 'Umbundu') ('und' 'Undetermined') ('ur' 'urd' 'Urdu') ('uz' 'uzb' 'Uzbek') ('vai' 'Vai') ('ve' 'ven' 'Venda') ('vi' 'vie' 'Vietnamese') ('vo' 'vol' 'Volapk') ('vot' 'Votic') ('wak' 'Wakashan languages') ('wal' 'Walamo') ('war' 'Waray') ('was' 'Washo') ('cy' 'wel' 'Welsh') ('wen' 'Sorbian languages') ('wa' 'wln' 'Walloon') ('wo' 'wol' 'Wolof') ('xal' 'Kalmyk; Oirat') ('xh' 'xho' 'Xhosa') ('yao' 'Yao') ('yap' 'Yapese') ('yi' 'yid' 'Yiddish') ('yo' 'yor' 'Yoruba') ('ypk' 'Yupik languages') ('zap' 'Zapotec') ('zbl' 'Blissymbols; Blissymbolics; Bliss') ('zen' 'Zenaga') ('za' 'zha' 'Zhuang; Chuang') ('znd' 'Zande languages') ('zu' 'zul' 'Zulu') ('zun' 'Zuni') ('zxx' 'No linguistic content') ('zza' 'Zaza; Dimili; Dimli; Kirdki; Kirmanjki; Zazaki'))! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country
	^ country! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country: aString
	country := aString! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 5/31/2008 23:49'!
countryName
	"answers the country name in english and all capitals"
	^self country size = 2
		ifTrue: [ self class iso2Countries at: self country ]
		ifFalse: [ self class iso3Countries at: self country ]! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
language
	^ language! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:11'!
language: aString
	language := aString! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 5/31/2008 23:50'!
languageName
	"answers the language name in english and all capitals"
	^self language size = 2
		ifTrue: [ self class iso2Languages at: self language ]
		ifFalse: [ self class iso3Languages at: self language ]! !

!WALocale methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self seasideString;
		nextPut: $)! !

!WALocale methodsFor: 'converting' stamp: 'pmm 8/31/2008 14:19'!
seasideString
	^ String streamContents: [ :stream | 
		stream nextPutAll: self language.
		self country isNil ifFalse: [ stream
			nextPut: $-;
			nextPutAll: self country ] ]! !

WAObject subclass: #WAMimeDocument
	instanceVariableNames: 'contentType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMimeDocument commentStamp: 'pmm 4/15/2008 21:00' prior: 0!
WAMimeDocument is the abstract base class for mime documents. It is intened as a very basic, mime documents. Implementations are free to use more advance, native implentations as long as they confirm to the protocol.

Instance Variables
	contentType:		<WAMimeType>

mimeType
	- the mime type of this document
!

WAMimeDocument subclass: #WACollectionMimeDocument
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WACollectionMimeDocument commentStamp: 'pmm 4/15/2008 20:57' prior: 0!
A WACollectionMimeDocument is a mime document that is based on a collection.

Instance Variables
	content:		<Collection>

content
	- is the content either as a Collection of Characters or bytes
!

!WACollectionMimeDocument class methodsFor: 'instance creation' stamp: 'pmm 4/16/2008 07:12'!
contentType: aMimeType content: aCollection
	^self new initializeWithContentType: aMimeType content: aCollection! !

!WACollectionMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:08'!
asMIMEDocumentType: aMimeType
	aMimeType = contentType ifTrue: [ ^self ].
	^self class contentType: aMimeType content: content! !

!WACollectionMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:11'!
content
	^content! !

!WACollectionMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:11'!
contentStream
	^content readStream! !

!WACollectionMimeDocument methodsFor: 'initialize-release' stamp: 'pmm 4/16/2008 07:12'!
initializeWithContentType: aMimeType content: aCollection
	contentType := aMimeType.
	content := aCollection! !

!WAMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:10'!
asMIMEDocument
	^self! !

!WAMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:10'!
asMIMEDocumentType: aMimeType
	self subclassResponsibility! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:14'!
content
	"returns the contents of the receiver as a Collection of Characters or bytes"
	self subclassResponsibility! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:14'!
contentStream
	"returns the contents of receiver as a ReadStream"
	self subclassResponsibility! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:15'!
contentType
	"returns the mime type of this document, an istance of the mime type of this document"
	^contentType! !

WAMimeDocument subclass: #WAStreamMimeDocument
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAStreamMimeDocument commentStamp: 'pmm 4/15/2008 20:58' prior: 0!
A WAStreamMimeDocument is a mime document that is based on a stream.

Instance Variables
	stream:		<ReadStream>

stream
	- the stream containing the contents of the document
!

!WAStreamMimeDocument class methodsFor: 'instance creation' stamp: 'pmm 4/16/2008 07:14'!
contentType: aMimeType contentStream: aStream
	^self new initializeWithContentType: aMimeType contentStream: aStream! !

!WAStreamMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:16'!
asMIMEDocumentType: aMimeType
	aMimeType = contentType ifTrue: [ ^self ].
	^self class contentType: aMimeType contentStream: stream! !

!WAStreamMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:12'!
content
	^stream contents! !

!WAStreamMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:12'!
contentStream
	^stream! !

!WAStreamMimeDocument methodsFor: 'initialize-release' stamp: 'pmm 4/16/2008 07:14'!
initializeWithContentType: aMimeType contentStream: aStream
	contentType := aMimeType.
	stream := aStream! !

WAObject subclass: #WAMimeType
	instanceVariableNames: 'main sub parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMimeType commentStamp: 'pmm 1/4/2008 14:44' prior: 0!
A WAMimeType abstracts a Internet media type, it is a two-part identifier for file formats on the Internet.

Instance Variables
	main:		<String>
	parameters:		<WASmallDictionary>
	sub:		<String>

main
	- the main type

parameters
	- a lazily initialized dictionary of optional parameters

sub
	- the subtype
!

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
applicationOctetStream
	^ self main: 'application' sub: 'octet-stream'! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'YM 8/29/2008 16:04'!
fromString: aString
	| main endOfSub sub parts parameters |
	main  := aString copyUpTo: $/.
	endOfSub := aString indexOf: $;.
	endOfSub := endOfSub = 0
		ifTrue: [ aString size ]
		ifFalse: [ endOfSub - 1 ].
	sub := aString copyFrom: main size + 2 to: endOfSub.
	endOfSub = aString size ifTrue: [
		^self main: main sub: sub ].
	parts := (aString copyFrom: endOfSub + 1 to: aString size) findTokens: ';'.
	parameters := WASmallDictionary new.
	parts do: [ :each | 
		parameters
			at: (each copyUpTo: $=) trimBoth
			put: (each copyAfter: $=) trimBoth ].
	^self main: main sub: sub parameters: parameters! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
imageGif
	^ self main: 'image' sub: 'gif'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
imageJpeg
	^ self main: 'image' sub: 'jpeg'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
imagePng
	^ self main: 'image' sub: 'png'! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString
	^self new
		main: aMainString;
		sub: aSubString;
		yourself! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString parameters: aDictionary
	^(self main: aMainString sub: aSubString)
		parameters: aDictionary;
		yourself! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:14'!
textCss
	^ self main: 'text' sub: 'css'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 12:52'!
textHtml
	^ self main: 'text' sub: 'html'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 12:59'!
textJavascript
	^ self main: 'text' sub: 'javascript'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 12:52'!
textPlain
	^ self main: 'text' sub: 'plain'! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:08'!
= other
	^(other isKindOf: WAMimeType)
		and: [ self main = other main
		and: [ self sub = other sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 4/6/2008 15:26'!
charset
	^self parameters at: 'charset'! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:17'!
charset: aString
	self parameters at: 'charset' put: aString! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:14'!
hash
	^self main hash bitXor: self sub hash! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 11/21/2007 14:30'!
isBinary
	| subTypes |
	self main = 'text' ifTrue: [ ^false ].
	self main = 'application' ifFalse: [ ^true ].
	subTypes := self sub findTokens: '+'.
	^ subTypes noneSatisfy: [ :each | 
		#('x-javascript' 'xml') includes: each ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:40'!
isNonStandard
	"tests if the receiver is a non-standard mime type that is not registered with IANA"
	^(self main beginsWith: 'x-')
		or: [ (self main beginsWith: 'X-')
		or: [ (self sub beginsWith: 'x-')
		or: [ self sub beginsWith: 'X-' ] ] ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:39'!
isVendorSpecific
	"tests if the receiver is a vendor specific mimetype"
	^self sub beginsWith: 'vnd.'! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
main
	^ main! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:57'!
main: aString
	main := aString! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 11/21/2007 15:12'!
matches: aMimeType
	"aMimeType is the pattern to match, it is a normal WAMimeType instance where main or sub can be wildcards"
	^(aMimeType main = '*'
		or: [ aMimeType main = self main ])
		and: [
			aMimeType sub = '*'
				or: [ aMimeType sub = self sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:14'!
parameterAt: aKey put: aValue
	self parameters at: aKey put: aValue! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:57'!
parameters
	parameters isNil ifTrue: [
		parameters := WASmallDictionary new ].
	^ parameters! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
parameters: aDictionary
	parameters := aDictionary! !

!WAMimeType methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self seasideString;
		nextPut: $)! !

!WAMimeType methodsFor: 'converting' stamp: 'jf 9/22/2008 12:14'!
seasideMimeType
	^ self! !

!WAMimeType methodsFor: 'converting' stamp: 'pmm 8/31/2008 14:19'!
seasideString
	^ String streamContents: [ :stream | 
		stream
			nextPutAll: self main;
			nextPut: $/;
			nextPutAll: self sub.
		parameters isNil ifFalse: [
			parameters keysAndValuesDo: [ :key :value | 
				stream
					nextPut: $;;
					nextPutAll: key;
					nextPut: $=;
					nextPutAll: value ] ] ]! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
sub
	^ sub! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:55'!
sub: aString
	sub := aString! !

!WAObject class methodsFor: '*Seaside-Core' stamp: 'YM 9/22/2008 22:31'!
deprecatedApi
	self deprecatedApi: thisContext sender seasideString! !

!WAObject class methodsFor: '*Seaside-Core' stamp: 'YM 9/22/2008 22:31'!
deprecatedApi: aString
	self deprecatedApi: aString in: nil! !

!WAObject class methodsFor: '*Seaside-Core' stamp: 'YM 9/22/2008 22:30'!
deprecatedApi: aString in: aNumber
	"Deprecated the sender method in Seaside with the version aNumber."

	WADeprecatedApi raiseSignal: aString! !

!WAObject methodsFor: '*Seaside-Core' stamp: 'YM 9/22/2008 22:36'!
deprecatedApi
	self class deprecatedApi! !

!WAObject methodsFor: '*Seaside-Core' stamp: 'YM 9/22/2008 22:36'!
deprecatedApi: aString
	self class deprecatedApi: aString! !

!WAObject methodsFor: '*Seaside-Core' stamp: 'YM 9/22/2008 22:36'!
deprecatedApi: aString in: aNumber
	self class deprecatedApi: aString in: aNumber! !

!WAObject methodsFor: '*Seaside-Core' stamp: 'jf 9/11/2008 19:42'!
requestContext
	"Answer the current request context, instance of WARequestContext."

	| context |
	context := WACurrentRequestContext value.
	^ context isNil
		ifTrue: [ WARequestContextNotFound raiseSignal ]
		ifFalse: [ context ]! !

WAObject subclass: #WAOpeningConditionalComment
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningConditionalComment commentStamp: 'pmm 1/28/2008 07:06' prior: 0!
Opens a WAConditionalComment and encodes the condition.!

!WAOpeningConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:38'!
condition: aString
	^self new
		condition: aString;
		yourself! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:36'!
condition
	^ condition! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition: aString
	condition := aString! !

!WAOpeningConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:53'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']>'! !

WAOpeningConditionalComment subclass: #WAOpeningRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningRevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Opens a WARevealedConditionalComment and encodes the condition.!

!WAOpeningRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:54'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']><!!-->'! !

WAObject subclass: #WAProcessMonitor
	instanceVariableNames: 'mutex process semaphore value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAProcessMonitor commentStamp: 'rew 10/19/2007 10:49' prior: 0!
WAProcessMonitor executes a block in a new process. Ensures that only one such block is executed at a time. See method critical:ifError:

Instance Variables:
	mutex	<Semaphore>	Used to sure that only one block is executed at a time
	process	<Process>	New process used to execute block
	semaphore	<Semaphore>	Used to signal when process is done

!

!WAProcessMonitor methodsFor: 'mutual exclusion' stamp: 'lr 3/3/2008 22:06'!
critical: aBlock ifError: anErrorBlock
	"Evaluate aBlock as a mutual exclusive block within a new processes and wait for the process to finish. Evaluate anErrorBlock in case of a problem. Answer the result of evaluating the blocks. Note, that the semaphore and value needs to be an instance-variable, otherwise continuations might screw up your session."

	mutex critical: [
		value := nil.
		semaphore := SeasidePlatformSupport semaphoreClass new.
		process := [
			[ value := aBlock on: Error do: anErrorBlock ]
				ensure: [ semaphore signal ] ] newProcess.
		process resume.
		semaphore wait.
		process := nil ].
	^ value! !

!WAProcessMonitor methodsFor: 'initialization' stamp: 'jf 8/30/2008 16:32'!
initialize
	super initialize.
	mutex := SeasidePlatformSupport semaphoreClass forMutualExclusion! !

!WAProcessMonitor methodsFor: 'controlling' stamp: 'lr 3/3/2008 10:51'!
terminate
	process isNil ifFalse: [ process terminate ]! !

WAObject subclass: #WAQualifiedValue
	instanceVariableNames: 'value quality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAQualifiedValue commentStamp: 'pmm 1/4/2008 14:45' prior: 0!
A WAQualifiedValue is an Object with an assigned quality value.

Instance Variables
	quality:		<Float>
	value:		<Object>

quality
	- between 0.0 and 1.0 or Float infinity if no value is given

value
	- the qualified object!

WAQualifiedValue subclass: #WAAccept
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAccept commentStamp: 'pmm 5/31/2008 23:46' prior: 0!
A WAAccept is a WAQualifiedValue with a value that is an instance of WAMimeType. It represents how much a user agent preferes a certain mime type.!

!WAAccept class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:56'!
valueClass
	^WAMimeType! !

WAQualifiedValue subclass: #WAAcceptCharset
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptCharset commentStamp: 'pmm 9/10/2008 22:50' prior: 0!
A WAAcceptCharset is a WAQualifiedValue with a value that is an instance of String. It represents how much a user agent preferes a certain character set for the response.!

!WAAcceptCharset class methodsFor: 'private' stamp: 'pmm 9/10/2008 22:51'!
valueClass
	^String! !

WAQualifiedValue subclass: #WAAcceptEncoding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptEncoding commentStamp: 'pmm 9/10/2008 22:51' prior: 0!
A WAAcceptCharset is a WAQualifiedValue with a value that is an instance of String. It represents how much a user agent preferes a certain encoding for the response.!

!WAAcceptEncoding class methodsFor: 'private' stamp: 'pmm 9/10/2008 22:51'!
valueClass
	^String! !

WAQualifiedValue subclass: #WAAcceptLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptLanguage commentStamp: 'pmm 5/31/2008 23:47' prior: 0!
A WAAcceptLanguage is a WAQualifiedValue with a value that is an instance of WALocale. It represents how much a user agent preferes a certain locale.!

!WAAcceptLanguage class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:59'!
valueClass
	^WALocale! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'pmm 9/14/2008 11:08'!
fromString: aString
	^Array streamContents: [ :stream |
		| values |
		values := aString findTokens: ','.
		values do: [ :each |
			| value quality |
			(each includes: $;)
				ifTrue: [
					value := self valueClass fromString: (each copyUpTo: $;) trimBoth.
					quality := Float readFrom: ((each copyAfter: $;) copyAfter: $=) readStream ]
				ifFalse: [
					value := self valueClass fromString: each trimBoth.
					quality := Float infinity ].
			stream nextPut: (self value: value quality: quality) ] ]! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'pmm 11/21/2007 21:54'!
value: anObject quality: aFloat
	^self new
		value: anObject;
		quality: aFloat;
		yourself! !

!WAQualifiedValue class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:51'!
valueClass
	self subclassResponsibility! !

!WAQualifiedValue methodsFor: 'comparing' stamp: 'pmm 9/10/2008 23:07'!
<= other
	^self quality <= other quality! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
quality
	^ quality! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
quality: aFloat
	quality := aFloat! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
value
	^ value! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
value: anObject
	value := anObject! !

WAObject subclass: #WARenderingContext
	instanceVariableNames: 'session actionUrl count callbacks document mode properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WARenderingContext methodsFor: 'accessing' stamp: 'jf 9/11/2008 15:09'!
absoluteUrlForResource: aString 
	| url |
	(aString isNil or: [ aString includesSubString: '://' ]) ifTrue: [ ^ aString ].
	url := self application resourceBaseUrl.
	url ifNil: [ ^ aString ].
	^ url , aString! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:13'!
actionUrl: anObject
	actionUrl := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 4/19/2006 08:05'!
callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 2/14/2006 20:55'!
callbacks
	^ callbacks! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:17'!
callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count
	^ count! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count: anInteger
	count := anInteger! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode := #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 11/27/2005 19:22'!
increaseKey
	count contents: count contents + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'jf 8/30/2008 16:32'!
initialize
	super initialize.
	count := WAValueHolder with: 1.
	callbacks := Dictionary new! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 8/30/2008 16:22'!
nextKey
	^ count contents seasideString! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key ifAbsent: aBlock
	^ self properties at: key ifAbsent: aBlock! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key put: value
	^ self properties at: key put: value! !

!WARenderingContext methodsFor: 'documents' stamp: 'jf 9/11/2008 15:10'!
registry
	^ self application! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'lr 4/20/2007 19:57'!
release
	super release.
	document := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 4/10/2007 10:06'!
session
	^ session! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 4/10/2007 10:06'!
session: aSession
	session := aSession! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
storeCallback: aCallback
	| key |
	key := self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key! !

!WARenderingContext methodsFor: 'documents' stamp: 'lr 10/28/2007 14:42'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'pmm 3/29/2008 22:49'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^self registry
		urlForRequestHandler:
			(WADocumentHandler
				document: anObject
				mimeType: mimeType
				fileName: fileName)
		addHandlerField: true! !

WAObject subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest responseStream remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WARequest commentStamp: 'jf 9/22/2008 21:11' prior: 0!
I am a server independent http request object. Instance of me can be aquired through WAObject >> #currentRequest.

Instance Variables
	url:				<WAUrl>
	fields:			<Dictionary<String, Object>>
	headers:		<Dictionary<String, String>>
	nativeRequest:	<Object>
	cookies:			<Collection<WARequestCookie>>
	method:			<String>
	remoteAddress:	<String>

url
	- The request path without the query string. For example if the client requested 'http://www.google.com/search?q=seaside' then the contents of url would be '/search'.

headers
	- The header of the HTTP request. This is a Dictionary mapping lowercase strings to other strings.
	
fields
	- The HTTP request parameters. These are the GET and POST parameters in combined into a single dictionary. In general this is a dictionary mapping Strings to Strings. In the case of multivalued paramters or parameters specified in both GET and POST it maps Strings to a Collection of Strings.
	
cookies
	- The collection of cookies (instance of WARequestCookie) the client sent. Note not all clients support all fields. E.g. you might send a path but the client might not return it. Note there can be several cookies with the same key but a different domain or path. See the #cookiesAt: method.
	
nativeRequest
	- The underlying request object of the web server (Kom, Swazoo, OpenTalk, FastCGI, ...). Accessing this makes your code unportable.
	
method
	- the HTTP method, should be upper case. In general only 'GET' and 'POST' are encountered in Seaside. SqueakSource also supports 'PUT'.
	
remoteAddress
	- the IP address of the client. If the server is behind a reverse proxy then this is '127.0.0.1'. This could in theory also be an IPv6 address.!

!WARequest class methodsFor: 'instance-creation' stamp: 'jf 9/22/2008 20:39'!
blankRequest
	^ self
		method: 'GET'
		url: WAUrl new
		headers: Dictionary new
		fields: Dictionary new
		cookies: Array new
		remoteAddress: '' ! !

!WARequest class methodsFor: 'instance-creation' stamp: 'jf 9/22/2008 20:34'!
method: methodString url: aUrlOrString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString
	^ self new
		setMethod: methodString
		url: aUrlOrString
		headers: headerDictionary
		fields: fieldDictionary
		cookies: cookieCollection
		remoteAddress: addressString! !

!WARequest class methodsFor: 'instance-creation' stamp: 'jf 9/22/2008 20:51'!
method: methodString url: aUrlOrString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString nativeRequest: anObject
	^ (self method: methodString url: aUrlOrString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString)
		nativeRequest: anObject;
		yourself! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:09'!
accept
	"The Accept request-header field can be used to specify certain media types which are acceptable for the response. Accept headers can be used to indicate that the request is specifically limited to a small set of desired types, as in the case of a request for an in-line image.
	
	Answers an OrderedCollection of WAAccept with the values in the order the client sent them."
	^ WAAccept fromString: (self headerAt: 'accept' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:10'!
acceptCharset
	"The Accept-Charset request-header field can be used to indicate what character sets are acceptable for the response. This field allows clients capable of understanding more comprehensive or special- purpose character sets to signal that capability to a server which is capable of representing documents in those character sets.
	
	Answers an OrderedCollection of WAAcceptCharset with the values in the order the client sent them."
	^ WAAcceptCharset fromString: (self headerAt: 'accept-charset' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:11'!
acceptEncoding
	"The Accept-Encoding request-header field is similar to Accept, but restricts the content-codings (section 3.5) that are acceptable in the response.
	
	Answers an OrderedCollection of WAAcceptEncoding with the values in the order the client sent them."
	^ WAAcceptEncoding fromString: (self headerAt: 'accept-encoding' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:11'!
acceptLanguage
	"The Accept-Language request-header field is similar to Accept, but restricts the set of natural languages that are preferred as a response to the request.
	
	Answers an OrderedCollection of WAAcceptLanguage with the values in the order the client sent them."
	^ WAAcceptLanguage fromString: (self headerAt: 'accept-language' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'ac 11/12/2005 00:46'!
at: key ifPresent: aBlock
	^ fields at: key ifPresent: aBlock! !

!WARequest methodsFor: 'private' stamp: 'pmm 4/22/2008 07:32'!
authorization
	"Answer the basic authorization string from the request. This is the username and the password separated by a colon."
	
	| authorization |
	authorization := self headerAt: 'authorization'.
	^ authorization isNil ifFalse: [ self decodeAuthorization: authorization ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'pmm 3/25/2008 18:59'!
cookieAt: aKey
	"returns the first found cookie with the given key
	there might be several cookies with the name key but different paths, in this case use
	#cookiesAt:"
	^ cookies ifNotNil: [
		cookies
			detect: [ :each | each key = aKey ]
			ifNone: [ nil ] ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'pmm 3/22/2008 15:23'!
cookies
	^ cookies ifNil: [ #() ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'pmm 3/25/2008 19:00'!
cookiesAt: aKey
	"returns all the cookies with the given key"
	
	^ cookies ifNotNil: [
		cookies
			select: [ :each | each key = aKey ] ]! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'pmm 9/13/2008 11:07'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: [ nil ]! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/29/2006 07:28'!
host
	^ self headerAt: 'host'! !

!WARequest methodsFor: 'testing' stamp: 'mb 3/31/2006 09:41'!
includesKey: key
	^ fields includesKey: key! !

!WARequest methodsFor: 'testing' stamp: 'avi 3/22/2004 12:58'!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'testing' stamp: 'lr 7/3/2006 09:25'!
isXmlHttpRequest
	^ (self headerAt: 'x-requested-with') = 'XMLHttpRequest'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest: aRequest
	nativeRequest := aRequest! !

!WARequest methodsFor: 'accessing' stamp: 'lr 2/12/2008 08:09'!
password
	"Answer the password from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyAfter: $: ]! !

!WARequest methodsFor: 'printing' stamp: 'jf 9/22/2008 20:32'!
printOn: aStream
	super printOn: aStream.
	aStream space; nextPutAll: self method.
	aStream space; nextPutAll: self url seasideString! !

!WARequest methodsFor: 'accessing-headers' stamp: 'ac 6/17/2006 16:28'!
referer
	^ self headerAt: 'referer'! !

!WARequest methodsFor: 'accessing' stamp: 'pmm 5/11/2008 22:00'!
remoteAddress
	"answer the IP address of the client (String)"
	^ remoteAddress! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream
	^ responseStream! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream: aStream
	responseStream := aStream! !

!WARequest methodsFor: 'private' stamp: 'jf 9/22/2008 20:34'!
setMethod: methodString url: aUrlOrString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString
	method := methodString.
	url := aUrlOrString seasideUrl.
	headers := headerDictionary.
	fields := fieldDictionary.
	cookies := cookieCollection.
	remoteAddress := addressString! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'accessing' stamp: 'lr 2/12/2008 08:09'!
user
	"Answer the username from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyUpTo: $: ]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
userAgent
	^ self headerAt: 'user-agent'! !

WAObject subclass: #WARequestContext
	instanceVariableNames: 'server handlers request response properties subscribers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

!WARequestContext commentStamp: 'lr 9/13/2008 14:24' prior: 0!
WARequestContext encapsulates all the knowledge that shuld be available while processing a single request. It does not matter if this is a request to a static file, an AJAX request, a long Comet request or a normal Seaside requestion.

The request context is valid only during the request that caused it. It should not be stored. Neither within instance variables, nor within the execution stack so that it might be captured by a continuation. In both cases this might lead to memory leaks.!

!WARequestContext class methodsFor: 'instance creation' stamp: 'lr 9/13/2008 14:08'!
server: aServer request: aRequest
	^ self new initializeServer: aServer request: aRequest! !

!WARequestContext methodsFor: 'accessing-scripts' stamp: 'lr 4/2/2008 11:57'!
addLoadScript: aString
	^ self loadScripts addLast: aString! !

!WARequestContext methodsFor: 'accessing' stamp: 'pmm 5/10/2008 22:02'!
codec
	"returns the WACodec instance used by the current server"
	^self server codec! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 9/13/2008 15:43'!
entryPoint
	"Answer the closest subclass of WAEntryPoint in the handler stack"

	^ handlers 
		detect: [ :each | each isEntryPoint ]
		ifNone: [ nil ]! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'lr 4/9/2008 10:17'!
handler
	"Answer the current request handler or nil."

	^ self handlers isEmpty ifFalse: [ self handlers first ]! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:47'!
handlers
	"Answer an ordered collection of request handlers that have been processed. The list of handlers is in reverse orders, so that the last processed handler is first in the list."

	^ handlers! !

!WARequestContext methodsFor: 'initialization' stamp: 'jf 8/30/2008 16:33'!
initialize
	super initialize.
	handlers := OrderedCollection new! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 9/13/2008 14:08'!
initializeServer: aServer request: aRequest
	server := aServer.
	request := aRequest! !

!WARequestContext methodsFor: 'testing' stamp: 'pmm 5/9/2008 19:33'!
isEncoded
	"returns true if the server is encoded
	the server is encoded if multi byte input characters are mapped to one instance of Character"
	^self server isEncoded! !

!WARequestContext methodsFor: 'accessing-scripts' stamp: 'lr 5/31/2008 23:34'!
loadScripts
	^ self properties at: #loadScripts ifAbsentPut: [ OrderedCollection new ]! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 4/9/2008 10:17'!
newCookie
	"Creates a new cookie. Tries to put as many restrictions on it as possible and make stealing it has hard a possible. Some of these restrictions might be to severe for your application, you can always loosen them."
	| cookie baseUrl |
	baseUrl := self handler baseUrl.
	cookie := WACookie new
		path: baseUrl pathString;
		httpOnly: true;
		yourself.
	baseUrl hostname isNil ifFalse: [ cookie domain: baseUrl hostname ].
	baseUrl scheme = 'https' ifTrue: [ cookie secure: true ].
	(baseUrl port notNil and: [ baseUrl hostname notNil ]) ifTrue: [ cookie port: baseUrl port ].
	^ cookie! !

!WARequestContext methodsFor: 'events' stamp: 'lr 3/29/2008 22:10'!
on: anEventClass do: aValuable
	"Evaluate aValuable, when an event of aClass is triggered."

	subscribers ifNil: [ subscribers := WASmallDictionary new ].
	(subscribers at: anEventClass ifAbsentPut: [ OrderedCollection new ])
		add: aValuable.
	^ aValuable! !

!WARequestContext methodsFor: 'events' stamp: 'lr 3/29/2008 22:11'!
on: anEventClass send: aSelector to: anObject
	"Send the message aSelector to anObject, when an event of aClass is triggered."

	^ self on: anEventClass do: (MessageSend receiver: anObject selector: aSelector)! !

!WARequestContext methodsFor: 'events' stamp: 'lr 3/29/2008 22:12'!
onRespond: aValuable
	self on: WAResponseEvent do: aValuable! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:15'!
properties
	"Answer a dictionary of custom request related properties."

	^ properties ifNil: [ properties := WASmallDictionary new ]! !

!WARequestContext methodsFor: 'actions' stamp: 'lr 9/13/2008 14:14'!
push: aRequestHandler while: aBlock
	"Push the request handler aRequestHandler on the handler stack while evaluating aBlock."
	
	handlers addFirst: aRequestHandler.
	^ aBlock ensure: [ handlers removeFirst ]! !

!WARequestContext methodsFor: 'accessing-scripts' stamp: 'lr 5/31/2008 23:40'!
rememberLoadScripts: aBlock
	| result scripts |
	scripts := self loadScripts.
	self properties removeKey: #loadScripts.
	result := aBlock value.
	self properties at: #loadScripts put: scripts.
	^ result! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:48'!
request
	"Answer the current request object."
	
	^ request! !

!WARequestContext methodsFor: 'initialization' stamp: 'pmm 3/29/2008 14:59'!
request: aRequest
	request := aRequest! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:48'!
response
	"Answer the current response object."
	
	^ response! !

!WARequestContext methodsFor: 'initialization' stamp: 'pmm 3/29/2008 15:25'!
response: aResponse
	response := aResponse! !

!WARequestContext methodsFor: 'responding' stamp: 'lr 4/5/2008 18:00'!
returnResponse: aResponse
	| event |
	"That should be improved, it should also check if the response is not already out on the socket.
	response isNil 
		ifFalse: [ self error: 'Invalid state exception.' ]."
	self trigger: (event := WAResponseEvent on: aResponse).
	WAReturnResponse new
		response: event response;
		raiseSignal! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:48'!
server
	"Answer the server handing this request."

	^ server! !

!WARequestContext methodsFor: 'initialization' stamp: 'pmm 3/29/2008 14:16'!
server: aServerApater
	server := aServerApater! !

!WARequestContext methodsFor: 'events' stamp: 'lr 4/9/2008 10:15'!
trigger: anEvent
	"Pass anEvent to all subscribers of anEvent class."
	
	subscribers ifNil: [ ^ anEvent ].
	subscribers keysAndValuesDo: [ :class :actions |
		(anEvent isKindOf: class)
			ifTrue: [ actions do: [ :action | action value: anEvent ] ] ].
	^ anEvent! !

!WARequestContext methodsFor: 'testing' stamp: 'pmm 5/9/2008 19:37'!
usesSmalltalkEncoding
	"returns true if the Strings provided by the server are guaranteed to be in the native encoding of the Smalltalk image
	returns false if the Characters in Strings provided by the server are only bytes"
	^self server usesSmalltalkEncoding! !

WAObject subclass: #WARequestCookie
	instanceVariableNames: 'key path domain ports value version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WARequestCookie commentStamp: 'pmm 6/1/2008 00:04' prior: 0!
A WARequestCookie is the cookie the user agent sent to the server.

Instance Variables
	domain:		<String>
	key:		<String>
	path:		<String>
	ports:		<Collection<Integer>>
	value:		<String>
	version:		<Integer>

domain
	- xxxxx

key
	- xxxxx

path
	- xxxxx

ports
	- xxxxx

value
	- xxxxx

version
	- the version of the cookie specification supported, currently only 1 is known
!

WARequestCookie subclass: #WACookie
	instanceVariableNames: 'expiry secure discard comment commentUrl httpOnly maxAge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WACookie commentStamp: 'pmm 6/1/2008 00:01' prior: 0!
I represent a cookie, a piece of information that is stored on the client and read and writable by the server. I am basically a key/value pair of strings.
You can never trust information in a cookie, the client is free to edit it.
I model only a part of the full cookie specification.

Browser support:
http://www.mnot.net/blog/2006/10/27/cookie_fun

Netscape spec
http://wp.netscape.com/newsref/std/cookie_spec.html

Cookie spec
http://tools.ietf.org/html/rfc2109

Cookie 2 spec
http://tools.ietf.org/html/rfc2965

HttpOnly
http://msdn2.microsoft.com/en-us/library/ms533046.aspx
https://bugzilla.mozilla.org/show_bug.cgi?id=178993

Compared to WARequestCookie I represent the information that is sent to the user agent.!

!WACookie class methodsFor: 'convenience' stamp: 'pmm 3/22/2008 11:00'!
combine: aCollectionOfCookies using: aOneArgumentBlock
	"combines several cookies into one HTTP header line
	aOneArgumentBlock takes a cookie as an argument and returns a string,
	it is supposed to send one of #oldNetscapeString #rfc2109String #rfc2965String to the argument"
	^String streamContents: [ :stream |
		aCollectionOfCookies
			do: [ :each |
				stream nextPutAll: (aOneArgumentBlock value: each) ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
comment
	^ comment! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
comment: aString
	comment := aString! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
commentUrl
	^ commentUrl! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:35'!
commentUrl: aUrl
	commentUrl := aUrl! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
discard
	^ discard! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
discard: aBoolean
	discard := aBoolean! !

!WACookie methodsFor: 'api' stamp: 'pmm 3/22/2008 12:37'!
expireIn: aDuration
	"sets the lifetime of the receiver mesaured in a duration"
	self expiry: DateAndTime now + aDuration.
	self maxAge: aDuration asSeconds! !

!WACookie methodsFor: 'api' stamp: 'pmm 4/5/2008 15:44'!
expireInPast
	self maxAge: 0.
	self expiry: (DateAndTime now - (Duration days: 10 hours: 0 minutes: 0 seconds: 0)).! !

!WACookie methodsFor: 'api' stamp: 'pmm 3/22/2008 12:37'!
expireInSeconds: anInteger
	"sets the lifetime of the receiver mesaured in seconds"
	self expiry: (Duration days: 0 hours: 0 minutes: 0 seconds: anInteger).
	self maxAge: anInteger! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
expiry: aDateTime
	expiry := aDateTime asUTC! !

!WACookie methodsFor: 'private' stamp: 'pmm 8/31/2008 14:23'!
expiryString
	^ String streamContents: [ :stream | 
		stream
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth seasideString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year seasideString;
			space;
			nextPutAll: expiry hour24 seasideString;
			nextPut: $:;
			nextPutAll: expiry minute seasideString;
			nextPut: $:;
			nextPutAll: expiry second seasideString;
			nextPutAll: ' GMT' ]! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:39'!
httpOnly
	^ httpOnly! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:39'!
httpOnly: anObject
	httpOnly := anObject! !

!WACookie methodsFor: 'initialize-release' stamp: 'pmm 3/3/2008 20:41'!
initialize
	super initialize.
	self secure: false.
	self discard: false.
	self httpOnly: false.
	self version: 1! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 12:31'!
maxAge
	^ maxAge! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 12:32'!
maxAge: anInteger
	"Optional.  The Max-Age attribute defines the lifetime of the
	cookie, in seconds.  The delta-seconds value is a decimal non-
	negative integer.  After delta-seconds seconds elapse, the client
	should discard the cookie.  A value of zero means the cookie
	should be discarded immediately."
	maxAge := anInteger! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:19'!
oldNetscapeString
	"Serializes the receiver accroding to the orginal Netscape spec.
	This has the broadest browser support but limited features.
	It can not be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: false on: stream.
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:17'!
oldNetscapeStringWithoutKey
	"same as oldNetscapeString except that the key is not included, used for Kom hacks"
	^String streamContents: [ :stream |
		self value isNil ifFalse: [
			stream nextPutAll: self value ].
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:20'!
rfc2109String
	"Serializes the receiver accroding to RFC 2109.
	Almost no browser support.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeVersionOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:21'!
rfc2965String
	"Serializes the receiver accroding to RFC 2965.
	This has the most features but is only supported in Opera.
	It can be used together with other serialization forms.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeCommentUrlOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writePortsOn: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeDiscardOn: stream.
		self writeVersionOn: stream ]! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:33'!
secure
	^ secure! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:35'!
secure: aBoolean
	secure := aBoolean! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 2/25/2008 07:33'!
write: aString asQuotedStringOn: aStream

	aStream nextPut: $".
	aString do: [ :each |
		each = $" 
			ifTrue: [ aStream nextPutAll: '\"']
			ifFalse: [ aStream nextPut: each ] ].
	aStream nextPut: $"! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:25'!
write: aString quoted: aBoolean on: aStream
	aBoolean
		ifTrue: [
			self
				write: aString
				asQuotedStringOn: aStream ]
		ifFalse: [ aStream nextPutAll: aString ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:18'!
writeCommentOn: aStream
	self comment isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Comment='.
	self
		write: self comment
		asQuotedStringOn: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'lr 8/30/2008 16:22'!
writeCommentUrlOn: aStream 
	self commentUrl isNil ifTrue: [ ^ self ].
	aStream nextPutAll: '; CommentURL='.
	self 
		write: self commentUrl seasideString
		asQuotedStringOn: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:32'!
writeDiscardOn: aStream
	(self discard notNil and: [ self discard ])
		ifTrue: [ aStream nextPutAll: '; Discard' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:02'!
writeDomainQuoted: aBoolean on: aStream
	domain isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; domain='.
	self
		write: self domain
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:22'!
writeExpiresOn: aStream
	expiry isNil ifTrue: [ ^self ].

	aStream
		nextPutAll: '; expires=';
		nextPutAll: self expiryString! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:42'!
writeHttpOnlyOn: aStream
	self httpOnly
		ifTrue: [ aStream nextPutAll: '; HttpOnly' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:26'!
writeKeyValueQuoted: aBoolean on: aStream
	aStream nextPutAll: self key.
	aStream nextPut: $=.
	self
		write: (self value ifNil: [ '' ])
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/22/2008 12:39'!
writeMaxAgeOn: aStream
	maxAge isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Max-Age="'.
	aStream print: maxAge.
	aStream nextPut: $".! !

!WACookie methodsFor: 'writing' stamp: 'pmm 3/3/2008 20:50'!
writeOn: aStream
	aStream nextPutAll: self oldNetscapeString! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:02'!
writePathQuoted: aBoolean on: aStream
	path isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; path='.
	self
		write: self path
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:24'!
writePortsOn: aStream
	ports isEmptyOrNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Port="'.
	self ports
		do: [ :each | aStream print: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $".! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:42'!
writeSecureOn: aStream
	self secure
		ifTrue: [ aStream nextPutAll: '; Secure' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:00'!
writeVersionOn: aStream
	aStream nextPutAll: '; Version='.
	aStream print: self version! !

!WARequestCookie class methodsFor: 'accessing' stamp: 'pmm 3/22/2008 13:55'!
actions
	^Dictionary new
		at: '$Domain' put: [ :cookie :value | cookie domain: value ];
		at: '$Path' put: [ :cookie :value | cookie path: value ];
		at: '$Port' put: [ :cookie :value | cookie initializePorts: value ];
		yourself! !

!WARequestCookie class methodsFor: 'instance creation' stamp: 'pmm 7/12/2008 07:54'!
fromString: aString
	"Creates an array of cookies from a HTTP Cookie: header value."
	| version tokens cookieLine current |
	cookieLine := aString.
	aString isEmptyOrNil ifTrue: [ ^#() ]. 
	tokens := cookieLine findTokens: $;.
	current := nil.
	^Array streamContents: [ :cookies |
		tokens do: [ :each |
			| key value action |
			key := self keyFrom: each.
			value := self valueFrom: each.
			key = '$Version'
				ifTrue: [ version := value asInteger ]
				ifFalse: [
					action := self actions
						at: key
						ifAbsent: [ nil ].
					action isNil
						ifTrue: [
							current := self key: key value: value.
							current version: version.
							cookies nextPut: current ]
						ifFalse: [ action value: current value: value ] ] ] ]! !

!WARequestCookie class methodsFor: 'instance creation' stamp: 'pmm 2/21/2008 21:30'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WARequestCookie class methodsFor: 'private' stamp: 'YM 8/29/2008 16:05'!
keyFrom: aString
	^(aString copyUpTo: $=) trimBoth! !

!WARequestCookie class methodsFor: 'private' stamp: 'YM 8/29/2008 16:04'!
trimBlanksAndQuotes: aString
	| trimmed |
	trimmed := aString trimBoth.
	^(trimmed size > 2
		and: [ trimmed first = $"
		and: [ trimmed last = $" ] ])
			ifTrue: [ trimmed copyFrom: 2 to: trimmed size - 1 ]
			ifFalse: [ trimmed ]! !

!WARequestCookie class methodsFor: 'private' stamp: 'pmm 2/24/2008 20:39'!
valueFrom: aString
	^(aString includes: $=)
		ifTrue: [ self trimBlanksAndQuotes: (aString copyAfter: $=) ]! !

!WARequestCookie methodsFor: 'comparing' stamp: 'pmm 3/22/2008 15:58'!
= other
	"cookies are identified by the triple name/domain/path"
	^ self species = other species
		and: [ self key = other key
		and: [ self domain = other domain
		and: [ self path = other path ] ] ]! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
domain
	^ domain! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
domain: aString
	domain := aString! !

!WARequestCookie methodsFor: 'comparing' stamp: 'pmm 3/22/2008 15:58'!
hash
	"see #="
	^(self key hash
		bitXor: self domain hash)
		bitXor: self path hash! !

!WARequestCookie methodsFor: 'initialize-release' stamp: 'pmm 3/22/2008 13:55'!
initializePorts: aString
	self ports: ((aString findTokens: $,) collect: [ :each | each asInteger ]).! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:30'!
key
	^ key! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:30'!
key: aString
	key := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
path
	^ path ifNil: ['/']! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
path: aString
	path := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 20:09'!
port: anInteger
	self ports: (Array with: anInteger)! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:43'!
ports
	^ ports! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:43'!
ports: aCollection
	ports := aCollection! !

!WARequestCookie methodsFor: 'copying' stamp: 'pmm 4/5/2008 15:22'!
postCopy
	super postCopy.
	ports := ports copy! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:31'!
value
	^ value! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:31'!
value: aString
	value := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:36'!
version
	^ version! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:36'!
version: anInteger
	version := anInteger! !

WAObject subclass: #WARequestFilter
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

WARequestFilter subclass: #WAAuthenticationFilter
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAAuthenticationFilter commentStamp: 'lr 8/31/2008 13:03' prior: 0!
WAAuthenticationFilter protects a request handler with username and password using the standard HTTP basic authentication. This passes username and password in clear-text, unless used over an encripted HTTPS connection. You should set the authenticator, and object that is able to validate usernames and passwords by implementing #verifyPassword:forUser:.!

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 15:05'!
authenticator
	"Answer the object used for authentication. Defaults to the owning handler."

	^ authenticator ifNil: [ self handler ]! !

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:54'!
authenticator: anObject
	authenticator := anObject! !

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 15:05'!
realm
	"Answer the realm to be displayed in the authentication dialog. Defaults to the description of the owning handler."
	
	^ realm ifNil: [ realm := self handler description ]! !

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:54'!
realm: anObject
	realm := anObject! !

!WAAuthenticationFilter methodsFor: 'processing' stamp: 'lr 9/13/2008 11:10'!
responseForContext: aRequestContext 
	^ (self verifyRequest: aRequestContext request) 
		ifTrue: [ super responseForContext: aRequestContext ]
		ifFalse: [ WAResponse basicAuthWithRealm: self realm ]! !

!WAAuthenticationFilter methodsFor: 'testing' stamp: 'lr 8/31/2008 13:10'!
verifyRequest: aRequest
	^ self authenticator verifyPassword: aRequest password forUser: aRequest user! !

WARequestFilter subclass: #WAProtectionFilter
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAProtectionFilter methodsFor: 'private' stamp: 'lr 8/31/2008 13:15'!
remoteAddress
	^ remoteAddress! !

!WAProtectionFilter methodsFor: 'private' stamp: 'jf 9/13/2008 16:15'!
remoteAddressFromRequest: aRequest
	remoteAddress ifNil: [
		remoteAddress := aRequest
			headerAt: 'x-forwarded-for'
			ifAbsent: [ aRequest remoteAddress ]	].
	^ aRequest remoteAddress! !

!WAProtectionFilter methodsFor: 'processing' stamp: 'jf 9/14/2008 01:22'!
responseForContext: aRequestContext 
	^ (self verifyRequest: aRequestContext request) 
		ifTrue: [ super responseForContext: aRequestContext ]
		ifFalse: [ aRequestContext entryPoint forbiddenResponseFor: aRequestContext ]! !

!WAProtectionFilter methodsFor: 'testing' stamp: 'lr 8/31/2008 13:15'!
verifyRequest: aRequest
	^ (self remoteAddressFromRequest: aRequest) = self remoteAddress! !

!WARequestFilter methodsFor: 'copying' stamp: 'lr 9/13/2008 15:08'!
copyTo: aRequestHandler
	^ self copy setNext: (self next copyTo: aRequestHandler)! !

!WARequestFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:46'!
handler
	"Answer the owning request handler."

	^ self next handler! !

!WARequestFilter methodsFor: 'initialization' stamp: 'lr 8/31/2008 12:47'!
initialize
	super initialize.
	next := WAValueHolder new! !

!WARequestFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:46'!
next
	"Answer the next filter or request handler."
	
	^ next contents! !

!WARequestFilter methodsFor: 'copying' stamp: 'lr 9/13/2008 15:23'!
postCopy
	super postCopy.
	next := next copy! !

!WARequestFilter methodsFor: 'processing' stamp: 'lr 9/13/2008 11:10'!
responseForContext: aRequestContext 
	"Pass on the aRequestContext to the next filter or handler. Subclasses might override this method to customize the request and response handling."
	
	^ self next responseForContext: aRequestContext! !

!WARequestFilter methodsFor: 'initialization' stamp: 'lr 9/13/2008 14:55'!
setNext: aFilter
	next contents: aFilter! !

!WARequestFilter methodsFor: 'processing' stamp: 'lr 8/31/2008 14:45'!
updateStates: aSnapshot
	aSnapshot register: next! !

WARequestFilter subclass: #WATransactionFilter
	instanceVariableNames: 'closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WATransactionFilter methodsFor: 'actions' stamp: 'lr 8/31/2008 16:14'!
close
	closed := true! !

!WATransactionFilter methodsFor: 'initialization' stamp: 'lr 8/31/2008 16:14'!
initialize
	super initialize.
	closed := false! !

!WATransactionFilter methodsFor: 'testing' stamp: 'lr 8/31/2008 16:14'!
isClosed
	^ closed! !

!WATransactionFilter methodsFor: 'processing' stamp: 'pmm 9/14/2008 13:55'!
responseForContext: aRequestContext 
	^ self isClosed 
		ifFalse: [ super responseForContext: aRequestContext ]
		ifTrue: [ WAResponseFactory pageExpiredForContext: aRequestContext ]! !

WAObject subclass: #WARequestHandler
	instanceVariableNames: 'parent filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARequestHandler commentStamp: 'rew 10/19/2007 10:44' prior: 0!
WARequestHandler is an abstract class whose subclasses handle http requests. Most of the methods are either empty or return a default value. 

Subclasses must implement the following messages:
	handleRequest:	process the request

Instance Variables:
	parent	<WADispatcher | WAApplication | nil> What owns or manages the handler. WADispatchers manage WADispatchers & WAApplications, WAApplications own WASessions

!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WADocumentHandler commentStamp: 'pmm 10/20/2007 23:22' prior: 0!
WADocumentHandler handles requests for images, text documents and binary files (byte arrays). This class is not normally used directly. A number of WA*Tag classes implement document:mimeType:fileName: which use WADocumentHandler. Given a document document:mimeType:fileName: creates a WADocumentHandler on the document, registers the handler with a dispatcher, and adds the correct url in the tag for the document.

Instance Variables:
	document	<ByteArray | GIFImage | Image | String | WACachedDocument | any class that understands #asMIMEDocumentType:>	contents of the document
	fileName	<String>	file containing the document to be sent as an attachment, nil if no such file
	mimeDocument	<MIMEDocument>	MIMEDocument object representing this document and mimeType, generates stream used to write document for the response. 
	mimeType	<String>	standard HTTP mime type
!

!WADocumentHandler class methodsFor: 'instance-creation' stamp: 'pmm 9/1/2008 23:36'!
document: anObject mimeType: mimeString fileName: fileString
	^ self new
		initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'lr 2/12/2007 19:38'!
= other
	^ other species = self species
		and: [ other document = self document
		and: [ other mimeType = self mimeType ] ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'initialization' stamp: 'jf 9/22/2008 12:24'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document := anObject.
	mimeString isNil
		ifFalse: [ mimeType := mimeString seasideMimeType ].
	fileName := fileString! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:37'!
mimeDocument
	^ mimeDocument ifNil: [ mimeDocument := document asMIMEDocumentType: mimeType ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'jf 9/22/2008 12:23'!
response
	| response |
	response := WAResponse new.
	response contents: self mimeDocument contentStream.
	response contentType: (mimeType ifNil: [ self mimeDocument contentType seasideMimeType ]).
	response cacheForever.
	fileName ifNotNil: [ response attachmentWithFileName: fileName ].
	^ response! !

!WADocumentHandler methodsFor: 'actions' stamp: 'lr 9/13/2008 11:11'!
responseForContext: aRequestContext 
	^ self response! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'name configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAEntryPoint commentStamp: 'rew 10/19/2007 10:45' prior: 0!
WAEntryPoint represents a named entry point to a request handler.

Given a seaside application URL, http://localhost:8008/seaside/tests/alltests, the path parts of the url are mapped to WARequestHandlers. "seaside" & "tests" map to WADispatchers, "alltests" maps to a WAApplication. These individual path parts are used as the names of the WARequestHandlers. WAEntryPoint is an abstract class that handles the name of WARequestHandlers. WAEntryPoint constructs the proper url path for this handler.

Instance Variables:
	name	<String>	the name or path part of this handler

!

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints defaultName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher commentStamp: 'rew 10/19/2007 10:46' prior: 0!
WADispatcher takes http requests and dispatches them to the correct handler (WAApplication, WAFileHandler, WANotFoundHandler, etc). 

WADispatcher class>>default is the top level dispatcher. When a Seaside application is registered as "foo" the application is added to the top level dispatcher. The application is added to the entryPoints of the dispatcher at the key "foo". If a Seaside application is registered as "bar/foo" then the application isadded to a  dispatcher's entryPoints at the key "foo". That dispatcher is in the top level dispatcher's  entryPoints at the key "bar". 
  
When a http request is received it is sent to WADispatcher class>>default to find the correct handler for the request. If a handler exists for the request is sent to that handler. Otherwise the request is sent to WANotFoundHandler.

The VW port maintains multiple copies of the tree of dispatchers rooted at WADispatcher class>>default. One copy is for each different URL that can reach Seaside (http://..../seaside/go/counter - normal, http://..../counter - SeasideShortPath, http://..../seaside/stream/counter - streaming). 

Instance Variables:
	defaultName	<String>
	entryPoints	<(Dictionary of: (WAApplication | WADispatcher | WAFileHandler))>	 the keys are strings, which are the names and URL path segments for the handler at that key
	lastUpdate	<TimeStamp>	Time the dispatcher was last changed
	version	<SmallInteger>	Each time the dispatcher is changed the version is increased by 1
!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 3/19/2007 21:06'!
default
	^ default ifNil: [ default := self named: SeasidePlatformSupport defaultDispatcherName ]! !

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 2/10/2008 15:28'!
description
	^ 'Dispatcher'! !

!WADispatcher class methodsFor: 'initialization' stamp: 'jf 9/13/2008 11:08'!
resetDefault
	default := nil.! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 20:07'!
defaultName
	^ defaultName! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/10/2008 17:45'!
defaultName: aString
	defaultName := aString! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 21:44'!
entryPointAt: aString
	^ (aString findTokens: '/') inject: self into: [ :dispatcher :token | dispatcher entryPoints at: token ]! !

!WADispatcher methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WADispatcher methodsFor: 'private' stamp: 'jf 9/22/2008 21:08'!
handlerForContext: aRequestContext
	| requestUrl baseUrl relativePath |
	requestUrl := aRequestContext request url.
	requestUrl path isEmpty ifTrue: [
		^self handlerOrNotFoundAt: self defaultName ].
	
	baseUrl := WAUrl new addAllToPath: self path; yourself.
	relativePath := baseUrl relativeTo: requestUrl.
	
	relativePath isEmpty ifTrue: [
		^self handlerOrNotFoundAt: self defaultName ].
		
	^ self handlerOrNotFoundAt: relativePath first! !

!WADispatcher methodsFor: 'private' stamp: 'jf 7/24/2008 23:14'!
handlerOrNotFoundAt: aString
	"returns the request handler registered under the given key
	if no handler exists for such a key a WANotFoundHandler is returned"
	^self entryPoints
		at: aString
		ifAbsent: [ self notFoundHandler ]! !

!WADispatcher methodsFor: 'initialization' stamp: 'lr 2/11/2008 21:13'!
initialize
	super initialize.
	entryPoints := Dictionary new! !

!WADispatcher methodsFor: 'testing' stamp: 'mb 5/26/2006 08:51'!
isDispatcher
	^ true! !

!WADispatcher methodsFor: 'testing' stamp: 'lr 2/12/2007 20:59'!
isRoot
	^ self parent isNil! !

!WADispatcher methodsFor: 'private' stamp: 'jf 9/14/2008 00:05'!
notFoundHandler
	^ WANotFoundHandler new
		setParent: self;
		yourself! !

!WADispatcher methodsFor: 'copying' stamp: 'mb 2/17/2007 01:31'!
postCopy
	super postCopy.
	entryPoints := entryPoints valuesCollect: [ :each | each copy setParent: self ]! !

!WADispatcher methodsFor: 'registration' stamp: 'lr 2/10/2008 17:44'!
register: anEntryPoint
	anEntryPoint name
		ifNil: [ self error: 'Unable to add unnamed entry point.' ].
	entryPoints
		at: anEntryPoint name
		put: (anEntryPoint setParent: self).
	^ anEntryPoint! !

!WADispatcher methodsFor: 'processing' stamp: 'jf 9/13/2008 13:13'!
responseForContext: aRequestContext 
	^ (self handlerForContext: aRequestContext) handleRequest: aRequestContext! !

!WADispatcher methodsFor: 'registration' stamp: 'lr 2/10/2008 17:44'!
unregister: anEntryPoint
	entryPoints removeKey: anEntryPoint name ifAbsent: [ ^ nil ].
	^ anEntryPoint unregistered! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:54'!
concreteSubclasses
	^ self allSubclasses reject: [ :each | each isAbstract ]! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

!WAEntryPoint class methodsFor: 'testing' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/12/2007 19:56'!
named: aString
	^ self new setName: aString! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/10/2008 19:51'!
register: aString
	^ self register: aString in: WADispatcher default! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/10/2008 19:51'!
register: aString in: aDispatcher
	| path dispatcher |
	path := aString findTokens: '/'.
	dispatcher := path allButLast
		inject: aDispatcher
		into: [ :result :each |
			result entryPoints 
				at: each
				ifAbsent: [ result register: (WADispatcher named: each) ] ].
	^ dispatcher register: (self named: path last)! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'mb 2/18/2007 01:30'!
basePath
	^ self parent isNil
		ifTrue: [self name isEmpty
				ifTrue: ['']
				ifFalse: ['/' , self name]]
		ifFalse: [self parent basePath , '/' , self name]! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 7/31/2008 16:00'!
baseUrl
	| serverPath url |
	serverPath := self serverPath.

	url := (serverPath isNil and: [ parent notNil ])
			ifTrue: [ parent baseUrl ]
			ifFalse: [ WAUrl new ].
	serverPath isNil
		ifFalse: [ url addToPath: serverPath ]
		ifTrue: [ url addToPath: self name ].
		
	self serverProtocol isNil ifFalse: [ url scheme: self serverProtocol ].
	self serverHostname isNil ifFalse: [ url hostname: self serverHostname ].
	self serverPort isNil ifFalse: [ url port: self serverPort ].

	^ url! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'lr 2/10/2008 18:33'!
configuration
	"Answer a default user configuration for the receiver."

	^ configuration ifNil: [ configuration := self defaultConfiguration ]! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/24/2008 23:24'!
defaultConfiguration
	^ WAUserConfiguration new
		addParent: WARequestHandlingConfiguration instance;
		yourself! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:21'!
description
	^ self class description! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 8/5/2008 10:23'!
documentClass
	^ self preferenceAt: #documentClass! !

!WAEntryPoint methodsFor: 'response generation' stamp: 'jf 9/14/2008 01:22'!
forbiddenResponseFor: aRequestContext
	^ self responseFactory forbiddenForContext: aRequestContext! !

!WAEntryPoint methodsFor: 'testing' stamp: 'mb 5/26/2006 08:50'!
isEntryPoint
	^ true! !

!WAEntryPoint methodsFor: 'testing' stamp: 'lr 2/10/2008 16:20'!
isRoot
	^ false! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:50'!
name
	^ name! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 7/16/2008 09:37'!
newDocumentOn: aStream
	^ self documentClass new
		stream: aStream;
		yourself.! !

!WAEntryPoint methodsFor: 'response generation' stamp: 'jf 9/13/2008 12:36'!
notFoundResponseFor: aRequestContext
	^ self responseFactory notFoundForContext: aRequestContext! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 9/13/2008 14:40'!
path
	"Answer the path elements of the receiving request handler."
	
	^ self parent isNil
		ifTrue: [ OrderedCollection with: self name ]
		ifFalse: [ self parent path addLast: self name; yourself ]! !

!WAEntryPoint methodsFor: 'copying' stamp: 'lr 2/10/2008 17:40'!
postCopy
	super postCopy.
	configuration := configuration copy! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'lr 2/10/2008 17:46'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'lr 2/10/2008 17:46'!
preferenceAt: aSymbol put: anObject
	^ self configuration valueAt: aSymbol put: anObject! !

!WAEntryPoint methodsFor: 'printing' stamp: 'lr 2/12/2007 21:48'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' named: '; print: self name! !

!WAEntryPoint methodsFor: 'response generation' stamp: 'jf 9/22/2008 21:05'!
redirectResponseFor: aRequestContext to: aUrlOrString
	^ self responseFactory redirectTo: aUrlOrString forContext: aRequestContext! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 9/13/2008 12:35'!
responseFactory
	^ self preferenceAt: #responseFactory! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverHostname
	^ self preferenceAt: #serverHostname! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverPath
	^ self preferenceAt: #serverPath! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverPort
	^ self preferenceAt: #serverPort! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverProtocol
	^ self preferenceAt: #serverProtocol! !

!WAEntryPoint methodsFor: 'initialization' stamp: 'lr 2/10/2008 17:44'!
setName: aString
	name := aString! !

!WAEntryPoint methodsFor: 'authentication' stamp: 'lr 9/12/2008 19:50'!
verifyPassword: password forUser: username
"This method is called by WAAuthMain to verify the username provided
in the HTTP request. The default implementation compares them against
the configuration values provided by WAAuthConfiguration. WAAuthMain
can also be used by itself if you implement this method in your
own Application subclass to do something different."

	| loginPref hashPref |
	loginPref := self preferenceAt: #login.
	hashPref := self preferenceAt: #passwordHash.
	
	loginPref ifNil: [self error: 'Login not defined. The default authentication method requires a WAAuthConfiguration'].
	hashPref ifNil: [self error: 'Password not defined. The default authentication method requires a WAAuthConfiguration'].
	
	(username isNil or: [password isNil or: [username isEmpty or: [password isEmpty]]])
		ifTrue: [^ false].
	
	^ (loginPref = username) and:
				[hashPref = (SeasidePlatformSupport secureHashFor: password)]! !

WAEntryPoint subclass: #WAFileHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler commentStamp: 'rew 10/19/2007 10:48' prior: 0!
Seaside serves static files using WALibrary subclasses. WAFileHandler handles all requests for WALibrary files (or methods) for all applications on the Seaside server. WAFileHandler is registered with the default WADispatcher automatically.!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/10/2008 19:59'!
default
	^ default! !

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/10/2008 15:28'!
description
	^ 'File Library'! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:15'!
libraries
	^ self libraryRootClasses gather: [ :each | each allSubclasses ]! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:16'!
librariesDo: aOneArgumentBlock
	self libraryRootClasses do: [ :each | each allSubclassesDo: aOneArgumentBlock ]! !

!WAFileHandler methodsFor: 'accessing' stamp: 'pmm 7/20/2007 06:52'!
libraryAt: aSymbol ifAbsent: aBlock
	self librariesDo: [ :each |
		(each handlesFolder: aSymbol)
			ifTrue: [ ^ each ] ].
	^ aBlock value! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 7/20/2007 06:54'!
libraryRootClasses
	^ WALibrary subclasses! !

!WAFileHandler methodsFor: 'private' stamp: 'jf 9/14/2008 01:24'!
responseAt: aPath ifForbidden: forbiddenBlock ifAbsent: absentBlock
	| libraryClass |
	aPath isEmpty ifTrue: [ ^ forbiddenBlock value ].
	libraryClass := self
		libraryAt: aPath first asSymbol
		ifAbsent: [ ^ absentBlock value ].
	^aPath size > 1
		ifTrue: [
			libraryClass
				documentAt: aPath second
				ifAbsent: absentBlock ]
		ifFalse: forbiddenBlock! !

!WAFileHandler methodsFor: 'processing' stamp: 'jf 9/22/2008 21:07'!
responseForContext: aRequestContext 
	| path baseUrl requestUrl |
	baseUrl := WAUrl new
		addAllToPath: self path;
		yourself.
	requestUrl := aRequestContext request url.
	path := baseUrl relativeTo: requestUrl.
	^ self 
		responseAt: path
		ifForbidden: [ self forbiddenResponseFor: aRequestContext ]
		ifAbsent: [ self notFoundResponseFor: aRequestContext ]! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARegistry commentStamp: 'jf 8/5/2008 11:13' prior: 0!
WARegistry maintains a set of handlers indexed by a key, (by default _s). WARegistry checks incoming request URLs for a key and looks for a matching active request handler. If one exists, the request is sent to the proper handler. If not the request is either a new request (in which case #handleDefaultRequest: is called) or a request to a now-inactive handler (in which case #handleExpiredRequest: is called). These two methods allow subclasses to properly handle these requests.

Subclasses must implement the following messages:
	handleDefaultRequest:
		Handle a request without a session key, ie a new request.

Instance Variables:
	handlersByKey	<Dictionary of <session key(string),WASession>>	provides easy access to the session for a session key
	keysByHandler	<Dictionary of <WASession, session key(string)>>	provides easy access to the session key of a session
	mutex	<Semaphore>	Used to insure keysByHandler & handlersByKey are updated atomically
!

!WARegistry class methodsFor: 'initialization' stamp: 'lr 3/19/2007 15:34'!
clearAllHandlers
	self allSubInstancesDo: [ :each | each clearHandlers ]! !

!WARegistry methodsFor: 'public' stamp: 'jf 9/18/2008 20:58'!
clearHandlers
	cache clear! !

!WARegistry methodsFor: 'public' stamp: 'lr 2/12/2007 20:40'!
ensureKeyForHandler: anObject
	^ (self keyOrNilForHandler: anObject) ifNil: [ self registerRequestHandler: anObject ]! !

!WARegistry methodsFor: 'private' stamp: 'lr 9/13/2008 11:27'!
handleDefaultRequest: aRequestContext
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'jf 9/13/2008 14:14'!
handleExpiredRequest: aRequestContext
	^ self responseFactory expiredKeyForContext: aRequestContext! !

!WARegistry methodsFor: 'private' stamp: 'jf 9/18/2008 22:02'!
handleKeyRequest: aRequestContext
	| key handler keyString |
	"Under some circumstances, HTTP fields are collections of values"
	key :=	[keyString := aRequestContext request at: self handlerField.
			(keyString isString not and: [ keyString isSequenceable ])
				ifTrue: [keyString := keyString first].
			WAExternalID fromString: keyString] on: Error do: [:e | nil].
	handler := cache at: key.
	^ handler notNil
		ifTrue: [handler handleRequest: aRequestContext]
		ifFalse: [self handleExpiredRequest: aRequestContext]! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: 'jf 9/18/2008 21:00'!
initialize
	super initialize.
	cache := WACache new! !

!WARegistry methodsFor: 'private' stamp: 'pmm 2/13/2007 07:21'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_ ]! !

!WARegistry methodsFor: 'private' stamp: 'jf 9/18/2008 20:57'!
keyOrNilForHandler: anObject
	^ cache keyFor: anObject! !

!WARegistry methodsFor: 'private' stamp: 'jf 9/18/2008 20:57'!
registerRequestHandler: anObject
	^ cache store: anObject! !

!WARegistry methodsFor: 'public' stamp: 'lr 9/13/2008 11:22'!
responseForContext: aRequestContext 
	^ (aRequestContext request fields includesKey: self handlerField) 
		ifTrue: [ self handleKeyRequest: aRequestContext ]
		ifFalse: [ self handleDefaultRequest: aRequestContext ]! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
unregistered
	super unregistered.
	self clearHandlers! !

!WARegistry methodsFor: 'public' stamp: 'pmm 8/31/2008 14:46'!
urlForRequestHandler: anObject addHandlerField: aBoolean 
	| key url |
	key := self ensureKeyForHandler: anObject.
	url := self baseUrl.
	aBoolean ifTrue: [
		url 
			addParameter: self handlerField
			value: key seasideString ].
	^ url! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WANotFoundHandler commentStamp: 'pmm 10/20/2007 23:18' prior: 0!
WANotFoundHandler handles requests whose urls don't map to a Seaside application.

!

!WANotFoundHandler methodsFor: 'actions' stamp: 'jf 9/13/2008 13:00'!
responseForContext: aRequestContext 
	^ WAResponseFactory notFoundForContext: aRequestContext! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 9/13/2008 14:59'!
addFilter: aFilter
	"Add aFilter to the receiver. Answer the filter added."

	| previous current |
	previous := nil.
	current := self filter.
	[ current = self ] whileFalse: [
		previous := current.
		current := current next ].
	aFilter setNext: current.
	previous isNil
		ifTrue: [ self setFilter: aFilter ]
		ifFalse: [ previous setNext: aFilter ].
	^ aFilter! !

!WARequestHandler methodsFor: 'copying' stamp: 'lr 9/13/2008 15:21'!
copyTo: aRequestHandler
	^ aRequestHandler! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:33'!
description
	"Answer a descriptive text of the receiver."

	^ String new! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 8/31/2008 13:36'!
filter
	^ filter contents! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 8/31/2008 15:40'!
filters
	"Answer an ordered colleciton of all filters active in the receiver."
	
	| current result |
	current := self filter.
	result := OrderedCollection new.
	[ current = self ] whileFalse: [
		result add: current.
		current := current next ].
	^ result! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 9/13/2008 14:12'!
handleRequest: aRequestContext
	"Handle a request with the context aRequestContext and answer a response. Do not override this method, instead subclass #responseForContext: to allow filters process the request first."

	^ aRequestContext push: self while: [ self filter responseForContext: aRequestContext ]! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 8/31/2008 14:07'!
handler
	^ self! !

!WARequestHandler methodsFor: 'initialization' stamp: 'lr 8/31/2008 13:26'!
initialize
	super initialize.
	filter := WAValueHolder with: self! !

!WARequestHandler methodsFor: 'testing' stamp: 'avi 7/23/2004 15:11'!
isActive
	^ true! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isApplication
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isDispatcher
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:48'!
isEntryPoint
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'lr 8/31/2008 15:11'!
isFiltered
	^ self filter ~= self! !

!WARequestHandler methodsFor: 'testing' stamp: 'jf 7/25/2008 20:33'!
isSession
	^ false! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
parent
	"Answer the parent request handler of the receiver."

	^ parent! !

!WARequestHandler methodsFor: 'copying' stamp: 'lr 9/13/2008 15:23'!
postCopy
	super postCopy.
	filter := filter copy.
	self setParent: nil; setFilter: (self filter copyTo: self)! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 9/13/2008 14:55'!
removeFilter: aFilter
	"Remove aFilter from the receiver. Answer the removed filter or nil."

	| previous current |
	previous := nil.
	current := self filter.
	[ current = self ] whileFalse: [
		current = aFilter ifTrue: [
			previous isNil
				ifTrue: [ self setFilter: current next ]
				ifFalse: [ previous setNext: current next ].
			^ aFilter setNext: nil ].
		previous := current.
		current := current next ].
	^ nil! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 9/13/2008 11:07'!
responseForContext: aRequestContext 
	"Answer a response for aRequestContext."

	self subclassResponsibility! !

!WARequestHandler methodsFor: 'initialization' stamp: 'lr 9/13/2008 15:21'!
setFilter: aFilter
	filter contents: aFilter! !

!WARequestHandler methodsFor: 'initialization' stamp: 'lr 2/12/2007 20:50'!
setParent: aRequestHandler
	parent := aRequestHandler! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 2/12/2007 21:12'!
unregistered! !

!WARequestHandler methodsFor: 'processing' stamp: 'jf 9/14/2008 01:38'!
withEscapeHandler: aBlock
	^ aBlock
		on: WAReturnResponse 
		do: [ :err | err response ]! !

WAObject subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAResponse commentStamp: 'pmm 6/1/2008 00:11' prior: 0!
I am a server independent http response object. I am used in conjunction with WASession >> returnResponse:

Instance Variables
	contentType:	<WAMimeType>
	headers:		<Dictionary<String, Object>>
	cookies:			<Set<WACookie>>
	status:			<Integer>
	stream:			<Stream>
				
contentType
	- the content type of the body
				
headers
	- the HTTP headers to be sent to the client
				
cookies
	- the cookies to be sent to the client. Either a Set of cookies or an empty array.
	
status
	- the HTTP status code, the default is 200 (OK)
	
stream
	- a read stream on the contents of the body to be sent to the client !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
basicAuthWithRealm: aString
	^ self new basicAuthenticationRealm: aString! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/21/2008 17:26'!
defaultHttpVersion
	^'HTTP/1.1'! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/1/2007 06:34'!
defaultValueForCharSet
	^'utf-8'! !

!WAResponse class methodsFor: 'defaults' stamp: 'jf 9/22/2008 12:55'!
defaultValueForContentType
	^ self defaultValueForMimeType seasideMimeType
		charset: self defaultValueForCharSet;
		yourself! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/1/2007 06:34'!
defaultValueForMimeType
	^'text/html'! !

!WAResponse class methodsFor: 'instance creation' stamp: 'jf 9/22/2008 12:17'!
document: anObject mimeType: mimeType
	| document |
	document := anObject asMIMEDocumentType: mimeType.
	^ self new
		contentType: (mimeType ifNil: [ document contentType seasideMimeType ]);
		nextPutAll: document content;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/22/2004 21:02'!
document: anObject mimeType: mimeString fileName: fileString
	^ (self document: anObject mimeType: mimeString)
		attachmentWithFileName: fileString;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'jf 9/22/2008 13:00'!
forbidden: aUrlOrString
	| response |
	response := self new.
	response
		forbidden;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Access forbidden to ', aUrlOrString seasideString.
	^ response! !

!WAResponse class methodsFor: 'instance creation' stamp: 'jf 9/22/2008 13:00'!
internalError: anError
	^ self new
		internalError;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Internal Error: ', anError description.! !

!WAResponse class methodsFor: 'instance creation' stamp: 'jf 9/22/2008 13:00'!
notFound: aUrlOrString
	| response |
	response := self new.
	response
		notFound;
		contentType: WAMimeType textPlain;
		nextPutAll: aUrlOrString seasideString, ' not found'.
	^ response! !

!WAResponse class methodsFor: 'responding' stamp: 'jf 9/22/2008 21:04'!
redirectTo: aUrlOrString
	^ self new redirectTo: aUrlOrString! !

!WAResponse class methodsFor: 'instance creation' stamp: 'jf 9/22/2008 13:00'!
refreshAfter: aNumber location: aUrlOrString message: aString
	^ self new
		refreshAfter: aNumber location: aUrlOrString;
		contentType: WAMimeType textPlain;
		nextPutAll: aString seasideString;
		yourself! !

!WAResponse class methodsFor: 'deprecated' stamp: 'jf 9/22/2008 13:00'!
refreshWithMessage: aString location: aUrlOrString delay: aNumber
	| response |
	self deprecatedApi: 'Use WAResponse>>redirectAfter:location:message:'.
	response := self new refreshAfter: aNumber location: aUrlOrString.
	
	response
		contentType: WAMimeType textPlain;
		nextPutAll: aString, Character cr;
		nextPutAll: 'You are being redirected to ', aUrlOrString seasideString.

	^ response! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
addCookie: aCookie
	cookies ifNil: [ cookies := Set new ].
	cookies add: aCookie! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 4/19/2006 09:30'!
attachmentWithFileName: aString
	self headerAt: 'Content-Disposition' put: 'attachment; filename="', aString, '"'! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:25'!
basicAuthenticationRealm: aString
	self headerAt: 'WWW-Authenticate' put: ('Basic realm="',aString,'"').
	self authenticationFailed! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 11/21/2007 15:22'!
beXML
	contentType sub = 'html' ifTrue: [
		contentType sub: 'xml' ]! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 9/11/2008 07:28'!
cacheControl: aString
	"The Cache-Control general-header field is used to specify directives that MUST be obeyed by all caching mechanisms along the request/response chain. The directives specify behavior intended to prevent caches from adversely interfering with the request or response. These directives typically override the default caching algorithms. Cache directives are unidirectional in that the presence of a directive in a request does not imply that the same directive is to be given in the response. "
	self headerAt: 'Cache-Control' put: aString! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'pmm 9/11/2008 07:39'!
cacheFor: aDuration
	"tells the user agent to cache the response for the given duration"
	self removeHeaderAt: 'Pragma'. "Proxies"
	self removeHeaderAt: 'Expires'. "HTTP 1.0"
	self cacheControl: 'max-age=', aDuration asSeconds printString. "HTTP 1.1"
	self expiresAt: (DateAndTime now + aDuration).
! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'pmm 9/11/2008 07:10'!
cacheForever
	self removeHeaderAt: 'Cache-Control'.
	self removeHeaderAt: 'Pragma'.
	self expiresAt: self cacheForeverExpiresDate ! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'pmm 9/11/2008 07:09'!
cacheForeverExpiresDate
	"answers the expiry date that should be used if the response should be cached forever
	
	Note that this is a bit dirty according to HTTP 1.1:
	To mark a response as 'never expires,' an origin server sends an Expires date approximately one year from the time the response is sent. HTTP/1.1 servers SHOULD NOT send Expires dates more than one year in the future. "
	^DateAndTime
		year: 2095 month: 1 day: 1
		hour: 13 minute: 0 second: 0
		offset: Duration zero! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAResponse methodsFor: 'accessing' stamp: 'jf 9/22/2008 12:18'!
contentType: mimeTypeOrString
	contentType := mimeTypeOrString seasideMimeType! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents
	^ stream reset! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents: aStream
	stream := aStream! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
cookieAt: key put: value
	^ self addCookie: (WACookie key: key value: value)! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
cookies
	^ cookies ifNil: [ #() ]! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 4/9/2008 10:17'!
deleteCookie: aCookie 
	"Delete the cookie in the browser.
	
	The spec sez:
	If a CGI script wishes to delete a cookie, it can do so by returning a cookie with the same name, and an expires time which is in the past. The path and name must match exactly in order for the expiring cookie to replace the valid cookie. This requirement makes it difficult for anyone but the originator of a cookie to delete a cookie.
	
	The trouble is:
	Browsers that follow the Netscape spec don't send path information"
	| cookie |
	cookie := (WACookie 
		key: aCookie key
		value: '')
		path: aCookie path;
		version: aCookie version;
		yourself.
	aCookie version isNil ifTrue: 
		[ "old Netscape cookie with no path information, assumbe baseUrl and cross fingers"
		cookie path: WACurrentRequestContext value handler baseUrl pathString ].
	cookie expireInPast.
	self addCookie: cookie! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'pmm 7/12/2008 07:51'!
deleteCookieAt: aKeyString
	"Delete the cookie in the browser. This method is quite unrelyable. Consider using #deleteCookie:"
	self deleteCookie: (WARequestCookie key: aKeyString value: '')! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'pmm 9/11/2008 07:28'!
doNotCache
	self expiresAt: self doNotCacheExpiresDate. "HTTP 1.0"
	self cacheControl: 'no-cache, must-revalidate'. "HTTP 1.1"
	self headerAt: 'Pragma' put: 'no-cache' "Proxy Servers"! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'pmm 9/11/2008 07:09'!
doNotCacheExpiresDate
	"answers the expiry date that should be used if the response should not be forever"
	^DateAndTime
		year: 1980 month: 6 day: 11
		hour: 11 minute: 0 second: 0
		offset: Duration zero! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 9/11/2008 07:05'!
expiresAt: aDateAndTime
	"The Expires entity-header field gives the date/time after which the response is considered stale. A stale cache entry may not normally be returned by a cache (either a proxy cache or a user agent cache) unless it is first validated with the origin server (or with an intermediate cache that has a fresh copy of the entity).
	
	To mark a response as 'never expires,' an origin server sends an Expires date approximately one year from the time the response is sent. HTTP/1.1 servers SHOULD NOT send Expires dates more than one year in the future. "
	self headerAt: 'Expires' putDate: aDateAndTime! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'akuhn 8/30/2008 15:05'!
expiresDate
	^(self headerAt: 'Expires') value! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/9/2005 13:14'!
forbidden
	self status: 403! !

!WAResponse methodsFor: 'status' stamp: 'pmm 12/31/2007 11:49'!
gone
	self status: 410! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:14'!
headerAt: aString
	^self headers
		detect: [ :each | each key = aString ]
		ifNone: [ nil ]! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:15'!
headerAt: aKeyString put: aValueObject
	self headers add: aKeyString -> aValueObject! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 9/11/2008 07:03'!
headerAt: aKeyString putDate: aDateAndTime
	"sets a header who's value is a DateAndTime
	correctly formats the date"
	self
		headerAt: aKeyString
		put: (WAPrinter httpDate print: aDateAndTime)! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:24'!
headers
	headers isNil ifTrue: [
		headers := OrderedCollection new ].
	^headers! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 5/1/2007 09:42'!
httpVersion
	^self class defaultHttpVersion! !

!WAResponse methodsFor: 'initialize-release' stamp: 'jf 9/11/2008 19:49'!
initialize
	| application |
	super initialize.
	stream := SeasidePlatformSupport readWriteStream.
	status := 200.
	application := [ self application ]
					on: WARequestContextNotFound
					do: [ nil ].
	contentType := application isNil 
		ifFalse: [ application contentType ]
		ifTrue: [ self class defaultValueForContentType ]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 15:57'!
internalError
	self status: 500! !

!WAResponse methodsFor: 'streaming' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAResponse methodsFor: 'streaming' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
notFound
	self status: 404! !

!WAResponse methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
printOn: aStream 
	super printOn: aStream.
	aStream
		space;
		nextPutAll: self status seasideString! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:26'!
redirect
	self status: 302! !

!WAResponse methodsFor: 'convenience' stamp: 'jf 9/22/2008 21:03'!
redirectTo: aUrlOrString
	self headerAt: 'Location' put: aUrlOrString seasideString.
	self redirect! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'jf 9/13/2008 23:26'!
refreshAfter: aNumber location: aUrlOrString
	self headerAt: 'Refresh' put: aNumber seasideString, '; ', aUrlOrString seasideString! !

!WAResponse methodsFor: 'initialize-release' stamp: 'tbn 7/20/2006 17:31'!
release
	stream := cookies := headers := nil.
	super release! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:21'!
removeHeaderAt: aString
	headers isNil ifTrue: [
		^self ].	

	headers := self headers reject: [ :each |
		each key = aString ]! !

!WAResponse methodsFor: 'streaming' stamp: 'lr 5/23/2007 11:13'!
space
	stream space! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 5/23/2007 12:04'!
status: aNumber
	status := aNumber! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 2/6/2004 15:28'!
stream
	^ stream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
stream: aStream
	stream := aStream! !

!WAResponse methodsFor: 'writing' stamp: 'pmm 8/31/2008 14:48'!
writeHeadersOn: aStream 
	self headers associationsDo: [ :association | 
		aStream
			nextPutAll: association key;
			nextPutAll: ': ';
			nextPutAll: association value seasideString.
		aStream crlf ].
	cookies ifNotNil:  [
		cookies do: [ :each | 
			aStream nextPutAll: 'Set-Cookie: '.
			each writeOn: aStream.
			aStream crlf ] ].
	aStream
		nextPutAll: 'Content-Type: ';
		nextPutAll: self contentType seasideString.
	aStream crlf! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:52'!
writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	aStream nextPutAll: stream contents! !

!WAResponse methodsFor: 'writing' stamp: 'lr 8/30/2008 16:22'!
writeStatusOn: aStream 
	aStream
		nextPutAll: self httpVersion;
		space;
		nextPutAll: self status seasideString;
		crlf! !

WAResponse subclass: #WAStreamResponse
	instanceVariableNames: 'writtenHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAStreamResponse commentStamp: 'pmm 6/1/2008 00:13' prior: 0!
A WAStreamResponse is a WAResponse that directly writes to the response stream. This can be used to implement HTTP response streaming.

Instance Variables
	writtenHeaders:		<Boolean>

writtenHeaders
	- whether the HTTP headers where alread written on the stream
!

!WAStreamResponse class methodsFor: 'instance-creation' stamp: 'lr 5/23/2007 10:35'!
on: aStream
	^ self new stream: aStream! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'pmm 4/19/2006 17:32'!
hasWrittenHeaders
	^ writtenHeaders! !

!WAStreamResponse methodsFor: 'initialization' stamp: 'mb 9/22/2006 12:26'!
initialize
	super initialize.
	writtenHeaders := false! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:31'!
stream
	self writeOn: stream.
	^ stream! !

!WAStreamResponse methodsFor: 'private' stamp: 'lr 3/25/2008 22:13'!
writeOn: aStream 
	self hasWrittenHeaders ifTrue: [ ^ self ].
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	writtenHeaders := true! !

WAObject subclass: #WAResponseFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAResponseFactory class methodsFor: 'as yet unclassified' stamp: 'jf 9/22/2008 23:03'!
expiredKeyForContext: aRequestContext 
	| url |
	aRequestContext request isXmlHttpRequest 
		ifTrue: [ ^ WAResponse new forbidden ].
	url := WAUrl new.
	url addAllToPath: aRequestContext request url path.
	url takeServerParametersFromRequest: aRequestContext request.
	aRequestContext request isGet ifTrue: [ 
		aRequestContext request fields keysAndValuesDo: [ :key :value | 
			(url isSeasideField: key) ifFalse: [ 
				url 
					addParameter: key
					value: value ] ] ].
	^ WAResponse redirectTo: url seasideString! !

!WAResponseFactory class methodsFor: 'as yet unclassified' stamp: 'jf 9/13/2008 15:39'!
forbiddenForContext: aRequestContext
	^ WAResponse forbidden: aRequestContext request url! !

!WAResponseFactory class methodsFor: 'as yet unclassified' stamp: 'jf 9/13/2008 12:24'!
notFoundForContext: aRequestContext 
	^ WAResponse notFound: aRequestContext request url! !

!WAResponseFactory class methodsFor: 'as yet unclassified' stamp: 'jf 9/22/2008 12:59'!
pageExpiredForContext: aRequestContext
	^WAResponse new
		contentType: WAMimeType textPlain;
		nextPutAll: 'This page has expired, please use the back-button to navigate to the last valid page.';
		doNotCache;
		yourself! !

!WAResponseFactory class methodsFor: 'as yet unclassified' stamp: 'jf 9/22/2008 21:05'!
redirectTo: aUrlOrString forContext: aRequestContext 
	^ WAResponse redirectTo: aUrlOrString! !

!WAResponseFactory class methodsFor: 'as yet unclassified' stamp: 'jf 9/14/2008 00:33'!
refreshAfter: aNumber location: aUrlOrString message: aString
	^ WAResponse new
		refreshAfter: aNumber
			location: aUrlOrString
			message: aString, Character cr, 'You are being redirected to ', aUrlOrString seasideString;
		yourself.! !

WAObject subclass: #WARoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WARoot commentStamp: 'pmm 6/1/2008 00:23' prior: 0!
A WARoot is the root node of a document.
!

WARoot subclass: #WAHtmlRoot
	instanceVariableNames: 'context docType htmlAttrs headAttrs bodyAttrs headElements title styles scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlRoot commentStamp: 'pmm 6/2/2008 19:31' prior: 0!
A WAHtmlRoot is the root element of an HTML Document (<html>).

Instance Variables
	bodyAttrs:		<WAHtmlAttributes>
	context:			<WARenderingContext>
	docType:		<String>
	headAttrs:		<WAHtmlAttributes>
	headElements:	<OrderedCollection<WAHtmlElement>>
	htmlAttrs:		<WAHtmlAttributes>
	scripts:			<Set<String>>
	styles:			<Set<String>>
	title:			<String>

bodyAttrs
	- the attributes of the <body> element

context
	- the context used to render the contents of the <body> element

docType
	- the document type

headAttrs
	- the attributes of the <head> element

headElements
	- the elements inside the <head> section

htmlAttrs
	- the attriebutes of the <html> element

scripts
	- contains the strings returned by WAPresenter >> #script

styles
	- contains the strings returned by WAPresenter >> #style

title
	- the title of the HTML document, the contents of the <title> element
!

!WAHtmlRoot class methodsFor: 'instance-creation' stamp: 'lr 3/27/2007 12:08'!
context: aRenderingContext
	^ self new setContext: aRenderingContext! !

!WAHtmlRoot methodsFor: 'private' stamp: 'lr 4/20/2007 16:24'!
absoluteUrlForResource: aString
	^ context absoluteUrlForResource: aString! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
add: aHtmlElement
	"Add a HTML head element to the receiver."

	^ headElements add: aHtmlElement! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 6/2/2008 09:34'!
addScript: aString
	"Include the script aString into the receiver."

	scripts ifNil: [ scripts := Set new ].
	scripts add: aString! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 6/2/2008 09:34'!
addStyle: aString
	"Include the style-sheet aString into the receiver."

	styles ifNil: [ styles := Set new ].
	styles add: aString! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
base
	^ self add: (WABaseElement root: self)! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:44'!
beXhtml10Strict
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml10Transitional
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml11
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
bodyAttributes
	^ bodyAttrs ifNil: [ bodyAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:18'!
close: aDocument
	self writeFootOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 3/27/2007 13:14'!
contentBase: urlString
	self base url: urlString! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:29'!
context
	^ context! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 3/27/2007 12:11'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 10/28/2007 14:42'!
docType: aString
	"Set the document-type of the receiver. The table at http://www.w3.org/TR/2002/NOTE-xhtml-media-types-20020430/ summarizes the recommendation to content authors for labeling their XHTML documents:

Media type				XHTML 1.0 (HTML compatible)	XHTML 1.0 (other)	XHTML Basic / 1.1	XHTML+MathML
text/html				MAY							SHOULD NOT			SHOULD NOT			SHOULD NOT
application/xhtml+xml	SHOULD							SHOULD				SHOULD				SHOULD
application/xml			MAY							MAY				MAY				MAY
text/xml					MAY							MAY				MAY				MAY"

	docType := aString! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
headAttributes
	^ headAttrs ifNil: [ headAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
htmlAttributes
	^ htmlAttrs ifNil: [ htmlAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
if
	^ WAConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'initialization' stamp: 'jf 8/30/2008 16:31'!
initialize
	super initialize.
	headElements := OrderedCollection new.
	title := docType := String new! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 4/6/2007 14:18'!
javascript
	^ self script beJavascript; yourself! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
link
	^ self add: (WALinkElement root: self)! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
meta
	^ self add: (WAMetaElement root: self)! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:17'!
open: aDocument
	self writeHeadOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 4/9/2007 10:43'!
redirectTo: aLocationString delay: aNumber
	self meta redirectAfter: aNumber to: aLocationString! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 11/25/2007 21:57'!
revealedIf
	^ WARevealedConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
script
	^ self add: (WAScriptElement root: self)! !

!WAHtmlRoot methodsFor: 'initialization' stamp: 'lr 3/27/2007 12:08'!
setContext: aRenderingContext
	context := aRenderingContext! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 3/24/2008 18:06'!
stylesheet
	^ self link beStylesheet; beCss; yourself! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title: aString
	title := aString! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 4/9/2007 10:40'!
writeElementsOn: aDocument
	aDocument openTag: 'title'; nextPutAll: title; closeTag: 'title'.
	headElements do: [ :each | aDocument print: each ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:20'!
writeFootOn: aDocument
	aDocument closeTag: 'body'.
	aDocument closeTag: 'html'! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 5/16/2007 21:53'!
writeHeadOn: aDocument
	aDocument nextPutAll: docType.
	aDocument openTag: 'html' attributes: htmlAttrs.
	aDocument openTag: 'head' attributes: headAttrs.
	self writeElementsOn: aDocument.
	self writeStylesOn: aDocument.
	self writeScriptsOn: aDocument.
	aDocument closeTag: 'head'.
	aDocument openTag: 'body' attributes: bodyAttrs! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeScriptsOn: aDocument
	scripts ifNil: [ ^ self ].
	scripts do: [ :each |
		aDocument print: ((WAScriptElement root: self)
			beJavascript;
			document: each;
			yourself) ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeStylesOn: aDocument
	styles ifNil: [ ^ self ].
	styles do: [ :each |
		aDocument print: ((WALinkElement root: self)
			beStylesheet; beCss;
			document: each;
			yourself) ]! !

!WARoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:30'!
close: aDocument! !

!WARoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:30'!
open: aDocument! !

WAObject subclass: #WAServer
	instanceVariableNames: 'codec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAServer commentStamp: 'pmm 6/1/2008 00:14' prior: 0!
A WAServer is the abstract base class for all servers. Actual servers do not have to subclass it but have to support the protocol:
 - #codec
 - #usesSmalltalkEncoding

Instance Variables
	codec:		<WACodec>

codec
	- the codec used for response conversion from characters to bytes!

!WAServer methodsFor: 'accessing' stamp: 'pmm 5/11/2008 08:11'!
codec
	^ codec! !

!WAServer methodsFor: 'accessing' stamp: 'pmm 5/11/2008 08:12'!
codec: aCodec
	codec := aCodec! !

!WAServer methodsFor: 'testing' stamp: 'pmm 5/11/2008 08:12'!
usesSmalltalkEncoding
	"see WARequestContext >> #usesSmalltalkEncoding"
	^self codec usesSmalltalkEncoding! !

WAObject subclass: #WAUrl
	instanceVariableNames: 'scheme username password hostname port path parameters fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAUrl commentStamp: 'lr 3/26/2008 14:20' prior: 0!
I represent all portions of an URL as described by the RFC 1738. I include scheme, username, password, hostname, port, path, parameters, and fragment.

Instance Variables
	scheme:			<String> or nil
	username:		<String> or nil
	password:		<String> or nil
	hostname:		<String> or nil
	port:			<Integer> or nil
	path:			<OrderedCollection> or nil
	parameters:		<Dictionary>
	fragment:		<String> or nil!

!WAUrl class methodsFor: 'parsing' stamp: 'lr 3/26/2008 20:55'!
absolute: aString
	"Parse aString as an absolute URL."

	^ self basicNew initializeFromString: aString! !

!WAUrl class methodsFor: 'parsing' stamp: 'jf 9/22/2008 12:46'!
absolute: aString relative: aRelativeString
	"Take absolute URL aString and combine it with a relative path aRelativeString."

	^ (self absolute: aString)
		parsePath: aRelativeString;
		yourself! !

!WAUrl methodsFor: 'comparing' stamp: 'lr 2/12/2008 11:09'!
= anUrl
	^ self class = anUrl class and: [ self printString = anUrl printString ]! !

!WAUrl methodsFor: 'adding' stamp: 'pmm 4/21/2008 20:42'!
addAllToPath: aCollectionOfStrings
	"convenice method to add a collection of strings to the path"
	aCollectionOfStrings do: [ :each |
		self addToPath: each ]! !

!WAUrl methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
addParameter: aString
	self addParameter: aString value: nil! !

!WAUrl methodsFor: 'adding' stamp: 'lr 3/27/2008 08:30'!
addParameter: keyString value: valueString
	keyString isEmpty 
		ifFalse: [ self parameters at: keyString put: valueString ]! !

!WAUrl methodsFor: 'adding' stamp: 'pmm 4/21/2008 20:43'!
addToPath: aString
	"Adds the argument as a path element. If the argument contains $/ it is split into multiple elements"
	self path addAll: (aString findTokens: '/')! !

!WAUrl methodsFor: 'private' stamp: 'lr 3/26/2008 15:14'!
decode: aString
	| input output char |
	input := aString readStream.
	output := WriteStream on: (String new: aString size).
	[ input atEnd ] whileFalse: [
		char := input next.
		output nextPut: (char = $+
			ifTrue: [ Character space ]
			ifFalse: [
				char = $%
					ifTrue: [
						Character value: input next asUppercase digitValue * 16
							+ input next asUppercase digitValue ]
					ifFalse: [ char ] ]) ].
	^ output contents! !

!WAUrl methodsFor: 'converting' stamp: 'jf 9/22/2008 23:35'!
decodedWith: aCodec
	| url |
	url := self copy.
	
	"scheme, host, port cannot include escaped characters (%FF) and so should not
	be able to include characters that need decoding"
	
	self username isNil ifFalse: [
		url username: (aCodec decodeUrl: self username) ].
	self password isNil ifFalse: [
		url password: (aCodec decodeUrl: self password) ].
	self path isEmpty ifFalse: [
		url path: (self path collect: [ :each | aCodec decodeUrl: each ]) ].
	url parameters: nil.
	self parameters keysAndValuesDo: [ :key :value |
		url
			addParameter: (aCodec decodeUrl: key)
			value: (value isNil ifTrue: [ nil ] ifFalse: [ aCodec decodeUrl: value ]) ].
	self fragment isNil ifFalse: [
		url fragment: (aCodec decodeUrl: self fragment) ].
	
	^ url! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 8/20/2007 21:13'!
encodeFragmentOn: aDocument
	fragment ifNil: [ ^ self ].
	aDocument nextPut: $#.
	aDocument urlEncoder nextPutAll: fragment! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 9/4/2007 15:32'!
encodeOn: aDocument
	self encodeOn: aDocument usingHtmlEntities: true! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeOn: aDocument usingHtmlEntities: aBoolean
	self encodeServerOn: aDocument.
	self encodePathOn: aDocument.
	self
		encodeParametersOn: aDocument
		usingHtmlEntities: aBoolean.
	self encodeFragmentOn: aDocument! !

!WAUrl methodsFor: 'encoding' stamp: 'pmm 8/31/2008 14:51'!
encodeParametersOn: aDocument usingHtmlEntities: aBoolean 
	| first |
	first := true.
	parameters ifNil: [ ^ self ].
	parameters keysAndValuesDo: [ :key :value | 
		aDocument nextPutAll: (first 
				ifTrue: [ first := false. '?' ]
				ifFalse: [ aBoolean 
					ifTrue: [ '&amp;' ]
					ifFalse: [ '&' ] ]).
		aDocument urlEncoder nextPutAll: key.
		value ifNotNil: [
			aDocument nextPut: $=.
			aDocument urlEncoder nextPutAll: value seasideString ] ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 3/26/2008 21:05'!
encodePathOn: aDocument
	aDocument nextPut: $/.
	path ifNil: [ ^ self ].
	path
		do: [ :each | aDocument urlEncoder nextPutAll: each ]
		separatedBy: [ aDocument nextPut: $/ ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeServerOn: aDocument
	hostname ifNil: [ ^ self ].
	aDocument nextPutAll: scheme; nextPutAll: '://'.
	username notNil ifTrue: [
		aDocument urlEncoder nextPutAll: username.
		password notNil ifTrue: [
			aDocument nextPut: $:.
			aDocument urlEncoder nextPutAll: password ].
		aDocument nextPut: $@ ].
	aDocument urlEncoder nextPutAll: hostname.
	port notNil ifTrue: [
		((scheme = 'http' and: [ port = 80 ])
			or: [ scheme = 'https' and: [ port = 443 ] ])
			ifFalse: [ aDocument nextPut: $:; print: port ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
fragment
	"Answer the fragment part of the URL."

	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:18'!
fragment: aString
	fragment := aString! !

!WAUrl methodsFor: 'comparing' stamp: 'lr 2/12/2008 11:09'!
hash
	^ self hostname hash bitXor: self path hash! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
hostname
	"Answer the host part of the URL."

	^ hostname! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 3/29/2008 10:14'!
hostname: aString
	hostname := aString isNil
		ifFalse: [ aString asLowercase ]! !

!WAUrl methodsFor: 'initialization' stamp: 'jf 8/30/2008 16:34'!
initialize
	super initialize.
	scheme := 'http'! !

!WAUrl methodsFor: 'initialization' stamp: 'lr 3/28/2008 23:00'!
initializeFromString: aString
	| string index |
	self initialize.
	string := aString.
	index := string indexOf: $#.
	index > 0 ifTrue: [
		self parseFragment: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOf: $?.
	index > 0 ifTrue: [
		self parseParameters: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOfSubCollection: '://'.
	index > 0 ifTrue: [ 
		self scheme: (string copyFrom: 1 to: index - 1).
		string := string copyFrom: index + 3 to: string size.
		index := string indexOf: $/.
		index > 0
			ifFalse: [ 
				self parseHost: string.
				string := '' ]
			ifTrue: [
				self parseHost: (string copyFrom: 1 to: index - 1).
				string := string copyFrom: index + 1 to: string size ] ].
	self parsePath: string! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 22:49'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_
		or: [ aString allSatisfy: [ :each | each isDigit ] ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 3/26/2008 21:04'!
parameters
	"Answer a dictionary with the query parameters."

	^ parameters ifNil: [ parameters := WASmallDictionary new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:19'!
parameters: aDictionary
	parameters := aDictionary! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/28/2008 23:02'!
parseFragment: aString
	aString isEmpty ifTrue: [ ^ self ].
	self fragment: (self decode: aString)! !

!WAUrl methodsFor: 'parsing' stamp: 'pmm 5/31/2008 13:48'!
parseHost: aString
	| string temp index |
	aString isEmpty 
		ifTrue: [ ^ self ].
	string := aString.
	index := string indexOf: $@.
	index > 1 ifTrue: [
		temp := string copyFrom: 1 to: index - 1.
		string := string copyFrom: index + 1 to: string size.
		index := temp indexOf: $:.
		index > 0 
			ifFalse: [ self username: (self decode: temp) ]
			ifTrue: [
				self username: (self decode: (temp copyFrom: 1 to: index - 1)).
				self password: (self decode: (temp copyFrom: index + 1 to: temp size)) ] ].
	index := string lastIndexOf: $:.
	index > 0 ifTrue: [
		temp := string copyFrom: index + 1 to: string size.
		string := string copyFrom: 1 to: index - 1.
		self port: ((temp notEmpty and: [ temp allSatisfy: [ :each | each isDigit ] ])
			ifTrue: [ temp asInteger ]) ].
	self hostname: (self decode: string)! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/27/2008 08:30'!
parseParameters: aString
	| input string index |
	input := aString readStream.
	[ input atEnd ] whileFalse: [
		string := input upTo: $&.
		index := string indexOf: $=.
		index > 0
			ifFalse: [ self addParameter: (self decode: string) ]
			ifTrue: [
				self
					addParameter: (self decode: (string copyFrom: 1 to: index - 1))
					value: (self decode: (string copyFrom: index + 1 to: string size)) ] ]! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/26/2008 22:13'!
parsePath: aString
	| input part |
	input := aString readStream.
	input peek = $/ 
		ifTrue: [ path := nil ].
	[ input atEnd ] whileFalse: [
		part := input upTo: $/.
		part isEmpty ifFalse: [
			part = '..'
				ifTrue: [ self path isEmpty ifFalse: [ self path removeLast ] ]
				ifFalse: [ part = '.' ifFalse: [ self path addLast: (self decode: part) ] ] ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
password
	"Answer the password part of the URL."

	^ password! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:21'!
password: aString
	password := aString! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path
	"Answer the path part of the URL."

	^ path ifNil: [ path := OrderedCollection new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path: aCollection
	"Set the path part of the URL to aCollection."

	path := aCollection! !

!WAUrl methodsFor: 'converting' stamp: 'lr 3/26/2008 21:27'!
pathString
	"Answer the path converted to a string."

	| document |
	^ String streamContents: [ :stream | 
		document := WAHtmlStreamDocument new.
		document stream: stream.
		self encodePathOn: document ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port
	"Answer the port number part of the URL."

	^ port! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port: aNumber
	port := aNumber! !

!WAUrl methodsFor: 'copying' stamp: 'lr 3/28/2008 23:07'!
postCopy
	super postCopy.
	path := path copy.
	parameters := parameters copy! !

!WAUrl methodsFor: 'printing' stamp: 'lr 9/4/2007 15:37'!
printOn: aStream
	| document |
	document := WAHtmlStreamDocument new.
	document stream: aStream.
	self encodeOn: document usingHtmlEntities: false! !

!WAUrl methodsFor: 'converting' stamp: 'lr 3/27/2008 07:47'!
relativeTo: anUrl
	"Answer a path element collection relative from the receiver to anUrl."
	
	| currentPath argumentPath resultingPath |
	currentPath := self path copy.
	argumentPath := anUrl path copy.
	[ currentPath notEmpty and: [ argumentPath notEmpty and: [ currentPath first = argumentPath first ] ] ] whileTrue: [
		currentPath removeFirst.
		argumentPath removeFirst ].
	resultingPath := OrderedCollection new.
	currentPath size 
		timesRepeat: [ resultingPath add: '..' ].
	resultingPath addAll: argumentPath.
	^ resultingPath! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 20:54'!
removeParameters
	parameters := nil! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
scheme
	"Answer the URL's scheme."

	^ scheme! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/30/2008 16:22'!
scheme: aString 
	"Set the URL scheme as a string. As some Seaside 2.7 and older uses Symbols here, we transform it to a string. This will be removed in future versions."
	scheme := aString seasideString asLowercase! !

!WAUrl methodsFor: 'converting' stamp: 'jf 9/22/2008 12:28'!
seasideUrl
	^ self! !

!WAUrl methodsFor: 'private' stamp: 'pmm 4/26/2008 12:11'!
takeServerParametersFromRequest: aRequest
	"Takes the hostname on URL from the given request unless already set.."
	
	self hostname isNil
		ifFalse: [ ^ self ].
	self parseHost: (aRequest 
		headerAt: 'host'
		ifAbsent: [ ^ self ])! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
username
	"Answer the username part of the URL."

	^ username! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:38'!
username: aString
	username := aString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:45'!
withParameter: aString
	^ self copy
		addParameter: aString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:57'!
withoutParameters
	^self copy
		removeParameters;
		yourself! !

WAObject subclass: #WAValueHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAValueHolder commentStamp: 'pmm 9/5/2007 19:01' prior: 0!
I wrap a single object. I am like value holder except that I am portable and don't include the Model cruft in Squeak.!

!WAValueHolder class methodsFor: 'instance-creation' stamp: 'lr 9/5/2007 11:40'!
with: anObject
	^ self new contents: anObject! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents
	^ contents! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents: anObject
	contents := anObject! !

!WAValueHolder methodsFor: 'printing' stamp: 'lr 4/20/2007 20:46'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' contents: '; print: self contents! !

!Integer methodsFor: '*Seaside-Core' stamp: 'lr 8/30/2008 16:22'!
printStringAsCents
	^ '$' , (self // 100) seasideString , '.' , (self \\ 100) asTwoCharacterString! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words := WriteStream on: String new.
	read := ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord := WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x := read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord := currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord := capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents! !

!String methodsFor: '*Seaside-Core' stamp: 'jf 9/22/2008 13:06'!
asMIMEDocument
	^self asMIMEDocumentType: WAMimeType textPlain! !

!String methodsFor: '*Seaside-Core' stamp: 'jf 9/22/2008 12:24'!
asMIMEDocumentType: mimeType
	^WACollectionMimeDocument
		contentType: mimeType seasideMimeType
		content: self! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 3/26/2007 20:22'!
encodeOn: aDocument
	aDocument htmlEncoder nextPutAll: self! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 6/13/2006 16:06'!
renderOn: aRenderer
	aRenderer text: self! !

!String methodsFor: '*Seaside-Core' stamp: 'jf 9/18/2008 15:38'!
seasideExternalID
	^ WAExternalID fromString: self! !

!String methodsFor: '*Seaside-Core' stamp: 'jf 9/22/2008 12:14'!
seasideMimeType
	^ WAMimeType fromString: self! !

!String methodsFor: '*Seaside-Core' stamp: 'jf 9/22/2008 12:29'!
seasideUrl
	^ WAUrl absolute: self! !

!Collection methodsFor: '*Seaside-Core' stamp: 'lr 5/9/2007 08:47'!
inspectorFields
	| i |
	i := 0.
	^ self asArray collect: [ :each | i := i + 1. i -> each ]! !

!Collection methodsFor: '*Seaside-Core' stamp: 'lr 3/8/2006 08:43'!
renderOn: html
	self do: [ :each | each renderOn: html ]! !

WAProcessVariable subclass: #WACurrentRequestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

!WACurrentRequestContext commentStamp: 'pmm 6/1/2008 00:38' prior: 0!
A WACurrentRequestContext is a thread local variable that points to the current WARequestContext.
!

WASmallDictionary subclass: #WAHtmlAttributes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlAttributes commentStamp: 'lr 7/12/2007 13:30' prior: 0!
I represent the attributes of a XHTML tag. Compared to my superclass I ignore requests to add a nil-values. I also don't throw an exception when accessing a key that doesn't exist, but instead return nil.!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addClass: aString
	"Add an additional CSS class aString to the receiver."

	self at: 'class' append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'pmm 3/9/2008 11:21'!
addMedia: aString
	"Add an additional intended destination medium aString to the receiver."

	self at: 'media' append: aString separator: ', '! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addStyle: aString
	"Add an additional CSS style definition aString to the receiver."

	self at: 'style' append: aString separator: ';'! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'lr 7/9/2007 07:46'!
at: aKey append: aValue
	"Append aValue to the attribute aKey. If already present, concatenate it with a space. Ignore the request if aValue is nil."

	^ self at: aKey append: aValue separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'pmm 8/31/2008 14:34'!
at: aKey append: aValue separator: aString 
	"Append aValue to the attribute aKey. If already present, concatenate it with aString. Ignore the request if aValue is nil."
	aValue ifNil: [ ^ self at: aKey ].
	^ self at: aKey put: (String streamContents: [ :stream | 
		self at: aKey ifPresent: [ :value | 
			stream nextPutAll: value seasideString.
			stream nextPutAll: aString ].
		stream nextPutAll: aValue seasideString ])! !

!WAHtmlAttributes methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeOn: aDocument
	"Encode the receivers attribute onto aDocument. Note that this implementation reqires those two checks for true and false exactly the way they are here, to reliable encode boolean attributes in an XHTML compliant way."

	self keysAndValuesDo: [ :key :value |
		value == false ifFalse: [
			aDocument nextPut: $ ; nextPutAll: key; nextPutAll: '="'.
			value == true
				ifTrue: [ aDocument nextPutAll: key ]
				ifFalse: [ aDocument print: value ].
			aDocument nextPut: $" ] ]! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:21'!
errorKeyNotFound
	^ nil! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:23'!
privateAt: aKey put: aValue
	aValue ifNil: [ ^ nil ].
	^ super privateAt: aKey put: aValue! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'jf 9/22/2008 13:22'!
asMIMEDocument
	^self asMIMEDocumentType: WAMimeType applicationOctetStream! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'jf 9/22/2008 12:25'!
asMIMEDocumentType: mimeType
	^WACollectionMimeDocument
		contentType: mimeType seasideMimeType
		content: self! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'mb 9/22/2006 12:17'!
renderOn: aRenderer
	aRenderer text: self! !

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex GeneratorSpace'
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAExternalID commentStamp: 'pmm 4/22/2007 12:55' prior: 0!
I am a session or conticuation key.!

!WAExternalID class methodsFor: 'private' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID class methodsFor: 'instance-creation' stamp: 'pmm 2/23/2008 18:25'!
fromString: aString
	| id |
	id := self new: aString size.
	aString keysAndValuesDo: [ :index :each |
		id at: index put: each asInteger ].
	^ id! !

!WAExternalID class methodsFor: 'initialization' stamp: 'lr 1/17/2008 11:43'!
initialize
	self startUp.
	SeasidePlatformSupport addToStartUpList: self.
	GeneratorSpace := ($a to: $z) , ($A to: $Z) , ($0 to: $9) , (Array with: $_ with: $-)
		collect: [ :each | each asInteger ].
	GeneratorMutex := SeasidePlatformSupport semaphoreClass forMutualExclusion! !

!WAExternalID class methodsFor: 'instance-creation' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'instance-creation' stamp: 'pmm 11/2/2005 23:19'!
new: aNumber
	^ (self basicNew: aNumber) initialize! !

!WAExternalID class methodsFor: 'initialization' stamp: 'lr 1/17/2008 11:42'!
startUp
	Generator := SeasidePlatformSupport randomClass new! !

!WAExternalID methodsFor: 'private' stamp: 'lr 1/17/2008 11:35'!
initialize
	GeneratorMutex critical: [
		1 to: self size do: [ :index |
			self at: index put: (GeneratorSpace atRandom: Generator) ] ]! !

!WAExternalID methodsFor: 'private' stamp: 'lr 1/17/2008 11:36'!
printOn: aStream
	self do: [ :each | aStream nextPut: (Character value: each) ]! !

!WAExternalID methodsFor: 'as yet unclassified' stamp: 'jf 9/18/2008 15:38'!
seasideExternalID
	^ self! !

!UndefinedObject methodsFor: '*Seaside-Core' stamp: 'lr 3/27/2007 10:40'!
encodeOn: aDocument! !

!UndefinedObject methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
renderOn: html! !

!Dictionary methodsFor: '*Seaside-Core' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

!Dictionary methodsFor: '*Seaside-Core' stamp: 'lr 2/16/2007 15:11'!
valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value |
		result at: key put: (aBlock value: value) ].
	^ result! !

!Exception methodsFor: '*Seaside-Core' stamp: 'pmm 6/1/2008 00:55'!
possibleCauses
	"Used by WAWalkback to render a list of what might have caused the receiver to be signaled.
	answers a collection of strings"
	^ #()! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 8/30/2008 16:22'!
encodeOn: aDocument 
	aDocument print: self seasideString! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 3/24/2008 17:47'!
inspectorFields
	| members |
	members := Array new writeStream.
	self class allInstVarNames keysAndValuesDo: [ :index :each | members nextPut: each -> (self instVarAt: index) ].
	self class isVariable ifTrue: 
		[ 1 
			to: self size
			do: [ :index | members nextPut: index -> (self at: index) ] ].
	^ members contents! !

!Object methodsFor: '*Seaside-Core' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*Seaside-Core' stamp: 'pmm 4/7/2007 17:14'!
renderOn: aRenderer
	"Override this method to customize how objects (not components) are rendered when passed as an argument to #render:. The default is the return value of #displayString.
	Just remember that you can not use #callback:, #on:of:, or #call:"

	aRenderer text: self! !

!MessageNotUnderstood methodsFor: '*Seaside-Core' stamp: 'pmm 7/7/2007 18:25'!
possibleCauses
	| causes |
	self receiver isNil ifFalse: [
		^ #('you sent a message this type of object doesn''t understand' )].
	causes := #(
		'the receiver of the message is nil'
		'a class extension hasn''t been loaded correctly'
		'you sent the wrong message' ) asOrderedCollection.
	self message selector = #contents ifTrue: [
		causes addFirst: 'you forgot to send "super initialize" in a initialize method of a component or task' ].
	^causes! !

Error subclass: #WAAttributeNotFound
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeNotFound methodsFor: 'accessing' stamp: 'jf 8/26/2008 14:17'!
key
	^ key! !

!WAAttributeNotFound methodsFor: 'accessing' stamp: 'jf 8/26/2008 14:17'!
key: aSymbol
	key := aSymbol! !

!WAAttributeNotFound methodsFor: 'accessing' stamp: 'jf 9/23/2008 01:22'!
possibleCauses
	^ #(
		'you need to clear your configuration caches to see new attributes (try "WAAdmin clearConfigurationCaches" in a workspace)'
		'you have not included a necessary ancestor in a configuration'
	)! !

Error subclass: #WAComponentsNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAComponentsNotFoundError commentStamp: 'pmm 6/1/2008 00:53' prior: 0!
A WAComponentsNotFoundError is an exception that is raised when for a callback now owning component could be found. See #possibleCauses for examples when this can happen.!

!WAComponentsNotFoundError methodsFor: 'accessing' stamp: 'pmm 7/11/2007 22:19'!
possibleCauses
	^#(
		'you do not implement #children correctly'
		'you do not backtrack #children correctly'
		'you do not implement #states correctly'
	)! !

Error subclass: #WARequestContextNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WARequestContextNotFound commentStamp: 'jf 9/11/2008 19:42' prior: 0!
This exception is raised when trying to obtain the current request context when none is available.!

!WARequestContextNotFound methodsFor: 'as yet unclassified' stamp: 'jf 9/23/2008 14:16'!
isResumable
	^ true! !
WASharedConfiguration initialize!
WAHtmlEncoder initialize!
WAUrlEncoder initialize!
WAFileLibrary initialize!
WALocale initialize!
WAExternalID initialize!
